<?php

if ((key_exists('DEVELOPMENT', $_SESSION) && $_SESSION['DEVELOPMENT']) || (key_exists('debug', $_REQUEST) && $_REQUEST['debug'] == 1)) {
	@error_reporting(E_ALL | E_NOTICE | E_STRICT);
	@ini_set('display_errors', '1');
	$CONFIG['LOG'] = 1;
}

// default timezone weil manche Server sonst Probleme mit date haben
@date_default_timezone_set('Europe/Berlin');
// encoding des Servers auf UTF-8 setzen
@ini_set('default_charset', 'utf-8');

if (!isset($docroot)) {
	$docroot = realpath(dirname(__FILE__)) . "/";
	$docroot = str_ireplace(array('\\', '_system/'), array('/', ''), $docroot);
	if (!defined('DOCROOT')) {
		define("DOCROOT", $docroot);
	}
}

$dirname = realpath(dirname(__FILE__));
$dirname = str_ireplace(array('\\', '_system/'), array('/', ''), $docroot);
if ($CONFIG['STRATO'] == true) {
	$_SERVER['DOCUMENT_ROOT'] = $dirname;
}

// Anmeldefenster groesse
$join_config_file_name = 'join.config.php';
$join_directory = $docroot . $CONFIG['POPUPDIR'];
if (substr($join_directory, strlen($join_directory) - 1, strlen($join_directory)) !== '/') {
	$join_directory .= '/';
}
$join_config_file = $join_directory . $join_config_file_name;
if (!is_file($join_config_file)) {
	$error = $join_config_file . ' ist nicht vorhanden, bitte aktuelles Join von 777partner.com laden';
	echo($error);
	die();
}
include_once ($join_config_file);

$CONFIG['SITEMAPDIR'] = $docroot . $CONFIG['SITEMAPDIR'];
// Wohin soll die Sitemap gespeichert werden..

// echo($docroot."<br/>");
// echo($dirname."<br/>");
// echo($CONFIG['SITEMAPDIR']."<br/>");
// die();

// Array PICLINKZ um die groessen erweitern
if (isset($PICLINKZ)) {
	$pic_height = array('{height}');
	$PICLINKZ = array_merge($pic_height, $PICLINKZ);
	$pic_width = array('{width}');
	$PICLINKZ = array_merge($pic_width, $PICLINKZ);
	// echo('PICLINKZ: '.$PICLINKZ[0]);
	// die();
}

// sicher stellen das die CONFIG-Einstellung THUMBSDIR auch besteht
if (!key_exists('THUMBSDIR', $CONFIG)) {
	$CONFIG = array_merge(array('THUMBSDIR' => 'thumbs/'), $CONFIG);
}

if (!function_exists('file_get_contents')) {
	function file_get_contents($filename) {
		if (strpos($filename, '//')) {
			$fcontents = get_content($filename);
		} else {
			$fhandle = fopen($filename, "r");
			$fcontents = fread($fhandle, filesize($filename));
			fclose($fhandle);
		}
		return $fcontents;
	}

}

if (!function_exists('mb_substr')) {
	function mb_substr($string, $start, $stop = null) {

		if (is_null($stop)) {
			$stop = strlen($string);
		}
		$string = substr($string, $start, $stop);
		return $string;
	}

}

if (!function_exists('str_ireplace')) {
	function str_ireplace($needle, $str, $haystack) {
		$needle = preg_quote($needle, '/');
		return preg_replace("/$needle/i", $str, $haystack);
	}

}

if (!function_exists('file_put_contents')) {
	function file_put_contents($filename, $data) {
		$f = @fopen($filename, 'w');
		if (!$f) {
			return false;
		} else {
			$bytes = fwrite($f, $data);
			fclose($f);
			return $bytes;
		}
	}

}

if (!function_exists('echo_debugtext')) {
	function echo_debugtext($text, $color) {
		echo('<div style="color:' . $color . ';">');
		myecho($text);
		echo('</div>');
		flush();
	}

}

if (!function_exists("stripos")) {
	function stripos($str, $needle, $offset = 0) {
		return strpos(strtolower($str), strtolower($needle), $offset);
	}

}

if (!function_exists("strripos")) {
	function strripos($haystack, $needle, $offset = 0) {
		if (!is_string($needle))
			$needle = chr(intval($needle));
		if ($offset < 0) {
			$temp_cut = strrev(substr($haystack, 0, abs($offset)));
		} else {
			$temp_cut = strrev(substr($haystack, 0, max((strlen($haystack) - $offset), 0)));
		}
		if (($found = stripos($temp_cut, strrev($needle))) === FALSE)
			return FALSE;
		$pos = (strlen($haystack) - ($found + $offset + strlen($needle)));
		return $pos;
	}

}

function createCamTargetUrl64($camid) {
	global $CONFIG;
	$bResult = "index.php?id={$CONFIG['WMID']}&showchat={$camid}";
	if (isset($CONFIG['LIVECAMLAYOUT']) && $CONFIG['LIVECAMLAYOUT'] != 'redrose') {
		$bResult .= '&l=' . $CONFIG['LIVECAMLAYOUT'];
	}
	if (isset($CONFIG['HEADER']) && $CONFIG['HEADER'] == 'off') {
		$bResult .= '&h=' . $CONFIG['HEADER'];
	}
	if (isset($CONFIG['LANGUAGE']) && $CONFIG['LANGUAGE'] != 'de') {
		$bResult .= '&setup_language=' . $CONFIG['LANGUAGE'];
	}
	$bResult = urlencode(base64_encode($bResult));
	return $bResult;
}

/**
 * Ueberprueft ob eine XML-Datei mit Showdaten vorhanden ist
 * und noch aktell ist nicht aelter als 30 Minuten
 * wenn nicht vorhanden, wird versucht diese zu erstellen
 * wenn die Show nicht disabled ist
 * @return boolean
 * @param integer $camid
 */
if (!function_exists('is_valid_XML_file')) {
	function is_valid_XML_file($camid) {
		global $CONFIG, $mm;
		$bResult = false;
		if (is_numeric($camid) || $camid > 0) {
			// remotefile
			$remotefile = 'https://mm.7-7-7-partner.com/showdetail.php?show=' . $camid . '&lang=' . $CONFIG['LANGUAGE'] . '&size=l';
			$xml_file = $CONFIG['TEMPDIR'] . $camid . '.xml';
			if (!file_exists($xml_file) || time() - filemtime($xml_file) > 1200) {
				$content = get_content($remotefile);
				if (strpos($content, '<camid>' . $camid . '</camid>') > 0 && strpos($content, '<disabled>1</disabled>') === false && strpos($content, '/0_320x240') === false) {
					$fp = fopen($xml_file, 'w');
					fputs($fp, $content);
					fclose($fp);
					// aus der inactivecams.xml loeschen
					// myecho('wird wenn eingetragen aus inactive geloescht: '.$camid);
					removeInactiveCams($camid);
				} else {
					// in die inactivecams.xml eintragen
					addInactiveCam($camid);
				}
				if (is_file($xml_file)) {
					// Zeitraum in dem die Daten aufbewahrt werden sollen
					if (isset($CONFIG['DAYLIVINGCAM'])) {
						$day_living_cam = $CONFIG['DAYLIVINGCAM'] * 24 * 60 * 60;
						$filemtime = filemtime($xml_file);
						$file_date_diff = time() - filemtime($xml_file);
						// myecho('FileAge (days): ' .$file_date_diff / 60/60/24);
						if (file_exists($xml_file) && time() - $filemtime > $day_living_cam) {
							// myecho($day_liveing_cam);
							// myecho(time() - filemtime($xml_datei));
							// myecho($camid. ' darf nicht mehr angezeigt werden');
							$bResult = false;
						} else {
							// myecho($camid. ' ist aktuell');
							$bResult = true;
						}
					} else {
						// die Bilder pruefen und evtl. speichern
						fillupcollection::savePreviewPics(file_get_contents($xml_file));
						$bResult = true;
					}

				}
			} else {
				$bResult = true;
			}
		}
		return $bResult;
	}

}

if (!function_exists('addInactiveCam')) {
	function addInactiveCam($id) {
		global $CONFIG;
		$is_listed = false;
		$xml_file_inactive_cams = $CONFIG['TEMPDIR'] . 'inactivecams.xml';
		$dom = new DOMDocument('1.0', 'utf-8');
		$dom->preserveWhiteSpace = false;
		$dom->formatOutput = true;
		if (!is_file($xml_file_inactive_cams)) {
			$root = $dom->createElement('inactives');
			$dom->appendChild($root);
			$is_listed = false;
		} else {
			// laden und nachsehen ob diese Cam schon in der XML-Datei steht
			$dom->load($xml_file_inactive_cams);

			$xpath = new DOMXPath($dom);
			$query = '/inactives/inactive[.="' . $id . '"]';
			$entries = $xpath->query($query);
			foreach ($entries as $entry) {
				if ((int)$entry->nodeValue == $id) {
					$is_listed = true;
					break;
				}
			}
			if (!$is_listed) {
				// root bestimmen
				$query = '/inactives';
				$entries = $xpath->query($query);
				foreach ($entries as $entry) {
					if ((string)$entry->nodeName == 'inactives') {
						$root = $entry;
						break;
					}
				}
			}
		}
		if (!$is_listed) {
			$parent = $dom->createElement('inactive');
			$data = $dom->createTextNode($id);
			$parent->appendChild($data);
			$root->appendChild($parent);
			$dom->save($xml_file_inactive_cams);
			savelog("added to inactivecams.xml: " . $id);
		}
		if (isset($dom)) {
			unset($dom);
		}
		return $is_listed;
	}

}

if (!function_exists('removeInactiveCams')) {
	function removeInactiveCams($active_camids) {
		global $CONFIG;
		$is_listed = false;
		$xml_file_inactive_cams = $CONFIG['TEMPDIR'] . 'inactivecams.xml';
		$dom = new DOMDocument('1.0', 'utf-8');
		$dom->preserveWhiteSpace = false;
		$dom->formatOutput = true;
		if (is_file($xml_file_inactive_cams)) {
			// laden und nachsehen ob diese Cam in der XML-Datei steht
			$dom->load($xml_file_inactive_cams);
			$xpath = new DOMXPath($dom);
			$query = '/inactives';
			$entries = $xpath->query($query);
			foreach ($entries as $entry) {
				if ((string)$entry->nodeName == 'inactives') {
					$text = 'root gefunden';
					// myecho($text);
					$root = $entry;
					break;
				}
			}
			if (!is_array($active_camids)) {
				$active_camids = array($active_camids);
			}
			foreach ($active_camids as $active_camid) {
				$query = '/inactives/inactive[.="' . $active_camid . '"]';
				// myecho($query);
				$entries = $xpath->query($query);
				foreach ($entries as $entry) {
					if ((int)$entry->nodeValue == (int)$active_camid) {
						$child = $entry;
						$root->removeChild($child);
						savelog("to remove from inactivecams.xml: " . $active_camid);
						$is_listed = true;
					}
				}
			}
			if ($is_listed) {
				$dom->save($xml_file_inactive_cams);
				$text = "removed from inactivecams.xml: " . $active_camid;
				// myecho($text);
				savelog($text);
			} else {
				savelog("no camids removed from inactivecams.xml");
			}
		}
		if (isset($dom)) {
			unset($dom);
		}
		return $is_listed;
	}

}

if (!function_exists('setIDToArray')) {
	function setIDToArray($array) {
		$bResult = $array;
		if (isset($array['ID']) && !is_array($array['ID'])) {
			// myecho($array);
			$bResult = array();
			foreach ($array as $key => $value) {
				$bResult[$key] = array($value);
			}
		}
		return $array;
	}

}

/**
 * anhand der IDs aus help werden die IDs der TOPsender generiert und
 * als textdatei im Verzeichnis /temp/ abgespeichert
 * damit nicht immer die gleichen Sender als Topsender erscheinen werden
 * die Camids gemischt
 * @return array
 * @param array $ids
 */
if (!function_exists('getTopsenderIds')) {
	function getTopsenderIds() {
		global $CONFIG;
		$renew = false;
		$bResult = null;
		$time_diff = 60 * 60 * 24;
		// taeglich einmal neu machen
		// Kategorie aus denen die Topsender bestehen soll
		$topsender_category = $CONFIG['STARTKATEGORIE'];
		if (isset($CONFIG["TOPSENDER_KATEGORIE"]) && $CONFIG["TOPSENDER_KATEGORIE"] != $topsender_category) {
			$topsender_category = $CONFIG["TOPSENDER_KATEGORIE"];
		}
		$topsender_txtfile = $CONFIG['TEMPDIR'] . 'topsender.txt';
		// loeschen zum test
		if (is_file($topsender_txtfile)) {
			// unlink($topsender_txtfile);
		}
		// timestamp.txt enthaelt die letzte Uhrzeit als INTEGER der letzten Aenderung
		// der text.datei, weil nicht bekannt ist ob auf allen Servern filemtime erlaubt ist
		$timestamp_txtfile = $CONFIG['TEMPDIR'] . 'timestamp_topsender.txt';
		if (!file_exists($topsender_txtfile)) {
			$renew = true;
		}
		if (!file_exists($timestamp_txtfile)) {
			$renew = true;
		}
		if (!$renew) {
			// das Datum aus der timestamp holen
			$data = '';
			$fp = fopen($timestamp_txtfile, 'r');
			while (!feof($fp)) {
				$data .= trim(fgets($fp));
			}
			fclose($fp);
			$timestamp = trim(str_replace(array("\t", "\r", "\n"), '', $data));
			if (!is_numeric($timestamp) || $timestamp < 0) {
				echo('timestamp ist nicht integer');
				die();
			}
			if ($timestamp - (time() - $time_diff) < 0) {
				$renew = true;
			}
			if (!$renew) {
				// jetzt die IDs auslesen
				$datas = file($topsender_txtfile);
				$bResult = array();
				foreach ($datas as $data) {
					$data = trim(str_replace(array("\n", " "), array("", ""), $data));
					if (empty($data) || !is_numeric($data)) {
						break;
					}
					$bResult[] = $data;
				}
				if (count($bResult) != $CONFIG["TOPSENDER_ANZAHL"]) {
					$renew = true;
				}
			}
		}
		if ($renew) {
			$ids = array();
			$with_offline_ids = false;
			// Ids von mm.777partner.com holen
			$remotefile = 'https://mm.7-7-7-partner.com/_xml/onlineshows.' . $CONFIG['LANGUAGE'] . '.xml';
			if (isset($CONFIG['TOPSENDER_KATEGORIE']) && is_numeric($CONFIG['TOPSENDER_KATEGORIE']) && ($CONFIG['TOPSENDER_KATEGORIE'] > 0 && $CONFIG['TOPSENDER_KATEGORIE'] <= 18 && $CONFIG['TOPSENDER_KATEGORIE'] != 12)) {
				$topsender_category = $CONFIG['TOPSENDER_KATEGORIE'];
				$remotefile = 'https://mm.7-7-7-partner.com/_xml/category' . $topsender_category . 'online.' . $CONFIG['LANGUAGE'] . '.xml';
			}
			// myecho($remotefile);
			$content = get_content($remotefile);
			$data = xml2array($content);
			$data = setIDToArray($data);
			if (isset($data['ID']) && is_array($data['ID'])) {
				foreach ($data['ID'] as $id) {
					$ids[] = $id;
				}
			}
			// myecho($ids);
			if (count($ids) < $CONFIG["TOPSENDER_ANZAHL"]) {
				// dann nuessen wir leider noch offlineshows aus dieser Kategorie hinzu nehmen
				$remotefile = str_replace('online', 'offline', $remotefile);
				// myecho($remotefile);
				$content = get_content($remotefile);
				$data = xml2array($content);
				$data = setIDToArray($data);
				// myecho($data); die();
				if (isset($data['ID']) && is_array($data['ID'])) {
					// nachsehen ob der Sender innerhalb der letzten 45 Tage online war
					// wenn ja darf die ID aufgenommen werden
					$before_14_days = time() - (60 * 60 * 24 * 45);
					for ($i = 0, $n = count($data['LASTONLINE']); $i < $n; $i++) {
						$id = $data['ID'][$i];
						$lastonline = strtotime($data['LASTONLINE'][$i]);
						if ($before_14_days - $lastonline < 0 || (isset($CONFIG['STARTKATEGORIE']) && is_numeric($CONFIG['STARTKATEGORIE']) && $CONFIG['STARTKATEGORIE'] > 0)) {
							// Senderid darf aufgenommen werden
							$ids[] = $id;
						}
					}
				}
				$with_offline_ids = true;
			}
			$start = 0;
			$stop = $CONFIG["TOPSENDER_ANZAHL"];
			if (count($ids) < $stop) {
				$liste_s_file = $CONFIG['TEMPDIR'] . 'liste-' . $CONFIG['TOPSENDER_KATEGORIE'] . '.s';
				// myecho($liste_s_file);
				if (is_file($liste_s_file)) {
					$data = unserialize(implode("", file($liste_s_file))); ;
				}
				if (count($data) > 0) {
					$enabled_ids = array();
					foreach ($data as $id) {
						$enabled_ids[] = $id;
					}
					srand((float) microtime() * 1000000);
					shuffle($enabled_ids);
					$i = count($ids);
					foreach ($enabled_ids as $id) {
						if (is_valid_XML_file($id)) {
							if (!in_array($id, $ids)) {
								$i++;
								$ids[] = $id;
							}
							if ($i == $CONFIG["TOPSENDER_ANZAHL"]) {
								break;
							}
						}
					}
				}
				if (isset($enabledshows)) {
					unset($enabledshows);
				}
			}
			// jetzt die IDs mischen
			$data = '';
			srand((float) microtime() * 1000000);
			shuffle($ids);
			$bResult = array();
			foreach ($ids as $id) {
				$id = trim($id);
				if ($id > 0) {
					$data .= $id . "\n";
					$bResult[] = $id;
					$start++;
					if ($start == $stop) {
						break;
					}
				}
			}
			// myecho($bResult);
			// Dateien nur schreiben, wenn keine offline IDs dabei sind
			if (!$with_offline_ids || (isset($CONFIG['STARTKATEGORIE']) && is_numeric($CONFIG['STARTKATEGORIE']) && $CONFIG['STARTKATEGORIE'] > 0)) {
				// die gemischten IDs speichern
				$fp = fopen($topsender_txtfile, 'w');
				fputs($fp, $data);
				fclose($fp);
				// timestamp neu schreiben
				$time_stamp = time();
				$fp = fopen($timestamp_txtfile, 'w');
				fputs($fp, $time_stamp);
				fclose($fp);
			}

		}
		if (!is_array($bResult)) {
			echo('Es wurden keine IDs gefunden');
			die();
		}
		return $bResult;
	}

}

if (!function_exists('myecho')) {
	/**
	 * mit dieser Funktion lassen sich Objekte und einfacher Text ausgeben
	 * einfache Textausgabe wobei \n zu <br/>
	 * und dem Text ein <br/> zugesetzt wird
	 *
	 * @param string $text
	 */
	function myecho($text) {
		if (is_array($text) || is_object($text)) {
			__var_export($text);
		} else {
			$text = htmlentities($text) . '<br/>';
			echo('<div style="background-color:#FFF;color:#000;border:1px solid #F00">');
			echo nl2br($text);
			echo('</div>');
			flush();
		}
	}

}
if (!function_exists('echo_in_javascript')) {
	/**
	 * einfache Textausgabe in Javascript
	 * @param string $text
	 */
	function echo_in_javascript($text, $htmlentities = true, $break = false) {
		if (is_array($text) || is_object($text)) {
			foreach ($text as $key => $value) {
				echo_in_javascript($value, $htmlentities);
			}
		} else {
			if ($htmlentities) {
				htmlentities($text);
			}
			$text = str_ireplace(array("\n", "\r", "\t"), '', $text);
			$text = str_ireplace('"', '\"', $text);
			if ($break) {
				$text = 'document.write("' . $text . '<br/>");' . "\n";
			} else {
				$text = 'document.write("' . $text . '");' . "\n";
			}
			echo($text);
		}
	}

}
if (!function_exists('echo_export')) {
	/**
	 * gibt ein Array in einer Textarea aus
	 * @param array $array
	 */
	function echo_export($array) {
		echo('<textarea rows="20" cols="100">' . var_export($array, true) . '</textarea>');
	}

}
if (!function_exists('echolink')) {
	/**
	 * gibt eine url als link auf dem Desktop aus
	 * @param string $text
	 */
	function echolink($text) {
		echo('<a href="' . $text . '" target="_blank" title="' . $text . '">' . $text . '</a><br/>' . "\n");
		flush();
	}

}
if (!function_exists('__var_export')) {
	/**
	 * Gibt ein array/object in einer textarea aus
	 * @param string $txt
	 */
	function __var_export($object) {
		echo '<p><textarea cols="90" rows="10" wrap="off">' . var_export($object, true) . '</textarea></p>';
		flush();
	}

}
/**
 * entfernt doppelte Zeilenumbrueche
 * @param string $string
 * @return string
 */
if (!function_exists('replace_double_line_breaks')) {
	function replace_double_line_breaks($string) {
		$string = str_ireplace("\n\n", "\n", $string);
		if (strpos($string, "\n\n") !== false) {
			$string = replace_double_line_breaks($string);
		}
		return $string;
	}

}

function senderkey($nr) {
	// myecho($nr);
	global $SENDERKEY, $CONFIG;
	$senderkey = null;
	// Erst einmal mach ein Array, wenn moeglich
	if ($SENDERKEY != "" && strpos($SENDERKEY, ',') !== false) {
		$special_keywords = explode(",", $SENDERKEY);
		$nummer = $nr;
		$nummer = ($nummer % count($special_keywords));
		// myecho($nummer);
		$senderkey = urlencode(trim(replace_ltext($special_keywords[$nummer])));
		// myecho($senderkey);
	}
	if (empty($senderkey)) {
		//$senderkey = senderkey($nr+1);
		// myecho('Senderkey: "'.$senderkey.'"');
		$senderkey = 'live' . $nr;
	}
	return $senderkey;
}

function keyword1($nr) {
	global $KEYWORDS, $CONFIG;
	// Erst einmal mach ein Array, wenn moeglich
	if ($KEYWORDS[0] != "") {
		$special_keywords = explode(",", $KEYWORDS[0]);
		if ($CONFIG['KEYWORDROTATION'] != 0) {
			$nummer = date("z") + $nr;
		} else {
			$nummer = $nr;
		}
		$nummer = ($nummer % count($special_keywords));
		return urlencode(trim(replace_ltext($special_keywords[$nummer])));
	}
	return "";
}

function keyword2($nr) {
	global $KEYWORDS;
	global $CONFIG;
	// Erst einmal mach ein Array, wenn mï¿½glich
	if ($KEYWORDS[1] != "") {
		$special_keywords = explode(",", $KEYWORDS[1]);
		if ($CONFIG['KEYWORDROTATION'] != 0) {
			$nummer = date("H") + $nr;
		} else {
			$nummer = $nr;
		}
		$nummer = ($nummer % count($special_keywords));
		return urlencode(trim(replace_ltext($special_keywords[$nummer])));
	}
	return "";
}

function keyword3($nr) {
	global $KEYWORDS;
	global $CONFIG;
	// Erst einmal mach ein Array, wenn mï¿½glich
	if ($KEYWORDS[2] != "") {
		$special_keywords = explode(",", $KEYWORDS[2]);
		if ($CONFIG['KEYWORDROTATION'] != 0) {
			$nummer = date("d") + $nr;
		} else {
			$nummer = $nr;
		}

		$nummer = ($nummer % count($special_keywords));
		return urlencode(trim(replace_ltext($special_keywords[$nummer])));
	}
	return "";
}

if (!function_exists('replace_words')) {
	function replace_words($word) {
		$OArr = array('ü', 'ä', 'ö', 'ß', 'Ü', 'Ä', 'Ö');
		$NArr = array('&uuml;', '&auml;', '&ouml;', '&szlig;', '&Uuml;', '&Auml;', '&Ouml;');
		$word = str_replace($OArr, $NArr, $word);
		return $word;
	}

}

function xml2array($xbuffer, $debug = 0) {
	// $debug = 1;
	$p = xml_parser_create("UTF-8");
	xml_parse_into_struct($p, $xbuffer, $vals, $index);
	$xml_array = array();
	if ($debug == 1) {
		echo "<!-- ";
		print_r($vals);
		echo " -->";
	}
	for ($n = 0; $n < count($vals); $n++) {
		if ($vals[$n]["type"] == "complete") {
			// Vorsicht, wenn es diesen Tag schon gibt, muss ein Array daraus gemacht werden
			if (isset($xml_array[$vals[$n]["tag"]]) && ($xml_array[$vals[$n]["tag"]] != "" || is_array($xml_array[$vals[$n]["tag"]]))) {
				// Ist es schon ein Array, dann haenge es hintendran:
				if (is_array($xml_array[$vals[$n]["tag"]])) {
					$xml_array[$vals[$n]["tag"]][] = $vals[$n]["value"];
				} else {
					$alter_wert = $xml_array[$vals[$n]["tag"]];
					unset($xml_array[$vals[$n]["tag"]]);
					$xml_array[$vals[$n]["tag"]] = array();
					$xml_array[$vals[$n]["tag"]][] = $alter_wert;
					$xml_array[$vals[$n]["tag"]][] = $vals[$n]["value"];
				}
			} else {
				if (isset($vals[$n]["value"])) {
					$xml_array[$vals[$n]["tag"]] = $vals[$n]["value"];
				}
			}
		}
	}
	return $xml_array;
}

function test_cat($wort, $stelle) {
	global $kategorie, $CATLINKZ, $CAMLINKZ;
	$sik_wort = strtolower($wort);
	$test = '';
	for ($n = 0; $n < count($kategorie); $n++) {
		if (!isset($kategorie[$n]['bezeichnung']) || $kategorie[$n]['bezeichnung'] == "") {
			continue;
		}
		$wort = $sik_wort;
		$kategorie_linkname = utilities::__utf8_decode(strtolower($kategorie[$n]['linkname']));
		// myecho($kategorie_linkname);
		$wort = str_replace($kategorie_linkname, "", $wort);

		if (key_exists($stelle, $CAMLINKZ)) {
			$test2 = str_replace("{kategorie}", "", $CAMLINKZ[$stelle]);
		} else {
			$test2 = '';
		}
		if (key_exists($stelle, $CATLINKZ)) {
			// myecho($stelle);
			// myecho($CATLINKZ);
			$test1 = str_replace("{kategorie}", "", $CATLINKZ[$stelle]);
		} else {
			$test1 = '';
		}
		if (($wort == $test) && (($test1 != $CATLINKZ[$stelle]) || ($test2 != $CAMLINKZ[$stelle]))) {
			return $n;
		}

	}
	return -1;
}

function test_cam($wort, $stelle) {
	global $CAMLINKZ, $CATLINKZ, $KEYWORDS, $SENDERKEY;
	$sik_wort = $wort;
	if (!isset($CAMLINKZ[$stelle])) {
		return -1;
	}
	// Unterscheide, ob id und seite an gleicher Stelle sitzen.
	if (strpos($CAMLINKZ[$stelle], "{id}") !== false && strpos($CATLINKZ[$stelle], "{seite}") === false) {
		if (preg_match("/([0-9]{1,6})/", $sik_wort, $sid)) {
			return $sid[1];
		}
	} elseif (strpos($CAMLINKZ[$stelle], "{id}") !== false && strpos($CATLINKZ[$stelle], "{seite}") !== false) {
		// Es muss nun herausgefunden werden, ob es sich um die id oder um die seite handelt.
		// 1. Gibt es ueberhaupt eine Zahl darin?
		if (preg_match("/([0-9]{1,6})/", $sik_wort, $sid)) {
			$zahl = $sid[1];
			// Mache Testausdruecke zum Vergleich.
			$testextern = str_replace($zahl, "", $sik_wort);
			$testintern = str_replace("{id}", "", $CAMLINKZ[$stelle]);
			// Wenn identisch, alles klar, gib zurueck
			if ($testintern == $testextern) {
				return $zahl;
			}
			// Noch ist nicht alles verloren, wenn in $CAMLINKZ der senderkey steckt
			$erfolg = 0;
			$testintern = str_replace(array("{keyword1}", "{keyword2}", "{keyword3}"), array("{senderkey}", "{senderkey}", "{senderkey}"), $testintern);
			if (strpos($testintern, "{senderkey}") !== false) {
				$allkeys = explode(",", $SENDERKEY);
				foreach ($KEYWORDS as $keyvalue) {
					$allkeys = array_merge($allkeys, explode(",", $keyvalue));
				}
				foreach ($allkeys as $value) {
					$test2intern = str_replace("{senderkey}", trim($value), $testintern);
					if ($test2intern == $testextern) {
						// Jawohl, es war ein Keyword dort versteckt.
						$erfolg = 1;
					}
				}
			}
			if ($erfolg == 1) {
				return $zahl;
			} else {
				return -1;
			}
		} else {
			return -1;
		}
	}
	return -1;
}

function test_page($wort, $stelle) {
	global $CATLINKZ, $CAMLINKZ;
	$sik_wort = $wort;
	$wort = preg_replace("/([0-9]+)/", "", $wort);
	if (isset($CATLINKZ[$stelle])) {
		$test1 = preg_replace("/{seite}/", "", $CATLINKZ[$stelle]);
		if (!isset($CAMLINKZ[$stelle])) {
			$CAMLINKZ[$stelle] = $test2 = '';

		} else {
			$test2 = preg_replace("/{seite}/", "", $CAMLINKZ[$stelle]);
		}
		if (($wort == $test1 && $test1 != $CAMLINKZ[$stelle]) || ($wort == $test2 && $test2 != $CATLINKZ[$stelle])) {
			if (preg_match("/([0-9]+)/", $sik_wort, $sid)) {
				return $sid[1];
			}
		}
	}

	return -1;
}

if (!function_exists('replace_ltext')) {
	function replace_ltext($word) {

		$word = preg_replace("~ü~msi", "ue", $word);
		$word = preg_replace("~ä~msi", "ae", $word);
		$word = preg_replace("~ö~msi", "oe", $word);
		$word = preg_replace("~ß~msi", "ss", $word);
		$word = preg_replace("~ ~msi", "-", $word);
		$word = preg_replace("~[^\w\d-]+~msi", "", $word);
		$word = preg_replace("~[-]+~msi", "-", $word);
		if (substr($word, 0, 1) == "-") {
			$word = substr($word, 1);
		}
		if (substr($word, -1) == "-") {
			$word = substr($word, 0, -1);
		}
		return $word;
	}

}

function get_liste($catid) {
	global $CONFIG;
	$datei = $CONFIG['TEMPDIR'] . "liste-" . $catid . ".s";
	$liste = array();
	$dateibuffer = array();
	if (file_exists($datei)) {
		$dateibuffer = unserialize(implode("", file($datei)));
		$i = 0;
		for ($n = 0; $n < count($dateibuffer); $n++) {
			$cam = get_cam_info($dateibuffer[$n]);
			if (!isset($cam['RESULT']) && isset($cam['PREVIEW']) && isset($cam['SHORTDESCRIPTION'])) {
				$liste[$dateibuffer[$i]] = $cam;
				$liste[$dateibuffer[$i]]['name'] = $liste[$dateibuffer[$i]]['NAME'];
				$liste[$dateibuffer[$i]]['desc'] = $liste[$dateibuffer[$i]]['SHORTDESCRIPTION'];
				$liste[$dateibuffer[$i]]['preview'] = $liste[$dateibuffer[$i]]['PREVIEW'][0];
				$liste[$dateibuffer[$i]]['longdesc'] = $liste[$dateibuffer[$i]]['BESCHREIBUNG'];
				$i++;
			} else {
				// myecho($cam);
			}
		}
	}
	return $liste;
}

/**
 * gibt die Anzahl der gespeicherten Cams
 * egal ob online oder offline pro Kategorie
 * in einem Array zurueck
 * und
 * erstellt eine Datei mit der Anzahl der
 * gespeicherten Cams pro Kategorie
 * in jeder Zeile, wenn diese Datei nicht vorhanden ist
 * oder aelter als eine gewisse Zeit ist
 * @return array
 */
function camsCountByCategories() {
	global $CONFIG, $kategorie;
	$cams_count_by_categories = array();
	$i = 0;
	$all_cams_counts_file = $CONFIG['TEMPDIR'] . "all_cams_count.txt";
	$time_diff = 60 * 60 * 1;
	if (!file_exists($all_cams_counts_file) || time() - filemtime($all_cams_counts_file) > $time_diff) {
		foreach ($kategorie as $category) {
			$category_list_file = $CONFIG['TEMPDIR'] . "liste-" . $i . ".s";
			$category_s_file = $CONFIG['TEMPDIR'] . "kategorie-" . $i . ".s";
			if (file_exists($category_s_file)) {
				$array = array();
				$content = implode("\n", file($category_s_file));
				// myecho($content);
				$content = str_ireplace("\n", ' ', $content);
				if (strpos($content, 'ID') != false) {
					$array = unserialize($content);
				}
				if (isset($array['ID'])) {
					$ids = $array['ID'];
					foreach ($ids as $id) {

					}
				}
			}
			if (file_exists($category_list_file)) {
				$array = unserialize(implode("", file($category_list_file)));
				// myecho($array);die();
				$cams_count_by_categories[$i] = count($array);
			} else {
				$cams_count_by_categories[$i] = 0;
			}
			if ($i > 0) {
				$content .= "\n" . $cams_count_by_categories[$i];
			} else {
				$content = $cams_count_by_categories[$i];
			}
			$i++;
		}
		file_put_contents($all_cams_counts_file, $content);
	} else {
		$cams_count_by_categories = array();
		foreach (file($all_cams_counts_file) as $line) {
			$cams_count_by_categories[] = trim(str_ireplace("\n", '', $line));
		}
	}
	return $cams_count_by_categories;
}

function get_neuliste() {
	global $CONFIG;
	$datei = $CONFIG['TEMPDIR'] . "neuliste.s";
	$datas = array();
	if (file_exists($datei)) {
		$camids = unserialize(implode("", file($datei)));
		// Die neuesten sind hinten
		$maximal = min(20, count($camids));
		for ($n = count($camids), $i = count($camids) - $maximal; $n > $i; $n--) {
			$data = get_cam_info($camids[$n - 1]);
			if (!isset($data['RESULT'])) {
				$datas[] = $data;
			}
		}
	}
	return $datas;
}

function get_kategorie_array($catid) {
	global $CONFIG;

	// Hole die Daten zu dieser Kategorie:
	$datei = "kategorie-" . $catid . ".s";
	$xml_filename = "kategorie-{$catid}.xml";
	$xml_file = $CONFIG['TEMPDIR'] . $xml_filename;
	if (!is_file($xml_file)) {
		// variables fuer die Funktion install_inc
		$hinweis = 1;
		$config_path = $CONFIG['PATH'];
		if (substr($config_path, strlen($config_path) - 1) != '/') {
			$config_path .= '/';
		}
		$link = "//" . $_SERVER["HTTP_HOST"] . $config_path . "fetch.php";
		$message = "Keine Daten zum Anzeigen vorhanden. Es lag/liegt ein tempor&auml;rer Fehler auf dem Datenserver von 777Live vor.";
		// die alte timestamp_fetch loeschen, sofern die Datei vorliegt und nicht in den letzten 5 Minuten geaendert wurde
		$temp_dir = $CONFIG['TEMPDIR'];
		if (substr($temp_dir, strlen($temp_dir) - 1) != '/') {
			$temp_dir .= '/';
		}
		$timestamp_file = $temp_dir . 'timestamp_fetch.txt';
		if (is_file($timestamp_file) && time() - filemtime($timestamp_file) > 300) {
			unlink($timestamp_file);
			$display_link = "Damit alle relvanten Daten zur Ausf&uuml;hrung von 777Script zur Verf&uuml;gung stehen, 
							f&uuml;hren Sie bitte den <a href=\"{$link}?first=1\" title=\"Script installieren und Daten importieren\">Datenimport</a> aus.";
		} else {
			$display_link = "Bitte warten Sie ein paar Minuten und f&uuml;hren Sie dann einen neuen <a href=\"{$link}?first=1\" title=\"Script installieren und Daten importieren\">Datenimport</a> aus.";
		}
		$display_link .= "<br/>Dieser Vorgang kann einige Minuten dauern. Nach erfolgreichem Datenimport wird direkt zur Startseite weiter geleitet.";
		// install anzeigen

		display_install_inc($message, $link, $display_link);
	}
	// myecho(file_get_contents($xml_file));die();
	$content = implode("\n", file($xml_file));
	$array = xml2array($content);
	if (isset($array['ID']) && !is_array($array['ID'])) {
		// myecho('CategoryId: '.$catid);
		// myecho($array);
		$new_array = array();
		foreach ($array as $key => $value) {
			$new_array[$key] = array($value);
		}
		$array = $new_array;
		// myecho($array);
	} else {
		// myecho('alles OK in CategorId: '.$catid);
	}
	// favoritencams nach vorne
	// myecho($array['ID']);
	if (!empty($CONFIG['FAVORITEN']) && (isset($array['ID']) && count($array['ID']) > 0)) {
		// myecho($CONFIG['FAVORITEN']);
		if (strpos($CONFIG['FAVORITEN'], ',') !== false) {
			$favourite_camids = preg_split('#,#', $CONFIG['FAVORITEN']);
		} else {
			$favourite_camids = array($CONFIG['FAVORITEN']);
		}
		// myecho($favourite_camids);
		$i = 0;
		$only_favourites = $only_favourites_pos = array();
		foreach ($favourite_camids as $favourite_camid) {
			$favourite_camid = trim($favourite_camid);
			if (is_array($array['ID'])) {
				if (in_array($favourite_camid, $array['ID'])) {
					$only_favourites[] = $favourite_camid;
					// myecho('gefunden');
					// favourite_camid ist gefunden muss an die erste position gesetzt werden
					$pos = array_search($favourite_camid, $array['ID']);
					// myecho($pos);
					foreach ($array as $key => $value) {
						// myecho($key);
						$key_i = $array[$key][$i];
						$key_pos = $array[$key][$pos];
						// myecho($key_i);
						// myecho($key_pos);
						$array[$key][$i] = $key_pos;
						$array[$key][$pos] = $key_i;
					}
					$i++;
				}
			}
		}
		// myecho($array['ID']);
		// myecho($array);
		// die();
	}

	if (isset($CONFIG['ONLYFAVOURITES']) && $CONFIG['ONLYFAVOURITES'] == 1) {
		if (count($only_favourites) > 0) {
			foreach ($only_favourites as $camid) {
				$i = 0;
				foreach ($array['ID'] as $array_id) {
					if (!in_array($array_id, $only_favourites)) {
						foreach ($array as $key => $value) {
							unset($array[$key][$i]);
						}
					}
					$i++;
				}
			}
			// myecho($array);
		}
		// myecho($array);
	}

	// cams die nicht angezeigt werden sollen - entfernen
	if (!empty($CONFIG['CAMAUSSCHLUSS']) && (isset($array['ID']) && count($array['ID']) > 0)) {
		// myecho($CONFIG['FAVORITEN']);
		if (strpos($CONFIG['CAMAUSSCHLUSS'], ',') !== false) {
			$exclusion_camids = preg_split('#,#', $CONFIG['CAMAUSSCHLUSS']);
		} else {
			$exclusion_camids = array($CONFIG['CAMAUSSCHLUSS']);
		}
		// myecho($exclusion_camids);
		$i = 0;
		foreach ($exclusion_camids as $exclusion_camid) {
			$exclusion_camid = trim($exclusion_camid);
			if (is_array($array['ID'])) {
				if (in_array($exclusion_camid, $array['ID'])) {
					// myecho('gefunden');
					// exclusion_camid ist gefunden Werte muessen auf null gesetzt werden
					$pos = array_search($exclusion_camid, $array['ID']);
					// myecho($pos);
					foreach ($array as $key => $value) {
						$array[$key][$pos] = null;
					}
				}
				$i++;
			}
		}
		// neues array schreiben, weil unset in einer schleife nicht funktioniert
		// und die null-Werte entfernen
		$filtered_array = array();
		foreach ($array as $key => $entry) {
			// myecho($entry);
			$x = 0;
			for ($i = 0, $n = count($entry); $i < $n; $i++) {
				$value = $array[$key][$i];
				if (!is_null($value)) {
					$filtered_array[$key][$x] = $value;
					$x++;
				}
			}
		}
		// array wieder umbenennen
		$array = $filtered_array;
		unset($filtered_array);
		// myecho($array['ID']);
		// myecho($array);
		// die();
	}
	// die();
	// Unter Umstaenden gibt es nur eine Cam, dann ummodeln.
	if (isset($array["ID"]) && (!is_array($array["ID"]) && $array["ID"] > 0)) {
		$altarray = $array;
		$array = array();
		while (list($key, $value) = each($altarray)) {
			$array[$key] = array();
			$array[$key][0] = $value;
		}
	}
	if ($CONFIG['NOSHORTDESCRIPTION'] == 1) {
		foreach ($array['DESCRIPTION'] as $key => $value) {
			$array['DESCRIPTION'][$key] = "";
			$array['BESCHREIBUNG'][$key] = "";
		}
	}
	foreach ($array as $key => $value) {
		if (!is_numeric($value) && !is_array($value)) {
			$array[$key] = encoding::fixUTF8($value);
			// $array[$key] = $value;
		} elseif (is_array($value) && !is_numeric($value)) {
			foreach ($value as $k => $v) {
				$array[$key][$k] = encoding::fixUTF8($v);
				// $array[$key][$k] = $v;
			}
		}
	}
	return $array;
}

function get_cam_info($sid, $muss = 0, $extend_kat = false) {
	global $CONFIG, $systemtext;
	$camid = $sid;
	// es gibt eine Cam, hole deren Daten
	$xml_datei = $CONFIG['TEMPDIR'] . $sid . ".xml";
	// myecho($xml_datei);
	// Es kann natuerlich sein, dass der/die Sender nicht online ist
	// also sieh einmal nach, ob die Daten nicht im temporaeren Ordner sind.
	$sender = array();
	if (file_exists($xml_datei) && $muss == 0) {
		// myecho($xml_datei. ' ist vorhanden');
		$dateibuffer = implode("\n", file($xml_datei));
		$debug = 0;
		$sender = xml2array($dateibuffer, $debug);
		if (count($sender) > 0) {
			$muss = 0;
		} else {
			$muss = 1;
		}
	} else {
		// myecho($xml_datei. ' holen');
		// datei holen und nachsehen ob die Show nicht disabled ist
		if (is_valid_XML_file($camid)) {
			// myecho('xml musste kontrolliert werden');
			$dateibuffer = implode("\n", file($xml_datei));
			$sender = xml2array($dateibuffer);
			if (count($sender) > 0) {
				$muss = 0;
			} else {
				$muss = 1;
			}
		}
	}
	if ($muss == 1) {
		// myecho('xml muss geholt werden');
		$redirect = true;
		// datei holen und nachsehen ob die Show nicht disabled ist
		if (is_valid_XML_file(trim($camid))) {
			$dateibuffer = implode("\n", file($xml_datei));
			$sender = xml2array($dateibuffer);
		} else {
			$remote_file = 'https://mm.7-7-7-partner.com/showdetail.php?show=' . $camid . '&lang=' . $CONFIG['LANGUAGE'] . '&size=l';
			// echolink($remote_file);
			$content = get_content($remote_file);
			// myecho($content);
			file_put_contents($xml_datei, $content);
			// myecho(simplexml_load_file($xml_datei));
			$dateibuffer = implode("\n", file($xml_datei));
			$sender = xml2array($dateibuffer);

			if (count($sender) > 0 && isset($sender['DISABLED']) && $sender['DISABLED'] == 0) {
				$redirect = false;
				// myecho('Daten sind da');
			}
			if ($redirect || isset($sender['RESULT'])) {
				if (is_file($xml_datei)) {
					@unlink($xml_datei);
				}
				$redirect = true;
				// display_404Error($camid);
			}
		}
		// myecho($sender);flush();
		if (!key_exists('PREVIEW', $sender)) {
			$redirect = true;
		} else {
			foreach ($sender['PREVIEW'] as $preview) {
				$image_id = image_id($preview);
				if (is_numeric($image_id) && strlen($image_id) >= 7) {
					$redirect = false;
				} else {
					$redirect = true;
					break;
				}
			}
		}
		if ($redirect) {
			if (is_file($xml_datei)) {
				@unlink($xml_datei);
			}
			// myecho($sender);die();
			if (!$extend_kat) {
				display_404Error($camid);
			}
		}
	}
	if (count($sender) == 0) {
		// echo('<div style="color:#F00;background-color:#000;width:250px;font-size:12px;padding:3px;">Cam: '.$camid.' ist nicht OK</div>');
		// myecho($sender);
	}
	if ($CONFIG['NODESCRIPTION'] == 1) {
		$sender['BESCHREIBUNG'] = "";
	}
	if ($CONFIG['NOSHORTDESCRIPTION'] == 1) {
		$sender['SHORTDESCRIPTION'] = "";
	}
	if ($CONFIG['NOHOBBIES'] == 1) {
		$sender['HOBBIES'] = "";
	}

	$keys = array('NAME', 'GESCHLECHT', 'STERNZEICHEN', 'ALTER', 'SEXPREF', 'KOERBCHENGROESSE', 'INTIMRASUR', 'BESCHREIBUNG', 'HOBBIES', 'GROESSE', 'FIGUR', 'HAARFARBE', 'HAARLAENGE', 'HAUTFARBE', 'AUGEN', 'SPRACHEN', 'CHARAKTER', 'EROINTRESSEN');
	foreach ($keys as $k) {
		if (!isset($sender[$k])) {
			$sender[$k] = '';
		}

	}
	// myecho($sender);
	// header('Content-type: text/html; charset=utf-8');
	// foreach ($sender as $key=>$value) {
	//    if (!is_numeric($value) && !is_array($value)) {
	//    	$value = utilities::__utf8_decode($value);
	//        $value = htmlentities($value);
	//        $sender[$key] = $value;
	//    }
	// }
	// myecho($sender);
	return $sender;
}

/**
 * zeigt eine 404Errorseite an,
 * traegt die aufgerufene Seite in
 * die 404filelist ein
 * und bricht das Script ab
 * @param integer $camid
 */
if (!function_exists('display_404Error')) {
	function display_404Error($camid) {
		global $CONFIG;
		// Abbruch mit 404-Error-Seite anzeigen
		if ($CONFIG['SITEMAP'] != 0) {
			$listed = false;
			$file = $CONFIG['SITEMAPDIR'] . $CONFIG['SITEMAP-404'];
			if (is_file($file)) {
				$fp = @fopen($file, 'r');
				$content = fread($fp, filesize($file));
				@fclose($fp);
				if (strpos($content, $_SERVER["REQUEST_URI"]) !== false) {
					$listed = true;
				}
			}
			if (!$listed) {
				if ($fp = @fopen($file, "a")) {
					@fputs($fp, $_SERVER["REQUEST_URI"] . "\n");
					@fclose($fp);
				}
			}
		}
		if (!headers_sent()) {
			header("Content-Type: text/html; charset=utf-8");
			header("HTTP/1.0 410 Gone");
		}

		$error_file = $_SERVER["DOCUMENT_ROOT"] . $CONFIG['LAYOUTPATH'] . "/404error.php";
		if (!is_file($error_file)) {
			echo('404 error_file not found');
			die();
		}
		@include_once ($error_file);
		if (isset($CONFIG['DEVELOPMENT']) && $CONFIG['DEVELOPMENT']) {
			echo('<div style="margin:10px auto;color:#F00;background-color:#FFF;width:250px;font-size:12px;padding:3px;">Camid: ' . $camid . ' ist nicht vorhanden</div>');
		}
		die();
	}

}
/**
 * setzt einen Wert aus zwei uebergebenen Parametern
 * wobei ueberprueft wird, ob ueberhaupt die Parameter
 * mit Zeichen gefuellt sind
 * @return string
 * @param string $value_1
 * @param string $value_2
 */
if (!function_exists('setSedcardTextValue')) {
	function setSedcardTextValue($value_1, $value_2) {
		$bResult = '';
		if (empty($value_1) && !empty($value_2)) {
			$bResult = $value_2;
		}
		if (empty($value_2) && !empty($value_1)) {
			$bResult = $value_1;
		}
		if (!empty($value_2) && !empty($value_1)) {
			$bResult = $value_1 . ' / ' . $value_2;
		}
		return $bResult;
	}

}

if (!function_exists('saveanzahl')) {
	function saveanzahl($wieviel, $welche) {
		// wird jetzt ueber die functions.inc.php
		// alle 30 Minuten aktualisiert

		return true;
		/**
		 global $CONFIG;
		 if (!file_exists($CONFIG['TEMPDIR']."anzahl.lst"))
		 {
		 $inhalt = array_fill(0, 12, "0\n");
		 }
		 else
		 {
		 $inhalt = file($CONFIG['TEMPDIR']."anzahl.lst");
		 }
		 $inhalt[$welche] = $wieviel."\n";
		 savefile("anzahl.lst", "TEMPDIR", implode("", $inhalt));
		 */
	}

}

if (!function_exists('savefile')) {
	function savefile($file, $dir, $content) {
		global $CONFIG;
		if (is_array($file)) {
			print_r($file);
			die("Unerwartete Datei");
		}
		// $dir als Assoziativer Wert fuer Config
		if ($CONFIG[$dir] != "") {
			$file = $CONFIG[$dir] . $file;
			if ($fp = @fopen($file, "w+")) {
				// Aktiviere die LOCK_NB Option bei exklusiver Sperre
				if (flock($fp, LOCK_EX | LOCK_NB)) {
					//ftruncate($fp, 0); // kuerze Datei
					fwrite($fp, $content);
					flock($fp, LOCK_UN);
					// Gib Sperre frei
				}
				fclose($fp);
				@chmod($file, 0666);
			} else {
				$message = '';
				if (is_dir($CONFIG[$dir])) {
					if (!@rmdir($CONFIG[$dir])) {
						$message = '<div><span>' . $CONFIG[$dir] . '</span> konnte nicht gel&ouml;scht werden</div>';
					}
				}
				$message .= '<div><span>' . $file . '</span> kann nicht ge&ouml;ffnet werden</div>
				<div>Bitte erstellen Sie das Verzeichnis: <span>' . $CONFIG[$dir] . '</span> manuell und </div>
				<div>geben Sie dem Verzeichnis <span>' . $CONFIG[$dir] . '</span> Schreibrechte (775 oder 777 je nach Serverkonfiguration).</div>';
				display_install_inc($message);
			}
			// if ($file=="cam.s") {
			// echo time();
			// echo "Content: ".$content;
			//     }
			return true;
		} else {
			return false;
		}
	}

}

if (!function_exists('extend_kat')) {
	function extend_kat($array) {
		// Die Kategorien müssen noch erweitert werden.
		// Unter Umstaenden gibt es nur eine Cam, dann ummodeln.
		// myecho($array);die();
		if (isset($array["ID"]) && (!is_array($array["ID"]) && $array["ID"] > 0)) {
			$altarray = $array;
			$array = array();
			while (list($key, $value) = each($altarray)) {
				$array[$key] = array();
				$array[$key][0] = $value;
			}
		}
		if (isset($array["ID"]) && is_array($array["ID"])) {
			// Es muss noch erweitert werden.
			$array['BESCHREIBUNG'] = array();
			foreach ($array["ID"] as $nummer => $camid) {
				// myecho($camid);
				$help = get_cam_info($camid, 1, true);
				if (!is_array($help) && !$help) {
					$help = array();
					$help['BESCHREIBUNG'] = '';
				} else {
					$help['BESCHREIBUNG'] = str_replace(array("\n", "\r"), "", nl2br($help['BESCHREIBUNG']));
				}
				$array['BESCHREIBUNG'][$nummer] = $help['BESCHREIBUNG'];
			}

		}
		return $array;
	}

}

if (!function_exists('get_cat_count')) {
	function get_cat_count() {
		global $CONFIG, $kategorie;
		$bResult = null;
		$count_cams_file = $CONFIG['TEMPDIR'] . "anzahl.lst";
		if (!is_file($count_cams_file)) {
			$bResult = get_count_cams();
		} else {
			$bResult = array();
			$inhalt = file($count_cams_file);
			for ($n = 0; $n < count($inhalt); $n++) {
				$bResult[$n] = trim($inhalt[$n]);
			}
		}
		if (is_null($bResult) || count($bResult) < count($kategorie)) {
			$bResult = get_count_cams();
		}
		return $bResult;
	}

}

if (!function_exists('shuffle_cams_by_category_id')) {
	function shuffle_cams_by_category_id($category_id) {
		global $CONFIG, $kategorie;
		$bResult = false;
		$found_cams = true;
		if (isset($kategorie[$category_id])) {
			$xml_file = $CONFIG['TEMPDIR'] . "kategorie-" . $category_id . ".xml";
			if (is_file($xml_file) && time() - filemtime($xml_file) > ($CONFIG['MINUTESLIVINGCAT'] * 60)) {
				// myecho($xml_file);flush();
				$objXML = new xmlutility();
				$objXML->parse(file_get_contents($xml_file));
				$anzahl[$category_id] = $objXML->getCountChildren();
				if ($anzahl[$category_id] == 0) {
					$found_cams = false;
				}
				if ($found_cams) {
					if ($objXML->shuffleArray2Xml()) {
						// myecho($xml_file);flush();
						$xml_string = $objXML->getXMLString();
						// myecho($xml_string);
						file_put_contents($xml_file, $xml_string);
						$array = xml2array($xml_string);
						// myecho($array);
						// Bilder speichern wenn $CONFIG['SAVEIMAGES'] = 1
						if (key_exists('PREVIEWURL', $array) && $CONFIG['SAVEIMAGES'] == 1) {
							$save_preview_images = save_preview_images($array['PREVIEWURL']);
							if (!$save_preview_images) {
								savelog('Vorschaubilder konnten nicht gespeichert werden');
							}
						}
						$file = "kategorie-" . $category_id . ".s";
						// myecho($array);flush();
						if (!savefile($file, "TEMPDIR", serialize($array))) {
							die("Datei konnte nicht gespeichert werden, bitte prüfen Sie die Verzeichnisrechte von " . $CONFIG["TEMP"]);
						}
						$file = $CONFIG['TEMPDIR'] . "kategorie-" . $category_id . ".s";
						$ergebnis = extend_kat(unserialize(implode("", file($file))));
						// myecho('ergebnis: '.$ergebnis);
						// die();
						savefile("kategorie-" . $category_id . ".s", "TEMPDIR", serialize($ergebnis));
						$bResult = true;
					} else {
						$bResult = false;
					}
				} else {
					$bResult = true;
				}
				if (isset($objXML)) {
					unset($objXML);
				}
			} else {
				$bResult = true;
			}
		}
		return $bResult;
	}

}
/**
 * liest aus einem Array mit URLS die ID der Vorschaubilder aus
 * und speichert die Bilder wenn gewuenscht die Bilder
 * @param object $array_previewurl
 * @return boolean
 */
if (!function_exists('save_preview_images')) {
	function save_preview_images($array_previewurl) {
		global $CONFIG;
		$bResult = false;
		if ($CONFIG['SAVEIMAGES'] == 0) {
			$bResult = true;
		}
		
		if (!$bResult) {
			if (is_array($array_previewurl)) {
				foreach ($array_previewurl as $previewurl) {
					$bResult = true;
					$image_id = image_id($previewurl);
					// myecho($image_id);
					if (!is_numeric($image_id)) {
						$bResult = false;
						$error = 'keine ID image_id => ' . $image_id;
						// myecho($error);
						savelog($error);
					}
					if ($bResult && !strlen($image_id) >= 7) {
						$bResult = false;
						$error = 'keine gueltige ID image_id => ' . $image_id;
						// myecho($error);
						savelog($error);
					}
					$image_directory = $CONFIG['IMAGEDIR'];
					if (!is_dir($image_directory)) {
						$error = 'Nicht vorhanden image_directory => ' . $image_directory;
						// myecho($error);
						savelog($error);
						$bResult = false;
					}
					// Datei erstellen
					$image_file_name = $image_id . '.jpg';
					$image_file = $image_directory . $image_file_name;
					if (!is_file($image_file) && $bResult) {
						$remote_image = $image_id . "_752x564.jpg";
						// myecho($remote_image);
						$host = 'mm.7-7-7-partner.com';
						$loc = '/images/' . $remote_image;
						$remote = 'http://' . $host . $loc;
						// echolink($remote);
						// erst nachsehen ob das Bild auf remote vorhanden ist
						if (!utilities::head($host, $loc)) {
							$remote = 'http://' . $host . '/images/404picture.php?url=%2Fimages%2F' . $remote_image;
						}
						// echolink($remote);
						$picturedata = get_content($remote);
						if (strlen(trim($picturedata)) > 6 && strtoupper(bin2hex(substr($picturedata, 0, 6))) == "326232310D0A") {
							$picturedata = substr($picturedata, 6);
						}
						if (strlen(trim($picturedata)) == 0 || strtoupper(bin2hex(substr($picturedata, 0, 4))) != "FFD8FFE0" || strtoupper(bin2hex(substr($picturedata, 6, 4))) != "4A464946") {
							$error = $remote_image . ' konnte nicht geholt werden';
							savelog($error);
							$bResult = false;
						} else {
							$phandle = fopen($image_file, "w");
							if ($phandle) {
								fwrite($phandle, $picturedata);
								fclose($phandle);
							}
							chmod($image_file, 0666);
						}
					}
				}
			}
		}
		return $bResult;
	}

}

function get_count_cams() {
	global $CONFIG, $kategorie;
	$anzahl = array();

	// Anzahl Onlinecams in den Kategorien
	$count_cams_file = $CONFIG['TEMPDIR'] . "anzahl.lst";
	// wann sie erneuert werden soll
	$time_diff = 60 * $CONFIG['MINUTESLIVINGCAT'];
	$content_count_cams_file = '';

	$category_timestamp_file = $CONFIG['TEMPDIR'] . "kategorie-0.xml";
	if (is_file($category_timestamp_file) && time() - filemtime($category_timestamp_file) > $time_diff) {
		$time_diff = 0;
	}
	$timestamp_fetch_file = $CONFIG['TEMPDIR'] . "timestamp_fetch.txt";
	// Uhrzeit von der letzten Ausfuehrung der fetch.php
	if (is_file($timestamp_fetch_file)) {
		$lastupdate_at_time = trim(file_get_contents($CONFIG['TEMPDIR'] . "timestamp_fetch.txt"));
		// myecho(date('d.m.Y G:i:s', $lastupdate_at_time ));
		if (time() - $lastupdate_at_time > 1200) {
			// myecho('fetch');die();
			$time_diff = $lastupdate_at_time;
		}
	}
	// myecho($lastupdate_at_time);
	// echo('<div style="color:#F00;background-color:#000;width:300px;">time since last fetch: '.time() - $lastupdate_at_time.'</div><br/>');
	// myecho($lastupdate_at_time);
	// myecho( time() - filemtime($count_cams_file));
	// echo('<div style="color:#F00;background-color:#000;width:300px;">time_diff: '.$time_diff.'</div>');
	// myecho(date('d.m.Y G:i:s', $time_diff));
	// myecho(time() - date('Y-m-d', $time_diff));
	if (!file_exists($count_cams_file) || time() - filemtime($count_cams_file) > $time_diff) {
		// echo('<div style="color:#F00;background-color:#000;width:300px;">shuffle</div>');
		$i = 0;
		$files = @scandirneu($CONFIG['TEMPDIR']);
		$xml_files = array();
		foreach ($files as $file) {
			if (strpos($file, 'kategorie') !== false && strpos($file, 'xml') !== false) {
				$xml_files[] = $CONFIG['TEMPDIR'] . $file;
			}
		}
		for ($i = 0, $n = 100; $i < $n; $i++) {
			if (isset($kategorie[$i])) {
				$xml_file = $CONFIG['TEMPDIR'] . "kategorie-" . $i . ".xml";
				if (is_file($xml_file)) {
					// myecho($xml_file);flush();
					$objXML = new xmlutility();
					$objXML->parse(file_get_contents($xml_file));
					$anzahl[$i] = $objXML->getCountChildren();
					if ($anzahl[$i] > 0 && $objXML->shuffleArray2Xml()) {
						// myecho($xml_file);flush();
						$xml_string = $objXML->getXMLString();
						file_put_contents($xml_file, $xml_string);
						@chmod($xml_file, 0666);
						$array = xml2array($xml_string);
						// Bilder speichern wenn $CONFIG['SAVEIMAGES'] = 1
						if (key_exists('PREVIEWURL', $array) && $CONFIG['SAVEIMAGES'] == 1) {
							$save_preview_images = save_preview_images($array['PREVIEWURL']);
							if (!$save_preview_images) {
								savelog('Vorschaubilder konnten nicht gespeichert werden');
							}
						}
						$file = "kategorie-" . $i . ".s";
						// myecho($array);flush();
						if (!savefile($file, "TEMPDIR", serialize($array))) {
							die("Datei konnte nicht gespeichert werden, bitte prüfen Sie die Verzeichnisrechte von " . $CONFIG["TEMP"]);
						}
						$file = $CONFIG['TEMPDIR'] . "kategorie-" . $i . ".s";
						$ergebnis = extend_kat(unserialize(implode("", file($file))));
						// myecho('ergebnis: '.$ergebnis);
						// die();
						savefile("kategorie-" . $i . ".s", "TEMPDIR", serialize($ergebnis));
					}
				} else {
					$anzahl[$i] = 0;
				}
			} else {
				$anzahl[$i] = 0;
			}
			$content_count_cams_file .= $anzahl[$i] . "\n";
		}
		// myecho($count_cams_file);
		file_put_contents($count_cams_file, $content_count_cams_file);
		@chmod($count_cams_file, 0666);
		// myecho($content_count_cams_file);
	} else {
		$inhalt = file($count_cams_file);
		for ($n = 0; $n < count($inhalt); $n++) {
			$anzahl[$n] = trim($inhalt[$n]);
		}
	}

	return $anzahl;
}

function replace_nl($array) {
	for ($n = 0; $n < count($array); $n++) {
		$array[$n] = trim($array[$n]);
	}
	return $array;
}

function lese_textdateien() {
	global $CONFIG;
	$textdateien = array();
	if ($handle = @opendir($CONFIG['TXTDIR'])) {
		while (($file = readdir($handle)) !== false) {
			if (substr($file, -4) == ".txt") {
				$textdateien[count($textdateien)] = substr($file, 0, -4);
			}
		}
	}
	if (isset($CONFIG['TXTDIR2']) && $CONFIG['TXTDIR2'] != "") {
		if ($handle = @opendir($CONFIG['TXTDIR2'])) {
			while (($file = readdir($handle)) !== false) {
				if (substr($file, -4) == ".txt") {
					$textdateien[count($textdateien)] = substr($file, 0, -4);
				}
			}
		}
	}
	// myecho($textdateien);
	return $textdateien;
}

function test_images() {
	// Gehe alle Listen durch und pruefe die Bildlinks
	global $CONFIG, $cam, $camall, $sender, $zufall, $camtopsender;

	if ($CONFIG['SAVEIMAGES'] != 1) {
		return true;
	}
	if (isset($cam['ID']) && count($cam) > 0) {
		for ($n = 0; $n < count($cam['ID']); $n++) {
			$pic_cam_name = $cam["NAME"][$n];
			$pic_cam_description = $cam["DESCRIPTION"][$n];
			$bilddatei = setbildlink(image_id($cam['PREVIEWURL'][$n]), $pic_cam_name, $pic_cam_description);
			$cam['PREVIEWURL'][$n] = $CONFIG['PATH'] . "/" . $bilddatei;
		}
	}
	if (isset($camall) && count($camall) > 0) {

		for ($n = 0; $n < count($camall['ID']); $n++) {
			$pic_cam_name = $camall["NAME"][$n];
			$pic_cam_description = $camall["DESCRIPTION"][$n];
			$bilddatei = setbildlink(image_id($camall['PREVIEWURL'][$n]), $pic_cam_name, $pic_cam_description);
			$camall['PREVIEWURL'][$n] = $CONFIG['PATH'] . "/" . $bilddatei;
		}
		for ($n = 0; $n < count($zufall); $n++) {
			$u = $zufall[$n];
			if (isset($camall['PREVIEW'][$u])) {
				$cam_preview = $camall['PREVIEW'][$u];
				$pic_cam_name = $camall["NAME"][$u];
				$pic_cam_description = $camall["DESCRIPTION"][$u];
				for ($a = 0, $b = count($cam_preview); $a < $b; $a++) {
					$bilddatei = setbildlink(image_id($cam_preview[$a]), $pic_cam_name, $pic_cam_description);
					$cam_preview[$a] = $CONFIG['PATH'] . "/" . $bilddatei;
				}
				$camall['PREVIEW'][$u] = $cam_preview;
			}
		}
	}
	if (isset($sender) && isset($sender['CAMID']) && $sender['CAMID'] > 0) {
		// myecho($sender);
		for ($n = 0; $n < 3; $n++) {
			$pic_cam_name = $sender["NAME"];
			$pic_shortdesciption = $sender["SHORTDESCRIPTION"];
			$bilddatei = setbildlink(image_id($sender['PREVIEW'][$n]), $pic_cam_name, $pic_shortdesciption);
			$sender['IMAGE'][$n] = $sender['PREVIEW'][$n] = $CONFIG['PATH'] . "/" . $bilddatei;
		}
	}

	if (isset($camtopsender) && is_array($camtopsender)) {
		for ($n = 0, $i = count($camtopsender); $n < $i; $n++) {
			if (isset($camtopsender[$n]["PREVIEW"])) {
				for ($u = 0, $x = count($camtopsender[$n]["PREVIEW"]); $u < $x; $u++) {
					// myecho($camtopsender[$n]["PREVIEW"][$u]);
					$pic_cam_name = '';
					if (isset($camtopsender["NAME"][$u])) {
						$pic_cam_name = $camtopsender["NAME"][$u];
					}
					$pic_shortdescription = $camtopsender[$n]["SHORTDESCRIPTION"];
					$bilddatei = setbildlink(image_id($camtopsender[$n]["PREVIEW"][$u]), $pic_cam_name, $pic_shortdescription);
					$camtopsender[$n]['PREVIEW'][$u] = $CONFIG['PATH'] . "/" . $bilddatei;
					$camtopsender[$n]['IMAGE'][$u] = $CONFIG['PATH'] . "/" . $bilddatei;
				}
			}
		}
	}
}

/**
 * erstellt einen virituellen Link zur Cam
 * @param array   $data
 * @param integer optional $x
 * @return array
 */
if (!function_exists('set_cam_link')) {
	function set_cam_link($camdatas, $x = null) {
		global $kategorie, $CAMLINKZ, $CONFIG;
		$link = $CONFIG['PATH'] . "/" . implode("/", $CAMLINKZ);
		if (!is_null($x)) {
			$keyword1 = keyword1($camdatas['ID'][$x]);
			$keyword2 = keyword2($camdatas['ID'][$x]);
			$keyword3 = keyword3($camdatas['ID'][$x]);
			$sk = senderkey($camdatas['ID'][$x]);
			$camdatas_link_name = create_cam_name_for_link($camdatas['NAME'][$x]);
			$camdatas_link_description = substr($camdatas['DESCRIPTION'][$x], 0, 60);
			$camdatas_link_description = create_cam_name_for_link($camdatas_link_description);
			$link = str_replace("{kategorie}", $kategorie[$CONFIG['STARTKATEGORIE']]["linkname"], $link);
			$link = str_replace("{id}", $camdatas["ID"][$x], $link);
		} else {
			if (!isset($camdatas['ID'])) {
				$camdatas['ID'] = $camdatas['CAMID'];
			}
			if (!isset($camdatas['DESCRIPTION'])) {
				$camdatas['DESCRIPTION'] = $camdatas['BESCHREIBUNG'];
			}
			$keyword1 = keyword1($camdatas['ID']);
			$keyword2 = keyword2($camdatas['ID']);
			$keyword3 = keyword3($camdatas['ID']);
			$sk = senderkey($camdatas['ID']);
			$camdatas_link_name = create_cam_name_for_link($camdatas['NAME']);
			$camdatas_link_description = substr($camdatas['DESCRIPTION'], 0, 60);
			$camdatas_link_description = create_cam_name_for_link($camdatas_link_description);
			$link = str_replace("{kategorie}", $kategorie[$CONFIG['STARTKATEGORIE']]["linkname"], $link);
			$link = str_replace("{id}", $camdatas["ID"], $link);
		}

		$link = str_replace("{keyword1}", $keyword1, $link);
		$link = str_replace("{keyword2}", $keyword2, $link);
		$link = str_replace("{keyword3}", $keyword3, $link);
		$link = str_replace("{senderkey}", $sk, $link);
		$link = str_replace("{desc}", $camdatas_link_description, $link);
		$link = str_replace("{name}", $camdatas_link_name, $link);
		if (strpos($link, '.php/') !== false) {
			$link = substr($link, 0, strripos($link, '.php') + 4);
		}
		$bResult = array();
		$bResult['link'] = $link;
		// myecho($link);
		$bResult['keyword1'] = $keyword1;
		$bResult['keyword2'] = $keyword2;
		$bResult['keyword3'] = $keyword3;
		$bResult['sk'] = $sk;
		return $bResult;
	}

}

function setbildlink($id, $name, $beschreibung) {
	global $CONFIG, $PICLINKZ;
	$name = create_cam_name_for_link(replace_ltext(mb_substr($name, 0, 60)));
	// $name = html_entity_decode($name);
	// $name = urlencode(replace_ltext($name));

	$beschreibung = create_cam_name_for_link(replace_ltext(mb_substr($beschreibung, 0, 60)));
	// $beschreibung = html_entity_decode($beschreibung);
	// $beschreibung = urlencode(replace_ltext(substr($beschreibung, 0, 60)));

	$helplink = $CONFIG['IMAGEDIR'] . implode("/", $PICLINKZ);
	$keyword1 = keyword1($id);
	$keyword2 = keyword2($id);
	$keyword3 = keyword3($id);
	$helplink = str_replace("{id}", $id, $helplink);
	$helplink = str_replace("{keyword1}", $keyword1, $helplink);
	$helplink = str_replace("{keyword2}", $keyword2, $helplink);
	$helplink = str_replace("{keyword3}", $keyword3, $helplink);
	$helplink = str_replace("{desc}", $beschreibung, $helplink);
	$helplink = str_replace("{name}", $name, $helplink);
	$helplink = str_replace("//", "/", $helplink);
	return $helplink;
}

function date2time($date) {
	list($year, $month, $day) = explode("-", $date);
	return mktime(0, 0, 0, $month, $day, $year);
}

/**
 * sucht die Image_id aus einem String (URL)
 * @param string $string
 * @return integer
 */
if (!function_exists('image_id')) {
	function image_id($string) {
		$picid = null;
		// myecho($string);
		// steckt die ID im Bildnamen...
		$picture_file_name = strrchr($string, '/');
		$picture_file_name = str_replace('/', '', $picture_file_name);
		// myecho($picture_file_name);
		$pos = strpos($picture_file_name, '_');
		if ($pos !== false) {
			$picid = substr($picture_file_name, 0, $pos);
		} else {
			$error = 'noch keine Picid im Bildnamen gefunden: ' . $picture_file_name;
			// myecho($error);
			savelog($error);
			if (preg_match('/^([0-9]{6,}.jpg)$/', $picture_file_name)) {
				$error = 'ID ist vorhanden: ' . $picture_file_name;
				savelog($error);
				$picid = substr($picture_file_name, 0, strpos($picture_file_name, '.'));
				$error = 'ID: ' . $picid;
				savelog($error);
			}
		}
		if (is_null($picid)) {
			// dann muss die picid in der URL stecken
			$parts = preg_split('#/#', $string);
			foreach ($parts as $part) {
				$part = trim($part);
				if (is_numeric($part) && strlen($part) > 6) {
					$picid = $part;
					break;
				}
			}
		}
		if (is_null($picid)) {
			$error = 'keine Picid in der URL: ' . $string;
			// myecho($error);
			savelog($error);
			$picid = 0;
		}
		return $picid;
	}

}

function microtime_float() {
	list($usec, $sec) = explode(" ", microtime());
	return ((float)$usec + (float)$sec);
}

function savelog($text) {
	global $CONFIG;
	if (isset($CONFIG['DEVELOPMENT']) && $CONFIG['DEVELOPMENT']) {
		if (!isset($CONFIG['LOG_TEXT'])) {
			$CONFIG['LOG_TEXT'] = '';
		}
		$CONFIG['LOG'] = 1;
		$CONFIG['LOG_TEXT'] .= '<div style="padding:2px;text-align:left;background-color:#000;color:#FFF;font-size:12px;font-family:verdana,arial;margin:0 auto;width:900px;">' . $text . '</div>';
	}
	if ($CONFIG['LOG'] < 1) {
		return true;
	}
	if ($fp = @fopen($CONFIG['TEMPDIR'] . "log.txt", "a")) {
		fputs($fp, date("H:i:s d.m.Y") . " - " . __FILE__ . " - " . $text . "\n");
		fclose($fp);
		@chmod($CONFIG['TEMPDIR'] . "log.txt", 0666);
	}
}

function filelist($sb) {
	global $CONFIG;

	// Richtige Domain?
	$parse = parse_url($CONFIG['SITEMAP-DOMAIN']);
	if ($parse['host'] != $_SERVER['HTTP_HOST']) {
		return false;
	}
	// wenn debug nicht eintragen
	if (strpos($_SERVER['REQUEST_URI'], 'debug=') !== false) {
		return false;
	}
	$file = $CONFIG['SITEMAPDIR'] . $CONFIG['SITEMAP-TEMPFILE'];
	$linkereg = Array("/(?i)<a([^\a]+?)href='([^\a]+?)'/i", "/(?i)<a([^\a]+?)href=\"([^\a]+?)\"/i", "/(?i)<a([^\a]+?)href=([^\a]+?)[ |>]/i");
	$pages = array();
	$content = '';
	$filemtime = $i = 0;
	if (file_exists($file)) {
		$max_size = 1000000;
		$min_size = $filemtime = 0;
		// groesse der filelist.dir ermitteln
		$file_size = filesize($file);
		$time_diff = 89400;
		$renew = false;
		$timestamp_file = $CONFIG['TEMPDIR'] . 'timestamp_filelist.txt';
		if (is_file($timestamp_file)) {
			$fp = fopen($timestamp_file, 'r');
			$filemtime = trim(fread($fp, filesize($timestamp_file)));
			fclose($fp);
		}
		// myecho($filemtime);
		if (time() - $filemtime > $time_diff) {
			// sitemap wird aufgrund des Zeitstempels neu erstellt
			$renew = true;
			// myecho('$filemtime > $time_diff: neu');
		}
		// myecho($file_size);
		if (isset($CONFIG['SITEMAP-TEMPFILE-MAXSIZE']) && is_numeric($CONFIG['SITEMAP-TEMPFILE-MAXSIZE']) && $CONFIG['SITEMAP-TEMPFILE-MAXSIZE'] > 0) {
			$max_size = ceil($CONFIG['SITEMAP-TEMPFILE-MAXSIZE'] * (1024 * 1024));
		}
		if ($file_size > $max_size || $renew) {
			$exit = false;
			// urllist_cleanup.tool.php
			include_once ('urllist_cleanup.tool.php');
			$file_size = 0;
			if (is_file($file)) {
				$file_size = filesize($file);
			}
			if ($file_size > $max_size || $renew) {
				//sitemap generieren
				if (file_exists('sitemapgenerator.php')) {
					include_once ('sitemapgenerator.php');
				} else {
					include_once ('make_sitemap.tool.php');
				}
				// datei loeschen
				if (file_exists($file)) {
					unlink($file);
				}
				$fp = fopen($file, 'w');
				fclose($fp);
			}
		} elseif ($file_size > $min_size) {
			// den bisherigen Content laden
			$fp = fopen($file, 'r');
			$content = fread($fp, filesize($file));
			fclose($fp);
		}
		if ($renew) {
			// myecho('renew = true');
			$fp = fopen($timestamp_file, 'w');
			fwrite($fp, time());
			fclose($fp);
			chmod($timestamp_file, 0666);
		}
	}
	$fp = fopen($file, 'a+');
	// myecho($content);
	if ($fp) {
		// myecho($pages);
		for ($n = 0; $n < count($linkereg); $n++) {
			preg_match_all($linkereg[$n], $sb, $rex, PREG_SET_ORDER);
			if (is_array($rex) && count($rex) > 0) {
				// myecho($rex);
				for ($m = 0; $m < count($rex); $m++) {
					$valid = true;
					$page = trim(str_ireplace("\n", '', $rex[$m][2]));
					if (empty($page) || in_array($page, $pages)) {
						$valid = false;
					}
					if ($valid && substr($page, 0, 1) != "/") {
						$valid = false;
					}
					if ($valid && strpos($page, '.php/') !== false) {
						$valid = false;
					}
					if ($valid && strpos($page, 'remote') !== false) {
						$valid = false;
					}
					if ($valid && !empty($content) && strpos($content, $page) !== false) {
						$valid = false;
					}
					if ($valid) {
						if (!empty($content)) {
							fputs($fp, "\n" . $page);
						} else {
							if ($i == 0) {
								fputs($fp, $page);
							} else {
								fputs($fp, "\n" . $page);
							}
							$i++;
						}
						$pages[] = $page;
					}
				}
			}
		}
		fclose($fp);
	} else {
		$error = $CONFIG['SITEMAPDIR'] . $CONFIG['SITEMAP-TEMPFILE'] . " ist nicht beschreibbar.";
		// myecho($error);
		savelog($error);
	}
}

function replace_uml($text) {
	$OArr = array('ü', 'ä', 'ö', 'ß', 'Ü', 'Ä', 'Ö', ' & ');
	$NArr = array('&uuml;', '&auml;', '&ouml;', '&szlig;', '&Uuml;', '&Auml;', '&Ouml;', ' &amp; ');

	$text = str_replace($OArr, $NArr, $text);
	return $text;
}

function scandirneu($pfad) {
	global $CONFIG;
	$dateien = array();
	if ($handle = @opendir($pfad)) {
		while (($file = readdir($handle)) !== false) {
			if ($file != "." && $file != ".." && is_file($pfad . $file)) {
				$dateien[count($dateien)] = $file;
			}
		}
	}
	return $dateien;
}

function deletedir($pfad) {
	$dateien = scandirneu($pfad);
	foreach ($dateien as $datei) {
		unlink($pfad . $datei);
	}
}

function get_content($holeurl) {
	global $CONFIG;
	if ($holeurl == "") {
		exit ;
	}
	if ($CONFIG['GETPROCEDURE'] == 0 || ($CONFIG['GETPROCEDURE'] == 1 && !function_exists("curl_init"))) {
		if ($url = implode("", file($holeurl))) {
			return $url;
		} else {
			exit ;
		}
	} else if ($CONFIG['GETPROCEDURE'] == 1) {
		if (function_exists("curl_init")) {
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $holeurl);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
			curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $CONFIG['CURLTIMEOUT']);
			//    curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, TRUE);
			$url = curl_exec($ch);
			curl_close($ch);
			if ($url != "") {
				return $url;
			} else {
				exit ;
			}
		} else {
			$holeurl = str_ireplace('//', '', $holeurl);
			$pos = strpos($holeurl, '/');
			if ($pos > 0) {
				$remote_url = substr($holeurl, 0, $pos);
				$path = substr($holeurl, $pos);
			} else {
				$remote_url = $holeurl;
				$path = '';
			}
			$data = '';
			$throwcontenterror = true;
			$fsockopen = fsockopen($remote_url, 80);
			if ($fsockopen) {
				fputs($fsockopen, 'POST ' . $path . " HTTP/1.0\r\n");
				fputs($fsockopen, 'Host: ' . $remote_url . "\r\n");
				fputs($fsockopen, "Content-type: application/x-www-url-encoded\r\n");
				fputs($fsockopen, 'Content-length: ' . strlen($data) . "\r\n");
				fputs($fsockopen, "\r\n");
				fputs($fsockopen, $data . "\r\n");
				fputs($fsockopen, "\r\n");
				$tmp_headers = $content = '';
				while ($str = trim(fgets($fsockopen))) {
					$tmp_headers .= $str . "\n";
				}
				while (!feof($fsockopen)) {
					$content .= fgets($fsockopen);
				}
				fclose($fsockopen);
				if ($throwcontenterror) {
					if ($content == '') {
						echo('Es wurden keine Daten von: ' . $remote_url . $path . ' gesendet');
						die();
					}
				}
			} else {
				echo($remote_url . $path . ' ist unbekannt');
				die();
			}
			return $content;
		}
	} else {
		return array();
	}
}

function anmeldefenster() {
	global $CONFIG;
	$scripttext = <<<EOD
<script language="javascript" type="text/javascript">
	/*<![CDATA[*/
	  function k1popup(windowurl) {
	    var windowname = 'anmeldefenster';
	    var height = {$CONFIG['ANMELDEFENSTERHOEHE']};
	    var width = {$CONFIG['ANMELDEFENSTERBREITE']};
	    var nleft = 50;
	    var ntop = 50;
	    var options = 'top=' + ntop + ',left=' + nleft + ',height=' + height + ',width=' + width + ',scrollbars=no,status=no,location=no,menubar=no,resizable=yes,toolbar=no';
	    window.open(windowurl, windowname, options);
	  }
	/* ]]> */
</script>
EOD;
	return $scripttext;
}

function str_replace_from($text, $to_replace, $to_search, $from) {
	$beforetext = "";
	if ($from > 0) {
		$beforetext = substr($text, 0, $from - 1);
	}
	$aftertext = substr($text, $from);
	$aftertext = str_replace($to_search, $to_replace, $aftertext);
	$text = $beforetext . $aftertext;
	return $text;
}

if (!function_exists("smartText")) {
	/**
	 * Schneidet $text nach $length zeichen ab und haengt '...' an.
	 * @param string $text
	 * @param integer $length
	 * @return string
	 */
	function smartText($text, $length) {
		if (strlen($text) <= $length) {
			return $text;
		} else {
			/**
			 * Also bestenfalls length -3 wegen der zusaetzlichen 3 zeichen die angehaengt werden
			 * aber auf keinen fall length plus 3
			 * return substr($text, 0, $length+3) . "...";
			 * bestenfalls eingebaut, weil den wollen wir haben... /michel
			 **/
			return substr($text, 0, $length - 3) . "...";
		}
	}

}

if (!function_exists('display_install_inc')) {
	function display_install_inc($error, $link = null, $display_link = null) {
		global $CONFIG;
		$install_inc = DOCROOT . 'install.inc.php';
		// myecho($error);die();
		if (file_exists($install_inc)) {
			$messages = array();
			$messages[] = $error;
			include ($install_inc);
		} else {
			echo($error);
		}
		die();
	}

}
/**
 * sortiert die in der config.inc.php definierten Kategorien
 * nach der gewuenschten Reihenfolge
 * aus dem Array $kategorie nach den Arrayschluesseln
 * 'sort_order_top', 'sort_order_left', 'sort_order_right'
 * und 'sort_order_footer'
 *
 * @param string $sort_order_key
 * @param array $default
 * @return array
 */
if (!function_exists('get_categories_list')) {
	function get_categories_list($key, $default = null) {
		global $kategorieliste, $kategorie, $CATLINK, $CAT_COUNT;
		// myecho($key);
		// myecho($kategorie);
		// myecho($kategorieliste);
		$categories_list = array();
		// default sort order
		if (!is_null($default)) {
			$sort_order = $default;
		} elseif (isset($kategorieliste[$key]) && is_array($kategorieliste[$key]) && count($kategorieliste[$key]) > 0) {
			$sort_order = $kategorieliste[$key];
			// myecho('sort_order');
			// myecho($sort_order);
		} else {
			$sort_order = array(1, 2, 3, 4, 5, 6, 7, 9, 10, 11, 13, 14, 15, 16, 17, 18);
		}
		for ($i = 0, $n = count($sort_order); $i < $n; $i++) {
			$id = $sort_order[$i];
			if (isset($CATLINK[$id]) && isset($kategorie[$id]['bezeichnung']) && isset($CAT_COUNT[$id])) {
				$categories_list[] = array('id' => $id, 'name' => $kategorie[$id]['bezeichnung'], 'link' => $CATLINK[$id], 'title' => $kategorie[$id]['bezeichnung'], 'count' => $CAT_COUNT[$id]);
			}
		}
		// myecho($categories_list);
		return $categories_list;
	}

}
/**
 * Schaltet waehrend der Entwicklung und zur vereinfachten Fehlersuche
 * auf Livesystemen die PHP Fehlerausgabe ein und
 * gibt ein DIV mit den Einstellungen 'layout', 'language'
 * und 'Anmeldefenster' aus
 *
 * @param object $layout [optional]
 * @param object $popupdir [optional]
 * @return string
 */
if (!function_exists('set_development')) {
	function set_development($layout = null, $popupdir = null) {
		global $CONFIG;
		if (isset($_GET['debug'])) {
			$debug = $_GET['debug'];
			switch ($debug) {
				case 1 :
					$_SESSION['DEVELOPMENT'] = true;
					break;
				default :
					$_SESSION['DEVELOPMENT'] = false;
			}
		}
		if (!isset($_SESSION['DEVELOPMENT'])) {
			$_SESSION['DEVELOPMENT'] = false;
		}
		$CONFIG['DEVELOPMENT'] = $_SESSION['DEVELOPMENT'];

		if (isset($CONFIG['DEVELOPMENT']) && $CONFIG['DEVELOPMENT']) {
			if (!isset($layout)) {
				$layout = $CONFIG['LAYOUT'];
			}
			if (!isset($popupdir)) {
				$popupdir = $CONFIG['POPUPDIR'];
			}
			$div_development = '<div style="border:1px solid #000;z-index:10;top:100px;left:10px;position:absolute;background-color:#FFF;color:#000;font-family:verdana, arial;font-size:12px;padding:10px;width:150px;min-height:80px;height:auto;text-align:left;">
 	<span style="color:#F00;">ACHTUNG - Development</span><br/>
	Layout: ' . $layout . '<br/>
	Anmeldefenster: ' . $popupdir . '<br/>
	language: ' . $CONFIG['LANGUAGE'] . '
 	</div>';
			@error_reporting(E_ALL | E_NOTICE | E_STRICT);
			@ini_set('display_errors', '1');
			$CONFIG['LOG'] = 1;
			$CONFIG['CACHE'] = 0;
			$CONFIG['LOG_TEXT'] = '';
		} else {
			@ini_set('display_errors', '0');
			$div_development = '';
		}
		return $div_development;
	}

}
/**
 * wandelt wenn noetig die uebergebenen Daten in UTF-8
 * wobei bei Arrays noch auf vorhandensein eines
 * bestimmten Schuessels kontrolliert wird
 * @param object $array
 * @param string $search_key
 * @return $array
 */
if (!function_exists('config_data_to_utf8')) {
	function config_data_to_utf8($array, $search_key) {
		// myecho($array);
		if (is_array($array)) {
			$bResult = array();
			for ($i = 0, $n = count($array); $i < $n; $i++) {
				// myecho($array[$i]);
				if (isset($array[$i])) {
					// myecho($array[$i]);
					if (!is_null($search_key) && key_exists($search_key, $array[$i])) {
						foreach ($array[$i] as $key => $value) {
							$bResult[$i][$key] = utilities::__utf8_encode($value);
						}
					} else {
						$bResult[$i] = utilities::__utf8_encode($array[$i]);
					}
				} else {
					$bResult = null;
					break;
				}
			}
			if (is_null($bResult)) {
				$bResult = array();
				if (!is_null($search_key) && key_exists($search_key, $array)) {
					foreach ($array as $key => $value) {
						$bResult[$key] = utilities::__utf8_encode($value);
					}
				} else {
					for ($i = 0, $n = count($array); $i < $n; $i++) {
						$bResult[$i] = utilities::__utf8_encode($array[$i]);
					}
				}
			}
		} else {
			$bResult = utilities::__utf8_encode($array);
		}
		return $bResult;
	}

}
/**
 * sendet eine Email an den Support
 * wenn ein bestimmter Fehler auftritt
 * die Versendung ist auf eine Email täglich begrenzt
 * @param string $directory
 * @return boolean
 */
if (!function_exists('support_mail')) {
	function support_mail($directory) {
		global $CONFIG;
		// Verzeichnis ist nicht beschreibar
		$log_text = $directory . ' ist nicht beschreibbar, der Inhalt der Textdateien kann nicht in UTF-8 umgewandelt werden';
		savelog($log_text);
		// ErrorMail an 777live senden
		// supportmail textfile ueberpruefen
		$support_mail_file = $CONFIG['TEMPDIR'] . 'timestamp_supportmail.txt';
		$time_stamp = 0;
		if (is_file($support_mail_file)) {
			$time_stamp = trim(str_replace("\n", '', file_get_contents($support_mail_file)));
		}
		if (time() - $time_stamp > 1 * 60 * 60 * 24) {
			$mail_text = $log_text . "\n\n" . $CONFIG['WMID'];
			$mail_subject = $CONFIG['DOMAIN'] . ' Verzeichnisrechte - Textfiledirectory nicht beschreibbar';
			if (!@mail('andreas@777live.com', $mail_subject, $mail_text, "FROM: 777script@" . $CONFIG['DOMAIN'] . " <noreply@" . $CONFIG['DOMAIN'] . ">")) {
				savelog('Mail an Support "Betreff: Verzeichnisrechte" konnte nicht versendet werden');
			}
			file_put_contents($support_mail_file, time());
		}
		return true;
	}

}

/**
 * Prueft ein Verzeichnis auf beschreibbar
 * durch den Versuch eine Textdatei zu erstellen,
 * wenn dies moeglich ist, wird true
 * ansonsten false zurueck gegeben
 * @return boolean
 * @param string $directory
 */
if (!function_exists('create_testfile')) {
	function create_testfile($directory) {
		global $CONFIG;
		$reset_logging = $CONFIG['LOG'];
		$CONFIG['LOG'] = 1;
		$bResult = true;
		// versuchen eine Datei zu erstellen in diesem Verzeichnis,
		// wenn dies nicht moeglich ist, wird die Fehlernachricht
		// um die Aufforderung das Verzweichnis neu zu erstellen erweitert
		$test_directory = $directory;
		if (substr($directory, strlen($directory) - 1) != '/') {
			$test_directory .= '/';
		}
		if (!is_dir($test_directory)) {
			$message = $test_directory . ' ist nicht vorhanden';
			$bResult = false;
		}
		if ($bResult) {
			$test_file = $test_directory . 'test.txt';
			if ($fp = @fopen($test_file, 'w')) {
				fputs($fp, $content);
				fclose($fp);
				$bResult = true;
				unlink($test_file);
				$message = 'Testfile: ' . $test_file . ' wurde erstellt';
			} else {
				$message = 'Testfile: ' . $test_file . ' konnte nicht erstellt werden';
				$bResult = false;
			}
		}
		savelog($message);
		$CONFIG['LOG'] = $reset_logging;
		return $bResult;
	}

}
/**
 * durchsucht ein Verzeichnis auf das
 * Vorhandensein von Dateien
 * wenn mindestens eine Datei gefunden wurde
 * wird true zurueck gegeben,
 * ansonsten false
 * @return boolean
 * @param string $directory
 */
if (!function_exists('search_in_directory')) {
	function search_in_directory($directory) {
		$bResult = false;
		if ($dh = @opendir($directory)) {
			while (($file = readdir($dh)) !== false) {
				if ($file != "." && $file != ".." && is_file($directory . $file)) {
					$bResult = true;
					break;
				}
			}
			closedir($dh);
		} else {
			$bResult = false;
		}
		return $bResult;
	}

}
/**
 * decode HTML-encodete Textsonderzeichen in normale Textzeichen
 * weil nicht immer html_entities_decode funktioniert
 * @param string $text
 * @return string
 */
if (!function_exists('entities_decode')) {
	function entities_decode($text) {
		$chars = array('ü', 'ä', 'ö', 'Ü', 'Ä', 'Ö', 'ß');
		$entities = array('&uuml;', '&auml;', '&ouml;', '&Uuml;', '&Auml;', '&Ouml;', '&szlig;');
		foreach ($chars as $char) {
			$text = str_replace($entities, $char, $text);
		}
		$text = str_replace('&amp;', '&', $text);
		return $text;
	}

}
/**
 * konvertiert den Namen einer Show so,
 * das er nachher mit in den Link eingesetzt werden kann,
 * denn wenn die eine Zahl in ihrem Shownamen hat,
 * wurde immer die 404Error.php angezeigt
 * @param string $string
 * @return string
 */
if (!function_exists('create_cam_name_for_link')) {
	function create_cam_name_for_link($string) {
		// $string = 'andre01';
		// myecho($string);
		$string = utilities::fixUTF8($string);
		$string = strtolower($string);
		$string = replace_ltext($string);
		$search = '#[0-9]#';
		$string = preg_replace($search, '', $string);
		$string = preg_replace("#['*?]#", '', $string);
		$string = urlencode($string);
		// myecho($string);
		// die();
		return $string;
	}

}

/**
 * erstellt die verschiedenen Links
 * - Anmeldung
 * - Login
 * - voice
 * @param array $sender
 * @return array
 */
if (!function_exists('create_link')) {
	function create_link($sender, $targeturl, $targeturl64) {
		global $CONFIG;
		$link = array();
		if (!is_null($sender) && isset($sender['NAME']) && isset($sender['CAMID']) && is_numeric($sender['CAMID']) && $sender['CAMID'] > 0) {
			$cam_targeturl64 = createCamTargetUrl64($sender['CAMID']);
			$link["camlogin"] = (($CONFIG['PATH'] == "/") ? "" : $CONFIG['PATH']) . "/remoteregister.php?id=" . $CONFIG["WMID"] . "&amp;targeturl=" . $cam_targeturl64 . "&amp;camid=" . $sender['CAMID'] . "&amp;name=" . urlencode($sender['NAME']);
			$link["anonymzugang"] = "https://www.777livecams.com/billing/voicecall_transfer.php?id=" . $CONFIG["WMID"] . "&amp;targeturl=" . $cam_targeturl64 . "&amp;camid=" . $sender['CAMID'] . "&amp;name=" . urlencode($sender['NAME']);
			$link["memberlogin"] = (($CONFIG['PATH'] == "/") ? "" : $CONFIG['PATH']) . "/remotelogin.php?bid={$CONFIG['WMID']}&amp;camid={$sender['CAMID']}&amp;name=" . urlencode($sender['NAME']) . "&amp;targeturl={$cam_targeturl64}=&amp;language={$CONFIG['LANGUAGE']}";
			$link["lostpassword"] = (($CONFIG['PATH'] == "/") ? "" : $CONFIG['PATH']) . "/remotepassword.php?id=" . $CONFIG["WMID"] . "&amp;targeturl=" . $cam_targeturl64 . "&amp;camid=" . $sender['CAMID'] . "&amp;name=" . urlencode($sender['NAME']);
			$link['memberlogin_by_form'] = "https://member.777livecams.com/?id=" . $CONFIG["WMID"] . "&amp;targeturl=" . $cam_targeturl64 . "&amp;camid=" . $sender['CAMID'] . "&amp;name=" . urlencode($sender['NAME']);
		} else {
			$link["camlogin"] = (($CONFIG['PATH'] == "/") ? "" : $CONFIG['PATH']) . "/remoteregister.php?id=" . $CONFIG["WMID"] . "&amp;targeturl=" . $targeturl64;
			$link["anonymzugang"] = "https://www.777livecams.com/billing/voicecall_transfer.php?id=" . $CONFIG["WMID"] . "&amp;targeturl=" . $targeturl;
			$link['memberlogin_by_form'] = "https://member.777livecams.com/?id=" . $CONFIG["WMID"];
			$link["lostpassword"] = (($CONFIG['PATH'] == "/") ? "" : $CONFIG['PATH']) . "/remotepassword.php?id=" . $CONFIG["WMID"] . "&amp;targeturl=" . $targeturl64;
			$link["memberlogin"] = (($CONFIG['PATH'] == "/") ? "" : $CONFIG['PATH']) . "/remotelogin.php?bid={$CONFIG['WMID']}&amp;id=" . $CONFIG["WMID"] . "&amp;targeturl=" . $targeturl64 . "&amp;language={$CONFIG['LANGUAGE']}";
		}
		if ($CONFIG["LIVECAMLAYOUT"] != "") {
			$link["camlogin"] .= "&amp;l=" . $CONFIG["LIVECAMLAYOUT"];
			$link["anonymzugang"] .= "&amp;l=" . $CONFIG["LIVECAMLAYOUT"];
			$link["memberlogin"] .= "&amp;l=" . $CONFIG["LIVECAMLAYOUT"];
			$link['memberlogin_by_form'] .= "&amp;l=" . $CONFIG["LIVECAMLAYOUT"];
		}
		if (isset($CONFIG['HEADER']) && $CONFIG['HEADER'] == 'off') {
			$link["camlogin"] .= "&amp;h=" . $CONFIG['HEADER'];
			$link["anonymzugang"] .= "&amp;h=" . $CONFIG['HEADER'];
			$link["memberlogin"] .= "&amp;h=" . $CONFIG['HEADER'];
			$link['memberlogin_by_form'] .= "&amp;h=" . $CONFIG['HEADER'];
		}
		if (isset($CONFIG['LANGUAGE']) && $CONFIG['LANGUAGE'] != 'de') {
			$link["camlogin"] .= "&amp;setup_language=" . $CONFIG['LANGUAGE'];
			$link["anonymzugang"] .= "&amp;setup_language=" . $CONFIG['LANGUAGE'];
			$link["memberlogin"] .= "&amp;setup_language=" . $CONFIG['LANGUAGE'];
			$link['memberlogin_by_form'] .= "&amp;setup_language=" . $CONFIG['LANGUAGE'];
		}

		$link["besender"] = "https://bizzgirls.com;
		$link["bewebmaster"] = "https://777partner.com/?id=" . $CONFIG["WMID"];
		return $link;
	}

}

if (!function_exists('get_image_id')) {
	function get_image_id($string) {
		global $PICLINKZ, $CONFIG;
		$bResult = -1;
		$found = false;
		// myecho($string);
		if (strpos($string, '/') !== false) {
			$parts = preg_split('#/#', $string);
		} else {
			$parts = array($string);
		}
		// myecho(count($parts));
		// myecho(count($PICLINKZ));
		if (count($parts) != count($PICLINKZ)) {
			if (count($parts) < count($PICLINKZ)) {
				$parts = array_merge($parts, array(''));
			}
		}
		// myecho(count($parts));
		// myecho(count($PICLINKZ));
		// myecho($parts);
		for ($i = 0, $n = count($PICLINKZ); $i < $n; $i++) {
			$part = $PICLINKZ[$i];
			if (strpos($part, '{id}') !== false) {
				// myecho($part);
				// Teil der URL welche die ID enthalten muss
				if (isset($parts[$i])) {
					// myecho('OK');
					$part_with_id = $parts[$i];
					// myecho($part_with_id);
					$search = '#[0-9]{6,}#';
					$search = '#[\.a-zA-Z_-]#';
					$bResult = preg_replace($search, '', $part_with_id);
					// myecho($bResult);
					// die();
					if (strlen($bResult) > 5 && is_numeric($bResult)) {
						$found = true;
					}
					break;
				}
			}
		}
		if (!$found) {
			// alle parts nach einer ID durchsuchen
			foreach ($parts as $part) {
				$search = '#[\.a-zA-Z_-]#';
				$bResult = preg_replace($search, '', $part);
				// myecho($bResult);
				// die();
				// myecho(preg_match('#[0-9]{6,}#', $part));
				if (preg_match('#[0-9]{6,}#', $part)) {
					$found = true;
					break;
				}
			}
		}
		if (!$found) {
			$error = 'in ' . $string . ' wurde keine Bildid gefunden';
			savelog($error);
			die('get_image_id: ' . $error);
		}
		// myecho($bResult);die();
		return $bResult;
	}

}
/**
 * liest aus einer URL die Bildgroessen
 * @param string $url
 * @return array
 */
if (!function_exists('get_image_sizes')) {
	function get_image_sizes($url) {
		global $PICLINKZ, $CONFIG;
		$bResult = array();
		$found = false;
		if (strpos($url, '/') !== false) {
			$parts = preg_split('#/#', $url);
		} else {
			$parts = array($url);
		}
		// myecho($parts);
		for ($i = 0, $n = count($PICLINKZ); $i < $n; $i++) {
			$part = $PICLINKZ[$i];
			if ($part == '{width}') {
				// Teil der URL welche die ID enthalten muss
				if (isset($parts[$i])) {
					if (is_numeric($parts[$i])) {
						$bResult['width'] = $parts[$i];
					} else {
						$bResult['width'] = 320;
					}

				}
			}
			if ($part == '{height}') {
				// Teil der URL welche die ID enthalten muss
				if (isset($parts[$i])) {
					if (is_numeric($parts[$i])) {
						$bResult['height'] = $parts[$i];
					} else {
						$bResult['height'] = 240;
					}
				}
			}
		}
		if (count($bResult) == 0) {
			$bResult['width'] = 320;
			$bResult['height'] = 240;
			if ($CONFIG['LOG'] == 1) {
				savelog($url . ' konnten keine Bildgroessen ermittelt werden');
			}
		}
		return $bResult;
	}

}
/**
 * ersetzt die Platzhalter {width} und {height}
 * durch die richtigen Werte
 * @param array $image_urls
 * @param integer $width
 * @param integer $height
 * @return array
 */
if (!function_exists('set_image_sizes_to_url')) {
	function set_image_sizes_to_url($image_urls, $width = 320, $height = 240, $camid = null) {
		global $CONFIG;
		if ($CONFIG['SAVEIMAGES'] == 1) {
			if (is_array($image_urls)) {
				// myecho($image_urls);
				$i = 0;
				foreach ($image_urls as $image_url) {
					if (strpos($image_url, '//') !== false) {
						$image_url = str_ireplace('//', '/', $image_url);
					}
					// myecho($image_url);
					$image_urls[$i] = str_replace(array('{width}', '{height}'), array($width, $height), $image_url);
					$i++;
				}
				// die();
			} else {
				if (strpos($image_urls, '//') !== false) {
					$image_urls = str_ireplace('//', '/', $image_urls);
				}
				$image_urls = str_replace(array('{width}', '{height}'), array($width, $height), $image_urls);
			}
		} else {
			// images from mm.777parter.com;
			if (!set_actual_mm_server()) {
				$CONFIG['MM_SERVER'] = 'mm.7-7-7-partner.com';
			}
			// camid?
			if (is_null($camid)) {
				// myecho('camid muss mit übergeben werden');
				// die();
				return $image_urls;
			}

			if (is_array($image_urls)) {
				$u = $i = 1;
				foreach ($image_urls as $image_url) {
					// size
					$size_and_image_type = substr($image_url, strripos($image_url, '_') + 1);
					$image_urls[($u - 1)] = '//' . $CONFIG['MM_SERVER'] . '/images/' . $camid . '_' . $i . '_' . $size_and_image_type;
					$i++;
					$u++;
					if ($i > 3) {
						$i = 0;
					}
				}
			} else {
				// size
				$size_and_image_type = substr($image_urls, strripos($image_urls, '_') + 1);
				$image_urls = '//' . $CONFIG['MM_SERVER'] . '/images/' . $camid . '_1_' . $size_and_image_type;
			}
		}
		return $image_urls;
	}

}

if (!function_exists('set_actual_mm_server')) {
	function set_actual_mm_server() {
		global $CONFIG, $docroot;
		$bResult = false;
		if(!isset($remote_file)){
			$remote_file = 'https://mm.7-7-7-partner.com/_xml/777script/cleanup.xml';
		}
		if (!isset($CONFIG['MM_SERVER'])) {
			$cleanup_xml_file = $docroot.$CONFIG['TEMPDIR'] . 'cleanup.xml';
			if (!is_file($cleanup_xml_file)) {

				$remote_xml_file = $data = file_get_contents($remote_file);
				if (!file_put_contents($cleanup_xml_file, $data)) {
					savelog($cleanup_xml_file . ' konnte nicht gespeichert werden');
				}else{
					@chmod($cleanup_xml_file, 0666);
				}
			}
			if (!is_file($cleanup_xml_file)) {

			} else {
				if ($xml = simplexml_load_file($cleanup_xml_file)) {
					$replaces = $xml->replaces->replace;
					// myecho($replaces);
					// myecho(count($replaces));
					$last_replace = (string)$replaces[count($replaces) - 1];
					$splited = explode('|', $last_replace);
					$mm_server = trim($splited[1]);
					// myecho($mm_server);die();
					$CONFIG['MM_SERVER'] = $mm_server;
					$bResult = true;
				} else {
					$bResult = false;
				}
			}
		} else {
			$bResult = true;
		}
		return $bResult;
	}

}

if (!function_exists('loadThumbnails')) {
	function loadThumbnails() {
		global $CONFIG;
		$thumbs_directory = DOCROOT . $CONFIG['IMAGEDIR'] . 'thumbs/';
		$files = null;
		if (is_dir($thumbs_directory)) {
			$files = scandirneu($thumbs_directory);
		}
		if (!is_null($files) && count($files) > 0) {
			$thumbnails = array();
			if (!is_null($files) && count($files) > 0) {
				foreach ($files as $file) {
					if (substr($file, strripos($file, '.') + 1) == 'jpg') {
						$thumbnails[] = $thumbs_directory . $file;
					}
				}
			}
		}
		return $thumbnails;
	}
}

if (!function_exists('deletePreviewPicByPicId')) {
	function deletePreviewPicByPicId($pic_id) {
		global $CONFIG, $thumbnails;
		$bResult = false;
		if (is_null($thumbnails)) {
			$thumbnails = loadThumbnails();
		}
		// vorschaubild loeschen
		$preview_picture = DOCROOT . $CONFIG['IMAGEDIR'] . $pic_id . '.jpg';
		// myecho($preview_picture);
		if (is_file($preview_picture)) {
			// myecho($preview_picture. ' wird geloescht');
			@unlink($preview_picture);
			$bResult = true;
		}
		// thumbnials loeschen
		if (is_array($thumbnails) && count($thumbnails) > 0) {
			foreach ($thumbnails as $thumbnail) {
				$prefix = $pic_id . '_';
				if (strpos($thumbnail, $prefix) !== false) {
					if (is_file($thumbnail)) {
						// myecho($thumbnail. ' wird geloescht');
						@unlink($thumbnail);
						$bResult = true;
					}
				}
			}
		}
		return $bResult;
	}
}

/**
 * ermittelt aus einem Teil der URL die Bildid wenn moeglich
 * @param string $wort
 * @param integer $stelle
 * @return integer
 */
if (!function_exists('test_bild')) {
	function test_bild($wort, $stelle) {
		global $PICLINKZ;
		$sik_wort = $wort;
		$wort = preg_replace("/([0-9]+)/", "", $wort);
		$test1 = str_replace("{id}", "", $PICLINKZ[$stelle]);
		if ($wort == $test1 && $test1 != $PICLINKZ[$stelle]) {
			if (preg_match("/([0-9]+)/", $sik_wort, $sid)) {
				return $sid[1];
			}
		}
		return -1;
	}

}
/**
 * aktualisiert eine lokale Datei mit
 * Daten einer Datei von einem anderen Server
 * @param string $remote_file
 * @param string $local_file
 * @return boolean
 */
function updateFileFromRemote($remote_file, $local_file, $time = 86400) {
	$bResult = true;
	if (!is_file($local_file) || time() - filemtime($local_file) > $time) {
		$content = get_content($remote_file);
		if (!file_put_contents($local_file, $content)) {
			$bResult = false;
		}else{
			@chmod($local_file, 0666);
		}
	}
	return $bResult;
}

/**
 * ueberprueft ob eine Show
 * bei ruf777 angemeldet und online oder offline ist
 * @return integer
 * 0 = nicht angemeldet
 * 1 = offline
 * 2 = online
 */
if (!function_exists('hasPhone()')) {
	function hasPhone($camid) {
		global $CONFIG;
		$bResult = 0;
		$error = null;
		$timediff = 1200;
		// myecho($camid);
		// $camid = 30691;
		try {
			if (!isset($CONFIG['MM_SERVER']) && !set_actual_mm_server()) {
				throw new Exception('Fehler MM_SERVER konnte nicht gesetzt werden in hasPhone');
			}
			$remote_xml_file = 'https://' . $CONFIG['MM_SERVER'] . '/_xml/ruf777/online.xml.php';
			$xml_file = $CONFIG['TEMPDIR'] . 'ruf777.xml';
			if (!updateFileFromRemote($remote_xml_file, $xml_file, $timediff)) {
				throw new Exception($xml_file . ' konnte aktualisiert werden');
			}
			$content = file_get_contents($xml_file);
			if(strpos($content, '<html>') !== false){
				// tue mal im moment nichts	
			}else{
				if (!$xml = @simplexml_load_file($xml_file)) {
					throw new Exception($xml_file . ' konnte nicht geladen werden');
				}
				// myecho($xml);
				$query = '/caminfos/caminfo[id = "' . $camid . '"]';
				$results = $xml->xpath($query);
				if (!is_null($results) && count($results) > 0) {
					$ruf_data = $results[0];
					$text = '';
					$online = (int)$ruf_data->phone_info->status->online;
					$bResult = 1;
					if ($online == 1) {
						$bResult = 2;
					}
				}
				if (isset($xml)) {
					unset($xml);
				}	
			}			
		} catch(Exception $e) {
			savlog($e->getMessage());
		}
		// myecho($bResult);
		return $bResult;
	}

}

function alert($text) {
	$text = str_ireplace(array("'", '""'), array("\'", '"\"'), $text);
	echo('<script type="text/javascript"> alert("' . $text . '"); </script>');
}

/**
 * mit dieser Funktion werden spezielle vom Webmaster erstellte Texte zur aktuellen Kategorie
 * in der Seite gesucht, damit sie spaeter in der Seite angezeigt werden koennen
 * @param {integer} 		$catid->Kategorieid
 * @param (string)  optional 	$text_file_prefix->Vorsilbe fuer eine eindeutige Kennung des Textfiles
 * @param (string)  optional 	$text_file_subdirectory->UnterVerzeichnis in dem sich das Textfile befinden soll
 * @param {boolean} optional	$plain  - true der Text in HTML formatiert, es koennen keine im Text enthaltene HTML-TAGS ausgefuehrt werden)
 *            				- false der Text wird so ausgegeben wie er in der Textdatei steht
 *
 * @return {}string		einen zufaelligen Text enstprechend der der uebergebenen Parameter
 */

if (!function_exists('getCategoryText')) {
	function getCategoryText($catid, $text_file_prefix = 'category_', $text_file_subdirectory = 'category/', $plain = false) {
		global $CONFIG, $kategorie;
		$bResult = '';
		if (isset($CONFIG['OWN_TEXT_FOR_CATEGORIES']) && $CONFIG['OWN_TEXT_FOR_CATEGORIES'] == 1 && is_numeric($catid)) {
			// jetzt die Textdatei suchen
			$text_file_name = $text_file_prefix . $catid . '.' . $CONFIG['LANGUAGE'] . '.txt';
			$text_file_directory = $CONFIG['TXTDIR'] . $text_file_subdirectory;
			// nachsehen ob das Verzeichnis vorhanden ist
			if (!is_dir($text_file_directory)) {
				// Verzeichnis muss erstellt werden
				chmod($CONFIG['TXTDIR'], 0777);
				mkdir($text_file_directory, 0777);
			}
			$text_file = $text_file_directory . $text_file_name;
			// myecho($text_file);
			$text = $kategorie[$catid]["bezeichnung"] . ': ' . $kategorie[$catid]["beschreibung"];
			if (is_file($text_file)) {
				$content = trim(file_get_contents($text_file));
				if (!utilities::isUTF8($content)) {
					// myecho ('TEXT ist nicht UTF8');
					$content = utilities::fixUTF8($content);
					file_put_contents($text_file, $content);
					@chmod($text_file, 0666);
				}
				$bResult = $content;
			} else {
				if (!@file_put_contents($text_file, $text)) {
					savelog('failed to open: ' . $text_file);
				} else {
					@chmod($text_file, 0666);
					$bResult = $text;
					// die ID der neu erstellten Textdatei in einer Textdatei
					// mit automatisch erstellten Textdateien fuer KategorieTexte speichern
					// damit der Webmaster weiss, welche Dateien erstellt worden sind
					// und diese mit einem eigenen Text bestuecken kann
					$textfile_counter_file = $CONFIG['TXTDIR'] . 'created_categorytext_files.txt';
					$line = $text_file . "\n";
					if (!$fp = @fopen($textfile_counter_file, 'a')) {
						savelog('failed to open: ' . $textfile_counter_file);
					} else {
						fputs($fp, date('Y-m-d H:i:s', time()) . " - " . $line);
						fclose($fp);
						@chmod($textfile_counter_file, 0666);
					}
				}
			}
			if (strpos($bResult, "\n") !== false) {
				$lines = preg_split("#\n#", $bResult);
				shuffle($lines);
				$bResult = $lines[0];
			}
		}
		if ($plain) {
			// bResult wird in HTML encoded
			$bResult = htmlentities($bResult);
		}
		return $bResult;
	}

}

/**
 * mit dieser Funktion werden spezielle vom Webmaster erstellte Texte zur aktuellen Sedcard
 * in der Seite gesucht, damit sie spaeter in der Seite angezeigt werden koennen
 * @param {integer} 			$camid->Camid
 * @param (string)  optional 	$text_file_subdirectory->UnterVerzeichnis in dem sich das Textfile befinden soll
 * @param {boolean} optional	$plain  - true der Text in HTML formatiert, es koennen keine im Text enthaltene HTML-TAGS ausgefuehrt werden)
 *                          			- false der Text wird so ausgegeben wie er in der Textdatei steht
 *
 * @return {}string				einen Text enstprechend der der uebergebenen Parameter
 */
if (!function_exists('getSedcardText')) {

	function getSedcardText($camid, $text_file_subdirectory = 'sedcard/', $plain = true) {
		global $CONFIG;
		$bResult = '';
		if (isset($CONFIG['SEDCARD_TEXT']) && $CONFIG['SEDCARD_TEXT'] == 1 && is_numeric($camid)) {
			// jetzt die Textdatei suchen
			$text_file_name = $camid . '.' . $CONFIG['LANGUAGE'] . '.txt';
			$text_file_directory = $CONFIG['TXTDIR'] . $text_file_subdirectory;
			// nachsehen ob das Verzeichnis vorhanden ist
			if (!is_dir($text_file_directory)) {
				// Verzeichnis muss erstellt werden
				chmod($CONFIG['TXTDIR'], 0777);
				mkdir($text_file_directory, 0777);
			}
			$text_file = $text_file_directory . $text_file_name;
			if (is_file($text_file)) {
				$content = trim(file_get_contents($text_file));
				if (!utilities::isUTF8($content)) {
					// myecho ('TEXT ist nicht UTF8');
					$content = utilities::fixUTF8($content);
					file_put_contents($text_file, $content);
					@chmod($text_file, 0666);
				}
				$bResult = $content;
			} else {
				$xml_file = $CONFIG['TEMPDIR'] . $camid . '.xml';
				if (is_file($xml_file)) {
					$xml = simplexml_load_file($xml_file);
					$text = (string)$xml->beschreibung;
					// $text .= 'Gebe einen eigenen Text ein';
					if (isset($xml)) {
						unset($xml);
					}
					file_put_contents($text_file, $text);
					@chmod($text_file, 0666);
					$bResult = $text;
					// die ID der neu erstellten Textdatei in einer Textdatei
					// mit automatisch erstellten Textdateien fuer Sedcardtexten speichern
					// damit der Webmaster weiss, welche Dateien erstellt worden sind
					// und diese mit einem eigenen Text bestuecken kann
					$textfile_counter_file = $CONFIG['TXTDIR'] . 'created_sedcardtext_files.txt';
					$line = $text_file . "\n";
					if (!$fp = @fopen($textfile_counter_file, 'a')) {
						savelog('failed to open: ' . $textfile_counter_file);
					} else {
						fputs($fp, date('Y-m-d H:i:s', time()) . " - " . $line);
						fclose($fp);
						@chmod($textfile_counter_file, 0666);
					}
				}

			}
		}
		if (!$plain) {
			// bResult wird in HTML encoded
			$bResult = htmlentities($bResult);
		}
		return $bResult;
	}

}

/**
 * Adds a CDATA property to an XML document.
 *
 * @param string $name
 *   Name of property that should contain CDATA.
 * @param string $value
 *   Value that should be inserted into a CDATA child.
 * @param object $parent
 *   Element that the CDATA child should be attached too.
 */
if (!function_exists('add_child')) {
	function add_cdata($name, $value, &$parent) {
		$child = $parent->addChild($name);

		if ($child !== NULL) {
			$child_node = dom_import_simplexml($child);
			$child_owner = $child_node->ownerDocument;
			$child_node->appendChild($child_owner->createCDATASection($value));
		}

		return $child;
	}

}

if (!function_exists('loadMySedcardDatas')) {
	function loadMySedcardDatas($camid) {
		global $CONFIG;
		$bResult = null;
		$valid = true;
		$xml_file_name = 'my_sedcard_datas.xml';
		$xml_file = $CONFIG['TEMPDIR'] . $xml_file_name;
		if (!is_file($xml_file)) {
			savelog($xml_file . ' wurde nicht gefunden');
			$valid = false;
			$dom = new DOMDocument('1.0', 'utf-8');
			$dom->preserveWhiteSpace = false;
			$dom->formatOutput = true;
			$root = $dom->createElement('sedcards');
			$parent = $dom->createElement('sedcard');
			$parent->setAttribute('camid', -1);
			$parent->setAttribute('edited', 'true');
			$root->appendChild($parent);
			$dom->appendChild($root);
			$dom->save($xml_file);
			@chmod($xml_file, 0666);
			$valid = true;
		}
		
		// myecho(simplexml_load_file($xml_file)); die();
		if ($valid && $xml = simplexml_load_file($xml_file)) {
			$query = '/sedcards/sedcard[@camid="' . $camid . '"]';
			// myecho($query);die();
			$results = $xml->xpath($query);
			if (!is_null($results) && count($results) > 0) {
				// myecho($result);die();
				$bResult = $results[0];
			} else {
				// aktuellen Sedcarddaten aus der Camid XML-datei laden
				$sedcard_data_xml_file = $CONFIG['TEMPDIR'] . $camid . '.xml';
				// myecho($sedcard_data_xml_file);die();
				if (is_file($sedcard_data_xml_file)) {
					$sedcard_data_xml = simplexml_load_file($sedcard_data_xml_file);
					$text_description = (string)$sedcard_data_xml->beschreibung;
					$text_shortdescription = (string)$sedcard_data_xml->shortdescription;
					$text_meta_description = (string)$sedcard_data_xml->beschreibung;
					$text_meta_title = (string)$sedcard_data_xml->name . ' - ' . (string)$sedcard_data_xml->hobbies;
					$text_meta_keywords = (string)$sedcard_data_xml->erointressen;

					// append sedcard to xml
					$child_sedcard = $xml->addChild('sedcard');
					$child_sedcard->addAttribute('camid', $camid);
					$child_sedcard->addAttribute('edited', 'false');
					$nodes = array();
					$nodes[] = array('name' => 'description', 'value' => $text_description);
					$nodes[] = array('name' => 'shortdescription', 'value' => $text_shortdescription);
					$nodes[] = array('name' => 'meta_description', 'value' => $text_meta_description);
					$nodes[] = array('name' => 'meta_title', 'value' => $text_meta_title);
					$nodes[] = array('name' => 'meta_keywords', 'value' => $text_meta_keywords);
					foreach ($nodes as $node) {
						$name = $node['name'];
						$value = $node['value'];
						add_cdata($name, $value, $child_sedcard);
					}
					if (class_exists('DOMDocument')) {
						$dom = new DomDocument('1.0', 'utf-8');
						$dom->preserveWhiteSpace = false;
						$dom->formatOutput = true;
						$dom->loadXML($xml->asXML());
						if (!@$dom->save($xml_file)) {
							savelog('save: ' . $xml_file . ' failed');
						}else{
						  @chmod($xml_file, 0666); 
                        }
						if (isset($dom)) {
							unset($dom);
						}
					} else {
						if (!@$xml->asXml($xml_file)) {
							savelog('save: ' . $xml_file . ' failed');
						}else{
                          @chmod($xml_file, 0666); 
                        }
					}
					if (isset($sedcard_data_xml)) {
						unset($sedcard_data_xml);
					}
					$bResult = $child_sedcard;
				}
			}
			if (isset($xml)) {
				unset($xml);
			}
		}
		return $bResult;
	}

}

if (!function_exists('loadMyCategoryMetas')) {
	function loadMyCategoryMetas($catid, $page = 1) {
		global $CONFIG, $meta, $kategorie;
		$bResult = $results = null;
		$valid = true;
		$xml_file_name = 'category_meta_' . $catid . '.xml';
		$xml_file = $CONFIG['TEMPDIR'] . $xml_file_name;
		if (isset($kategorie[$catid])) {
			$category = $kategorie[$catid];
			if (!is_file($xml_file)) {
				if (class_exists('DOMDocument')) {
					$dom = new DomDocument('1.0', 'utf-8');
					$dom->preserveWhiteSpace = false;
					$dom->formatOutput = true;
					$child_pages = $dom->createElement('pages');
					$child_page = $dom->createElement('page');
					$child_page->setAttribute('id', 1);
					$child_page->setAttribute('edited', 'false');
					$child_page_text = $dom->createElement('page_text');
					$cdata_page_text = $dom->createCDataSection($category['bezeichnung'] . ' - ' . $category['beschreibung']);
					$child_page_text->appendChild($cdata_page_text);
					$child_page_description = $dom->createElement('meta_description');
					$cdata_page_description = $dom->createCDataSection($category['bezeichnung'] . ': ' . $category['beschreibung']);
					$child_page_description->appendChild($cdata_page_description);
					$child_page_title = $dom->createElement('meta_title');
					$cdata_page_title = $dom->createCDataSection($category['titel'] . ' - Seite: ' . $page);
					$child_page_title->appendChild($cdata_page_title);
					$child_page_keywords = $dom->createElement('meta_keywords');
					$cdata_page_keywords = $dom->createCDataSection($category['keywords']);
					$child_page_keywords->appendChild($cdata_page_keywords);
					$child_page->appendChild($child_page_text);
					$child_page->appendChild($child_page_description);
					$child_page->appendChild($child_page_title);
					$child_page->appendChild($child_page_keywords);
					$child_pages->appendChild($child_page);
					$dom->appendChild($child_pages);
					if (!@$dom->save($xml_file)) {
						savelog('save: ' . $xml_file . ' failed');
						$valid = false;
					} else {
						@chmod($xml_file, 0666);
					}
					if (isset($dom)) {
						unset($dom);
					}
				} else {
					$valid = false;
				}
			}
			if ($valid && $xml = simplexml_load_file($xml_file)) {
				$query = '/pages/page[@id="' . $page . '"]';
				// myecho($query);
				$results = $xml->xpath($query);
				if (!is_null($results) && count($results) > 0) {
					$bResult = $results[0];
				} else {
					// append new page
					// myecho('append new page');
					$child_page = $xml->addChild('page');
					$child_page->addAttribute('id', $page);
					$child_page->addAttribute('edited', 'false');
					$nodes = array();
					$nodes[] = array('name' => 'page_text', 'value' => $category['bezeichnung'] . ' - ' . $category['beschreibung']);
					$nodes[] = array('name' => 'meta_description', 'value' => $category['bezeichnung'] . ': ' . $category['beschreibung']);
					$nodes[] = array('name' => 'meta_title', 'value' => $category['titel'] . ' - Seite: ' . $page);
					$nodes[] = array('name' => 'meta_keywords', 'value' => $category['keywords']);
					foreach ($nodes as $node) {
						$name = $node['name'];
						$value = $node['value'];
						add_cdata($name, $value, $child_page);
					}
					if (class_exists('DOMDocument')) {
						$dom = new DomDocument('1.0', 'utf-8');
						$dom->preserveWhiteSpace = false;
						$dom->formatOutput = true;
						$dom->loadXML($xml->asXML());
						if (!@$dom->save($xml_file)) {
							savelog('save: ' . $xml_file . ' failed');
						}
						if (isset($dom)) {
							unset($dom);
						}
					} else {
						if (!@$xml->asXml($xml_file)) {
							savelog('save: ' . $xml_file . ' failed');
						}
					}
				}
				if (isset($xml)) {
					unset($xml);
				}
			}
		} else {
			savelog('save: ' . $catid . ' ist nicht definiert');
		}
		return $bResult;
	}

}

if (!function_exists('loadMydatas')) {
	function loadMydatas() {
		global $CONFIG, $cams;
		$bResult = null;
		$valid = true;
		$xml_file_name = 'my_sedcard_datas.xml';
		$xml_file = $CONFIG['TEMPDIR'] . $xml_file_name;
		if (!is_file($xml_file)) {
			savelog($xml_file . ' wurde nicht gefunden');
			$valid = false;
		}
		if ($valid && $xml = simplexml_load_file($xml_file)) {
			$bResult = $xml;
			if (isset($xml)) {
				unset($xml);
			}
		}
		return $bResult;
	}

}

/**
 * mit dieser Funktionen werden fuer jede Kategorie eigene Metatags gesetzt,
 * welche selbst in einer XML-Datei definiert wurden
 * und diese werden alle in einem String zurueck gegeben
 *
 * @param integer 	$catid
 * @return string	metadaten
 *
 */
if (!function_exists('getMetaAsText')) {
	function getMetaAsText($catid, $as_string = 0) {
		global $CONFIG, $kategorie;
		$xml_file = $CONFIG['TEMPDIR'] . 'all_categories_meta.xml';
		$bResult = null;
		$valid = true;		
		if (!isset($kategorie[$catid])) {
			$valid = false;
			savelog($catid . ' ist nicht definiert');
		} else {
			if (!is_file($xml_file)) {
				$doc = new DOMDocument();
				$metatags = array('title' => $kategorie[$catid]['titel'], 'description' => $kategorie[$catid]['beschreibung'], 'text' => $kategorie[$catid]['beschreibung'], 'sitetitle' => $kategorie[$catid]['titel'], 'keywords' => $kategorie[$catid]['keywords']);
				$doc->preserveWhiteSpace = false;
				$doc->formatOutput = true;
				$root = $doc->createElement("categories");
				$r = $doc->createElement("category");
				$r->setAttribute('id', $catid);
				$r->setAttribute('edited', 'false');
				$root->appendChild($r);
				$doc->appendChild($root);
				$b = $doc->createElement("metadata");
				foreach ($metatags as $k => $v) {
					$child = $doc->createElement($k);
					$child->appendChild($doc->createCDATASection($v));
					$b->appendChild($child);
				}
				$r->appendChild($b);
				if (!@$doc->save($xml_file)) {
					savelog('save: ' . $xml_file . ' failed');
				} else {
					@chmod($xml_file, 0666);
				}
				if (isset($doc)) {
					unset($doc);
				}
			}
			if (is_file($xml_file)) {
				if (!$xml = simplexml_load_file($xml_file)) {
					savelog($xml_file . ' konnte geladen werden');
				} else {
					$query = '//categories/category[@id="' . $catid . '"]';
					// myecho($query);
					$results = $xml->xpath($query);
					if (!is_null($results) && count($results) > 0) {
						$category_meta = $results[0];
					} else {
						// append new category
						// myecho('append new category');
						$category = $kategorie[$catid];
						$child_category = $xml->addChild('category');
						$child_category->addAttribute('id', $catid);
						$child_category->addAttribute('edited', 'false');
						$child_meta = $child_category->addChild('metadata');
						$nodes = array();
						$nodes[] = array('name' => 'text', 'value' => $category['bezeichnung'] . ' - ' . $category['beschreibung']);
						$nodes[] = array('name' => 'description', 'value' => $category['bezeichnung'] . ': ' . $category['beschreibung']);
						$nodes[] = array('name' => 'title', 'value' => $category['titel']);
						$nodes[] = array('name' => 'sitetitle', 'value' => $category['titel']);
						$nodes[] = array('name' => 'keywords', 'value' => $category['keywords']);
						foreach ($nodes as $node) {
							$name = $node['name'];
							$value = $node['value'];
							add_cdata($name, $value, $child_meta );
						}
						if (class_exists('DOMDocument')) {
							$dom = new DomDocument('1.0', 'utf-8');
							$dom->preserveWhiteSpace = false;
							$dom->formatOutput = true;
							$dom->loadXML($xml->asXML());
							if (!@$dom->save($xml_file)) {
								savelog('save: ' . $xml_file . ' failed');
							}
							if (isset($dom)) {
								unset($dom);
							}
						} else {
							if (!@$xml->asXml($xml_file)) {
								savelog('save: ' . $xml_file . ' failed');
							}
						}
						$category_meta = $child_category;
					}
					if (isset($xml)) {
						unset($xml);
					}
				}
				$meta_title = (string)$category_meta->metadata->title;
				$meta_text = (string)$category_meta->metadata->text;
				$meta_description = (string)$category_meta->metadata->description;
				$meta_keywords = (string)$category_meta->metadata->keywords;
				
				global $meta;
				$meta['page_text'] = $meta_text;
				$meta['description'] = $meta_description;
				$meta['title'] = $meta_title;
				$meta['keywords'] = $meta_keywords;
				if($as_string  == 1){
					$bResult = "<title>" . $meta_title . "</title>\n";
					$bResult .= "<meta name=\"description\" content=\"" . $meta_description . "\" />\n";
					$bResult .= "<meta name=\"keywords\" content=\"" . $meta_keywords . "\" />\n";
				}
			}
		}
		return $bResult;
	}

}
/**
 * die PHP-Einstellung: open_short_tags 
 * 
 * wenn open_short_tags auf off steht wird die Ausfuehrung des 777Script
 * unerwartet abgebrochen
 * und es erscheint folgende Fehlermeldung auf dem Bildschirm
 * 
 * Parse error: syntax error, unexpected end of file in ..../_system/scripthelper.inc.php on line 3470
 * 
 * in diesem Fall muss die erste Zeile der .htaccess wie folgt geaendert werden:
 * 
 * # short open tags einschalten, weil sie nicht auf jedem Webmasterserver eingestellt sind
 * php_flag short_open_tag on
 * 
 */

if (!isset($sender)) {
	$sender = null;
}
?>
