<?php
include_once('basics.inc.php');
?>
 <!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
        <title>
            <?php echo($text['remotepassword']['remotepassword']); ?>
        </title>
        <style type="text/css" media="all">        
            /*<![CDATA[*/
			@import url('<?php echo($popupdir . 'styles.' . $CONFIG['LANGUAGE']. '.css'); ?>');
            /* ]]> */        
        </style>
        <!--[if IE]>
            <style type="text/css" media="screen">
            .errortxt {
            filter:alpha(opacity=80); /* IE */
            }
            </style>
        <![endif]-->
        <script type="text/javascript">
            /*<![CDATA[*/
    		/**
    		 * Ueberprueft die Formulardaten
    		 */
            function validate(){
                var valid = true;
    			var objInputEmail = document.getElementById('email');
    			var objInputCaptcha = document.getElementById('captcha');
    			var objErrorbox = document.getElementById('div_error');
    			var objP = document.createElement('p');
    			objP.className = 'errortxt';
    			objP.setAttribute('class', 'errortxt');
    			
    			var directory = '<?php echo($imagepath_for_javascript); ?>';
				var bg_image = 'formbox.png';
				var bg_img_input_error = 'url(' + directory + bg_image + ') 0 -94px';
            	var bg_img_captcha_error = 'url(' + directory + bg_image + ')  -90px -141px';
				var bg_img_input = 'url(' + directory + bg_image + ') 0 0';
            	var bg_img_captcha = 'url(' + directory + bg_image + ') -90px -47px';
    			
    			if (objInputEmail.value.length == 0) {					
    				objP.innerHTML = '<?php echo $text['remotepassword']['error_email']?>';
    				objInputEmail.style.background = bg_img_input_error;
                    objInputEmail.focus();
                    valid = false;
                }else{
    				objInputEmail.style.background = bg_img_input;
    			}
    			
                if (valid && (objInputCaptcha.value.length < 3 || isNaN(objInputCaptcha.value))) {
    				objP.innerHTML = '<?php echo $text['remotepassword']['error_captchatext']?>';
    				objInputCaptcha.style.background =bg_img_captcha_error;
                    objInputCaptcha.focus();
                    valid = false;
                }else{
    				objInputCaptcha.style.background =bg_img_captcha;
    			}
    			
    			if(valid){
    				document.formpassword.submit();
    			}else{
    				//objErrorbox.innerHTML = '';
    				document.getElementById('div_errorbox_text').innerHTML = '';
    				document.getElementById('div_errorbox_text').appendChild(objP);
    				objErrorbox.style.display = 'block';
    				return valid;
    			}
            }
    		// versucht bei Enter im Textfeld das Formular ab zu schicken
    		function doSubmit(e){
    			var objForm = document.forms.formlogin;
    			if(e.keyCode == 13){
    				 validate();
    			}
    		}              
            /* ]]> */
        </script>
    </head>
    <body>
        <!-- Start Wrapper -->
        <div class="div_wrapper">
            <div class="div_errorbox" id="div_error" <?php echo($style_div_errorbox); ?> >
                <div id="div_errorbox_text">
                    <p>
                        <?php echo($error); ?>
                    </p>
                </div>
                <div>
                    <input type="button" onclick="document.getElementById('div_error').style.display = 'none';" value="<?php echo($text['remoteregister']['close']); ?>" />
                </div>
            </div>
            <div class="div_headline_password">
                <span>
                    <?php echo($text['remotepassword']['remotepassword']); ?>
                </span>
            </div>
            <div class="div_subheadline_password">
                <span>
                    <?php echo($text['remotepassword']['get_new_password']); ?>
                </span>
            </div>
            <!-- <a href="close window" class="close"><span><?php echo($text['remotepassword']['windowclose'] ); ?></span></a> --><!-- Start formbox --><!-- Start formbox -->
            <form action="<?php echo $action['remotepassword']?>" method="post" name="formpassword" id="formpassword" accept-charset="UTF-8">
                <input type="hidden" name="bid" value="<?php echo $form['bid']?>" />
	            <input type="hidden" name="targeturl" value="<?php echo $form['targeturl']?>" />
	            <input type="hidden" name="language" value="<?php echo $form['language']?>" />
	            <input type="hidden" name="culture" value="<?php echo $form['language']?>" />
	            <input type="hidden" name="origin" value="<?php echo $form['origin']?>" />
	            <input type="hidden" name="capid" value="<?php echo $form['capid']?>" />
	            <input type="hidden" name="layout" value="<?php echo $form['layout']?>" />
	            <input type="hidden" name="ref" value="<?php echo $form['ref']?>" />
	            <?php
					if(!is_null($CONFIG['CAMID'])){
						echo('<input type="hidden" name="camid" value="'.$CONFIG['CAMID'].'" />');
						echo('<input type="hidden" name="name" value="'. $form['name'] .'" />');
					}
					if(!is_null($CONFIG['SC_ID'])){
						echo('<input type="hidden" name="sc_id" value="'.$CONFIG['SC_ID'].'" />');
					}
					if (!is_null($CONFIG['HEADER'])) {
						echo('<input type="hidden" name="header" value="'.$CONFIG['HEADER'].'" />');
					}
				?>
				<div class="div_formbox">
                    <div>
                        <label for="email">
                            <?php echo($text['remoteregister']['email'].':'); ?>
                        </label>
                        <input name="email" id="email" type="text" size="20" maxlength="50" onkeydown="doSubmit(event);"/>
                    </div>
                    <div>
                        <label for="captcha">
                            <?php echo($text['remoteregister']['captchacode'].':'); ?>
                        </label>
                        <div class="div_code_box">
                            <div class="div_code">
                                <img src="<?php echo $action['remotecaptcha']."?id=".$captcha['uniquekey']?>" alt="captcha" />
                            </div><input type="text" name="captchatext" id="captcha" value="" maxlength="8" onkeydown="doSubmit(event);"/>
                        </div>
                    </div>
                    <br class="br_clear"/>
                    <div class="div_get_password_submit">
                        <input type="button" onclick="validate();" onmouseover="this.style.background='url(<?php echo($popupdir); ?>images/<?php echo($CONFIG['LANGUAGE']); ?>/buttons.png) -199px -245px';" onmouseout="this.style.background='url(<?php echo($popupdir); ?>images/<?php echo($CONFIG['LANGUAGE']); ?>/buttons.png) -199px -196px'" value="&nbsp;" />
                    </div>
                </div>
            </form><!-- End formbox --><!-- Start Footer -->
            <div class="div_footer">
                <div>
                    <h1>
                        <?php echo($text['remotepassword']['you_have_login_data']); ?>
                    </h1>
                </div>
                <a href="remoteregister.php<?php echo($form['remoteregister_querystring']); ?>" target="_self" title="<?php echo($text['remoteregister']['div_login_text']['text']); ?>" class="a_footer_login"><span>
                        <?php echo($text['remoteregister']['div_login_text']['text']); ?>
                    </span></a>
            </div>
            <!-- Ende Footer -->
        </div>
        <!-- Ende Wrapper -->
		<?php
        if ( isset ($counterpixel))
        {
            $_SESSION['cid_refresh'] = time();
			echo ($counterpixel);
        }
        ?>
    </body>
</html>