<?php
include_once('basics.inc.php');
?>
<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
        <title>
            <?php echo($text['remoteregister']['free_registration']); ?>
        </title>
        <style type="text/css" media="all">        
            /*<![CDATA[*/
			@import url('<?php echo($popupdir . 'styles.' . $CONFIG['LANGUAGE']. '.css'); ?>');
           /* ]]> */
        </style>
        <!--[if IE]>
            <style type="text/css" media="screen">
            .errortxt {
            filter:alpha(opacity=80); /* IE */
            }
            </style>
        <![endif]-->
        <script type="text/javascript">
	        /*<![CDATA[*/
	        function validate(){
	            var valid = true;
				var objInputEmail = document.getElementById('email');
				var objInputCaptcha = document.getElementById('captcha');
				var objInputUser = document.getElementById('user');
				var objErrorbox = document.getElementById('div_error');
				var objP = document.createElement('p');
				objP.className = 'errortxt';
				objP.setAttribute('class', 'errortxt');
				var directory ='<?php echo($imagepath_for_javascript); ?>';
				var bg_image = 'formbox.png';
				var bg_img_input_error = 'url(' + directory + bg_image + ') 0 -94px';
            	var bg_img_captcha_error = 'url(' + directory + bg_image + ')  -90px -141px';
				var bg_img_input = 'url(' + directory + bg_image + ') 0 0';
            	var bg_img_captcha = 'url(' + directory + bg_image + ') -90px -47px';
				
				if (objInputUser.value.length == 0) {
	                objP.innerHTML = '<?php echo($text['remoteregister']['error_user']); ?>';
					objInputUser.style.background = bg_img_input_error;
	                objInputUser.focus();
	                valid = false;
	            }else {
					objInputUser.style.background = bg_img_input;
				}
	            
				if (valid && objInputEmail.value.length == 0) {
	                objP.innerHTML = '<?php echo($text['remoteregister']['error_email']); ?>';
					objInputEmail.style.background = bg_img_input_error;
	                objInputEmail.focus();
	                valid = false;
	            }else {
					objInputEmail.style.background = bg_img_input;
				}
	            
				if (valid && (objInputCaptcha.value.length < 3 || isNaN(objInputCaptcha.value))) {
	                objP.innerHTML = '<?php echo($text['remoteregister']['error_captchatext']); ?>';
					objInputCaptcha.style.background = bg_img_captcha_error;
	                objInputCaptcha.focus();
	                valid = false;
	            }else {
					objInputCaptcha.style.background = bg_img_captcha;
				}
				
				if(valid){
					document.formregister.submit();
				}else{
					//objErrorbox.innerHTML = '';
					document.getElementById('div_errorbox_text').innerHTML = '';
					document.getElementById('div_errorbox_text').appendChild(objP);
					objErrorbox.style.display = 'block';
					return valid;
				}	            
	        }
			// versucht bei Enter im Textfeld das Formular ab zu schicken
			function doSubmit(e){
				var objForm = document.forms.formlogin;
				if(e.keyCode == 13){
					 validate();
				}
			}   	        
	        /* ]]> */
        </script>
    </head>
    <body>
        <!-- Start Wrapper -->
        <form action="<?php echo($action['remoteregister']); ?>" method="post" name="formregister" id="formregister" accept-charset="UTF-8" onsubmit="validate();return false;">
            <input type="hidden" name="bid" value="<?php echo $form['bid']?>" />					
			<input type="hidden" name="targeturl" value="<?php echo $form['targeturl']?>" />
			<input type="hidden" name="language" value="<?php echo $form['language']?>" />
			<input type="hidden" name="origin" value="<?php echo $form['origin']?>" />
			<input type="hidden" name="capid" value="<?php echo $form['capid']?>" />
			<input type="hidden" name="layout" value="<?php echo $form['layout']?>" />
			<input type="hidden" name="ref" value="<?php echo $form['ref']?>" />
			<?php
				if(!is_null($CONFIG['CAMID'])){
					echo('<input type="hidden" name="camid" value="'.$CONFIG['CAMID'].'" />');
					echo('<input type="hidden" name="name" value="'. $form['name'] .'" />');
				}
				if(!is_null($CONFIG['SC_ID'])){
					echo('<input type="hidden" name="sc_id" value="'.$CONFIG['SC_ID'].'" />');
				}
				if (!is_null($CONFIG['HEADER'])) {
					echo('<input type="hidden" name="header" value="'.$CONFIG['HEADER'].'" />');
				}
			?>
			<div class="div_wrapper">
                <div class="div_errorbox" id="div_error"<?php echo($style_div_errorbox); ?>>
                    <div id="div_errorbox_text">
                        <p>
                            <?php echo($error); ?>
                        </p>
                    </div>
                    <div>
                        <input type="button" onclick="document.getElementById('div_error').style.display = 'none';" value="<?php echo($text['remoteregister']['close']); ?>" />
                    </div>
                </div>
                <div class="div_headline_register">
                    <span><?php echo($text['remoteregister']['you_want_sex']); ?></span>
                </div>
                <div class="div_subheadline_register">
                    <span><?php echo($text['remoteregister']['register_now_for_liveshows']); ?></span>
                </div>
                <div class="div_subheadline_50_coins">
                    <span>+<?php echo($text['remotelogin']['50_free_coins']); ?></span>
                </div>
                <!--
                <a href="close window" class="close"><span><?php echo($text['remotepassword']['windowclose'] ); ?></span></a>
                --><!-- Start formbox -->
                <div class="div_formbox">
                    <div>
                        <label for="user">
                            <?php echo($text['remoteregister']['username'].':'); ?>
                        </label>
                        <input name="user" type="text" id="user" value="" size="20" maxlength="50" onkeydown="doSubmit(event);"/>
                    </div>
                    <div>
                        <label for="email">
                            <?php echo($text['remoteregister']['email'].':'); ?>
                        </label>
                        <input name="email" type="text" id="email" value="" size="20" maxlength="50" onkeydown="doSubmit(event);"/>
                    </div>
                    <div>
                        <label for="captcha">
                            <?php echo($text['remoteregister']['captchacode'].':'); ?>
                        </label>
                        <div class="div_code_box">
                            <div class="div_code">
                                <img src="<?php echo $action['remotecaptcha']."?id=".$captcha['uniquekey']?>" alt="captcha" />
                            </div><input type="text" name="captchatext" id="captcha" value="" maxlength="8" />
                        </div>
                    </div>
                    <br class="br_clear"/>
                    <div class="div_register_submit">
                        <input type="button" onclick="validate();" onmouseover="this.style.background='url(<?php echo($popupdir); ?>images/<?php echo($CONFIG['LANGUAGE']); ?>/buttons.png) -199px -147px';" onmouseout="this.style.background='url(<?php echo($popupdir); ?>images/<?php echo($CONFIG['LANGUAGE']); ?>/buttons.png) -199px -98px'" value="&nbsp;" />
                    </div>
                </div>
				<!-- Ende formbox -->
				<!-- Start Footer -->
                <div class="div_footer">
                    <div>
                        <a href="remotelogin.php<?php echo $form['remoteregister_querystring'] ?>" target="_self" title="Login" class="a_login"><span><?php echo($text['remoteregister']['login_with_own_data']); ?></span></a>
                    </div>
                    <!-- Ende Footer -->
                </div>
                <!-- Ende Wrapper -->
                <div class="div_glossar">
                    <?php echo($text['remoteregister']['div_glossar']); ?>
                </div>
            </div>
        </form>
        <?php 
        if (isset($counterpixel)) {
            echo($counterpixel);
        }
        ?>
    </body>
</html>