<?php 
/*****************************************************
 *                                                   *
 *  777Script Version 8.2                            *
 *  function.inc.php V. 1.0                          *
 *  Diese Datei sollte nicht veraendert werden.      *
 *  Die Copyright-Zeile darf nicht rausgenommen      *
 *  werden!                                          *
 *                                                   *
 *****************************************************/
// benoetigte PHP Dateien
include_once ('config.inc.php');
include_once ('_system/autoload.inc.php');
include_once ('_system/scripthelper.inc.php');

$div_development = set_development();

if (isset($language)) {
    $camlanguage = $language;
    unset($language);
}

//ab hier beginnt die Verarbeitung
$language = array();
$language['de'] = array();
$language['en'] = array();
$language['de']['earn_money'] = "Geld verdienen?";
$language['en']['earn_money'] = "earn money?";
$language['de']['fatal_error'] = "FATAL ERROR - Keine Cams gefunden";
$language['en']['fatal_error'] = "FATAL ERROR - no cams found";
$language['de']['no_data'] = "Keine Daten zum Anzeigen vorhanden.";
$language['en']['no_data'] = "No Data to display";
$language['de']['404_not_found'] = "Seite wurde nicht gefunden (404)";
$language['en']['404_not_found'] = "Page not found (404)";
$language['de']['404_not_displayed'] = "Die aufgerufene Seite konnte leider nicht korrekt dargestellt werden.";
$language['en']['404_not_displayed'] = "The REQUESTed page could not be displayed properly";
$language['de']['404_proceed'] = "Bitte klicken Sie hier fuer weiter ...";
$language['en']['404_proceed'] = "Please click to proceed ...";

$popup = array();
$popup['link'] = array();
$popup['link']['remoteregister'] = array();
$popup['link']['remoteregister']['page'] = "remoteregister.php";
$popup['link']['remoteregister']['var'] = "remoteregister";
$popup['link']['remotelogin'] = array();
$popup['link']['remotelogin']['page'] = "remotelogin.php";
$popup['link']['remotelogin']['var'] = "remotelogin";
$popup['link']['remotepassword'] = array();
$popup['link']['remotepassword']['page'] = "remotepassword.php";
$popup['link']['remotepassword']['var'] = "remotepassword";
// errorcode
if (isset($_REQUEST['errorcode'])) {
    $errorcode = $_REQUEST['errorcode'];
}
// sendto:
$action = array();
$action['remotecaptcha'] = "https://777livecams.com/remotecaptcha.php";
$action['remoteregister'] = "https://777livecams.com/remoteregister.php";
$action['remotelogin'] = "https://777livecams.com/remotelogin.php";
$action['remotepassword'] = "https://777livecams.com/remotepassword.php";

if (strpos($_SERVER['DOCUMENT_ROOT'], "://") !== false) {
    exit;
}

if ($CONFIG['LANGUAGE'] == "") {
    $systemtext = $language['de'];
} else {
    $systemtext = $language[$CONFIG['LANGUAGE']];
}

if (isset($CONFIG['POPUPDIR_IN_IFRAME']) && $CONFIG['POPUPDIR_IN_IFRAME'] == 1) {
    $CONFIG['POPUPDIR_IN_IFRAME'] = 'true';
} else {
    $CONFIG['POPUPDIR_IN_IFRAME'] = 'false';
}

// counterpixel damit die Aufrufe des Popups bei 777partner.com als Besucher gezaehlt werden
if (!isset($_SESSION)) {
    SESSION_start();
}

$usepixel = false;
$counterpixel = '';
if (stripos($_SERVER['HTTP_USER_AGENT'], "googlebot") === false) {
    if (!key_exists('cid_refresh', $_SESSION)) {
        $usepixel = true;
    } else {
        // myecho($_SESSION['cid_refresh']);
        if ((time() - 60) >= $_SESSION['cid_refresh']) {
            $usepixel = true;
        }
    }
}
// myecho($_SESSION);
// myecho($usepixel);
if ($usepixel) {
    // $_SESSION['cid_refresh'] = time(); wird erst gesetzt wenn auch der counterpixel ausgegeben wird
    // myecho(SESSION_id());
    $queryString = '?webid='.$CONFIG['WMID'];
    // Website-ID uebergeben..?
    $queryString .= '&amp;websiteid=2';
    $queryString .= '&amp;SESSION='.SESSION_id();
    $counterurl = "//counter.live4members.com/";
    $counterpixel = '<img src="'.$counterurl.$queryString.'" id="counter.live4members" alt="counter" style="width:1px;height:1px;display:none;visibility:hidden;"/>';
}

ignore_user_abort(true);

$time['start'] = microtime_float();

if ($CONFIG['PATH'] == "/") {
    $CONFIG['PATH'] = "";
}

if (!key_exists('SEARCHDIR', $CONFIG)) {
    $s = array();
    $s['SEARCHDIR'] = 'search/';
    $CONFIG = array_merge($CONFIG, $s);
    unset($s);
}

// START Adplus gesperrte MM-Domains
try{	
	global $mm;	
	$remote_cleanup_xml_file = $CONFIG['CLEANUPURL'];
	$local_cleanup_xml_file = $CONFIG['TEMPDIR'].'cleanup.xml';
	$ad = new mm_server($remote_cleanup_xml_file, $local_cleanup_xml_file);
	// evtl. neu erstellen XML-datei mit allen AdPlus gesperrten MM-Servern
	$ad->updateFileFromRemote();
	$ad->setAdplusBlockedMMServers();
	$CONFIG['MM_SERVER'] = $mm = $ad->getMMServer();
	$mm_search = $ad->getAdplusBlockedMMServers();
	if(isset($ad)){
		unset($ad);
	}
}catch(Exception $ex){
	display_install_inc($ex->getMessage(), '', '');
}
// END Adplus gesperrte MM-Domains

$url = $_SERVER["REQUEST_URI"];

// Reduziere die $url auf den Teil nach $CONFIG[PATH]
$url = substr($url, 1 + strlen($CONFIG['PATH']));
// Nimm die URL auseinander, vorsicht, gilt fuer Linux-Systeme.
$url_teile = explode("/", $url);

// Wichtig, hier werden nun der Link extrahiert und geprueft, was eigentlich angezeigt werden soll.
// Wenn diese Seite includet wurde, dann steht die komplette URL in $_SERVER["REQUEST_URI"]
// Kein Bild, dann weiter.
// Befindet sich im ersten Ausdruck eine Kategorie?
$targeturl = urlencode(base64_encode("/index.php?id=".$CONFIG["WMID"]));
$targeturl64 = base64_encode("/index.php?id=".$CONFIG["WMID"]);

$catid = -1;
$sid = -1;
$page = -1;
$startseite = 0;
$speciallink = 0;
$popuplink = 0;

if (is_array($popup['link']) && count($popup['link']) > 0) {

    foreach ($popup['link'] as $typ=>$array) {
        /**
         echo substr($url,0,strlen($array['page']));
         echo "\n<br />";
         echo $array['page'];
         echo "\n<br />";
         echo "\n<br />";
         */

        if (substr($url, 0, strlen($array['page'])) == $array['page']) {
            ${$array['var']} = 1;
            $popuplink = 1;
            $popuppage = $array['page'];
        } else {
            ${$array['var']} = 0;
        }
    }
    if ($popuplink == 1) {
    
        $backpath = (($CONFIG['PATH'] == "/") ? "" : $CONFIG['PATH']);
        if (substr($backpath, strlen($backpath) - 1) != '/') {
            $backpath .= '/';
        }
        if (substr($backpath, 0, 1) != '/') {
            $backpath = "/".$backpath;
        }
        if ($backpath == "//") {
            $backpath = "/";
        }
        $image_path = (($CONFIG['PATH'] == "/") ? "" : $CONFIG['PATH'])."/".$CONFIG['POPUPDIR']."/images_".$CONFIG['LANGUAGE'];
        $language_path = (($CONFIG['PATH'] == "/") ? "" : $CONFIG['PATH'])."/".$CONFIG['POPUPDIR']."/texte_".$CONFIG['LANGUAGE'];
        // Wenn es die remoteregister oder die remotelogin oder remotepasswort ist
        // Dann hole auch das Captcha
        
        if (isset($remoteregister) || isset($remotepassword)) {
            $captcha_full = get_content($action['remotecaptcha']);
            $captcha['uniquekey'] = $captcha_full;
        }
        
        $form['bid'] = $CONFIG['WMID'];
        $form['layout'] = $CONFIG['LIVECAMLAYOUT'];
        $form['language'] = $CONFIG['LANGUAGE'];
        $form['origin'] = "//".$_SERVER['HTTP_HOST'].$backpath.$popuppage;
        $form['capid'] = $captcha['uniquekey'];
        
        $form_names = array('email', 'camid', 'name');
        foreach ($form_names as $form_name) {
            if (key_exists($form_name, $_REQUEST)) {
                $form[$form_name] = $_REQUEST[$form_name];
            } else {
                $form[$form_name] = '';
            }
        }
        if (key_exists('targeturl', $_REQUEST)) {
            $form['targeturl'] = $_REQUEST['targeturl'];
        } else {
            $form['targeturl'] = $targeturl64;
        }
        $text_file_name  = "texte_".$CONFIG['LANGUAGE'].".php";
		$directory = $_SERVER["DOCUMENT_ROOT"].(($CONFIG['PATH'] == "/") ? "" : $CONFIG['PATH'])."/".$CONFIG['POPUPDIR']."/";
		$text_file = $directory.$text_file_name;
		if(!is_file($text_file)){
			echo($text_file.' not found');
			die();
		}        
        if(isset($errorcode)){
        	switch($errorcode){
        		case 0:
				case 6:
					if(is_file($directory.'send.php')){
						$popuppage = 'send.php';
					}
					break;
				default:			
        	}
        }
		// registration page
		include_once ($text_file);
		include_once ($directory.$popuppage);
        die();
    }
}

// ueberpruft die Installation
include_once ('install.inc.php');

// die Kategorien muessen in UTF-8 umgewandelt werden
if (isset($kategorie)) {
    foreach ($kategorie as $key=>$value) {
        if (is_array($value)) {
            foreach ($value as $k=>$v) {
                $kategorie[$key][$k] = utilities::__utf8_encode($v);
            }
        } else {
            $kategorie[$key] = utilities::__utf8_encode($value);
        }
    }
}
// $special_link['TOPSENDER'] in UTF-8 umgewandeln
if (isset($special_link['TOPSENDER'])) {
    $special_link['TOPSENDER'] = config_data_to_utf8($special_link['TOPSENDER'], 'LINK');
}
// $special_link['tagcloud']['LINK'] in UTF-8 umgewandeln
if (isset($special_link['tagcloud'])) {
    $special_link['tagcloud'] = config_data_to_utf8($special_link['tagcloud'], 'LINK');
}
// $special_link['suche'] in UTF-8 umgewandeln
if (isset($special_link['suche'])) {
    $special_link['suche'] = config_data_to_utf8($special_link['suche'], 'LINK');
}
// $special_link['impressum'] in UTF-8 umgewandeln
if (isset($special_link['impressum'])) {
    $special_link['impressum'] = config_data_to_utf8($special_link['impressum'], 'LINK');
}
// $METACAM in UTF-8 umgewandeln
if (isset($METACAM)) {
    $METACAM = config_data_to_utf8($METACAM, 'TITLE');
}
// $METACAT in UTF-8 umgewandeln
if (isset($METACAT)) {
    $METACAT = config_data_to_utf8($METACAT, 'TITLE');
}
// $KEYWORDS in UTF-8 umgewandeln
if (isset($KEYWORDS)) {
    $KEYWORDS = config_data_to_utf8($KEYWORDS, null);
}


if (file_exists($CONFIG['TEMPDIR']."system.s") && filesize($CONFIG['TEMPDIR']."system.s") > 0) {
    $system = unserialize(implode("", file($CONFIG['TEMPDIR']."system.s")));
}


if (is_array($special_link) && count($special_link) > 0) {
    foreach ($special_link as $typ=>$array) {
        if (substr($url, 0, strlen($array['LINK'])) == $array['LINK']) {
            ${$array['VARIABLE']} = 1;
            $speciallink = 1;
            $specialname = $typ;
        } else {
            ${$array['VARIABLE']} = 0;
        }
    }
}

// Impressumlink der da reingewurschtelt wird  - body durch eine Fusszeile ziemlich am Ende dieser Datei:
$impressum_link = '';
if ($CONFIG['USEIMPRESSUM'] == 1 || strtolower($CONFIG['USEIMPRESSUM']) == "on") {
    // myecho($special_link);die();
    $impressum_path = $CONFIG['PATH'];
    if (substr($impressum_path, strlen($impressum_path) - 1) != '/') {
        $impressum_path .= '/';
    }
    if (isset($special_link['impressum']['LINK'])) {
        $impressum_link = ' / <a href="'.$impressum_path.$special_link['impressum']['LINK'].'" class="copy">Impressum</a> ';
    }
}
if ($url_teile[0] == "") {
    // Startseite
    $catid = $CONFIG['STARTKATEGORIE'];
    $page = 0;
    $startseite = 1;
} elseif ($speciallink == 1) {
    // Dann tue mal nichts.
} elseif (count($url_teile) > 0) {
    if ($catid == -1) {
        $found = false;
        for ($i = 0, $u = count($CATLINKZ); $i < $u; $i++) {
            // $catid = test_cat($url_teile[$i], $i);
            if (isset($url_teile[$i])) {
                $sid = test_cam($url_teile[$i], $i);
            }
            if (isset($CATLINKZ[$i])) {
                $cat_link_part = $CATLINKZ[$i];
            }
            // myecho($cat_link_part);
            if (strpos($cat_link_part, '{seite}') !== false) {
                // in diesem Teil der URL ist die Seite versteckt
                if (isset($url_teile[$i])) {
                    $url_part = $url_teile[$i];
                    // myecho($url_part);
                    $search = str_ireplace('{seite}', '', $cat_link_part);
                    $page = preg_replace("#".$search."#", '', $url_part);
                    if (!is_numeric($page)) {
                        $page = -1;
                    }
                }
            }
            if (strpos($cat_link_part, '{kategorie}') !== false) {
                // in diesem Teil der URL ist die category_id ersteckt
                if (isset($url_teile[$i]) && $sid < 0) {
                    $catid = test_cat($url_teile[$i], $i);
                    // myecho('category_id: '.$catid);
                    $found = true;
                }
            }
        }

        
    }
    // myecho('page:'. $page);
    if ($sid == -1 && $page == -1) {
        // myecho($url_teile);
        $found = false;
        for ($i = 0, $u = count($CAMLINKZ); $i < $u; $i++) {
            $cam_link_part = $CAMLINKZ[$i];
            // myecho($cam_link_part);
            if (strpos($cam_link_part, '{id}') !== false) {
                // in diesem Teil der URL ist die Senderid ersteckt
                if (isset($url_teile[$i])) {
                    $url_part = $url_teile[$i];
                    // myecho($url_part);
                    $sid = preg_replace('#[a-zA-Z-_.]#', '', $url_part);
                    if (is_numeric($sid) && $sid > 0) {
                        $found = true;
                        break;
                    }
                }
            }
        }
    }
    
    if ($sid > - 1) {
        if (isset($_SESSION['category_id'])) {
            // myecho('SESSION["category_id"]: '.$_SESSION['category_id']);
            $catid = $_SESSION['category_id'];
        }
    }
    if ($CONFIG['STARTKATEGORIE'] != 0 && $catid == 0) {
        $catid = $CONFIG['STARTKATEGORIE'];
        $_SESSION['category_id'] = $catid;
    }
    $_SESSION['category_id'] = $catid;
    
    if (count($url_teile) == 1) {
        $startseite = 1;
    }
	if($page == -1){
		$page = 1;
	}	
}

// myecho($sid);

$topsender = 0;
if (count($url_teile) == 1) {
    $url_teile_0 = $url_teile[0];
    if (strpos($url_teile_0, $special_link['TOPSENDER']['LINK']) !== false) {
        $topsender = 1;
    }
}

// Pruefe, wenn sid und page != 0 sind, ob sie ggf. als Parameter uebergeben wurden.
if ($sid == -1 && (isset($_GET['sid']) && $_GET['sid'] > 0)) {
    $sid = $_GET['sid'];
}

// damit auch cams die ueber die MM-Tools Banner angezeigt werden - 2012-05-29
if (key_exists('camid', $_GET)) {
    // ueberpruefen ob zu dieser Camid eine XML-Datei vorhanden ist, wenn nicht
    // muss diese von dem MM-Server geholt und gespeichert werden
    // wenn die XML-Datei nicht erstellt werden kann, bzw. keine richtigen
    // Daten enhaelt wird die Variable $sid nicht geaendert
    if (is_valid_XML_file($_GET['camid'])) {
        $sid = $_GET['camid'];
    }
}


if ($page == -1 && (isset($_GET['page']) && $_GET['page'] > 0)) {
    $page = $_GET['page'];
}

// Benoetige jetzt die Daten zur Kategorie:
if ((!isset($_GET['l']) && !isset($_GET['j'])) && (($catid != - 1 && $sid == -1 && $page == -1) || ($catid == -1 && $sid == -1 && $speciallink != 1))) {
    // Abbruch mit 404-Error-Meldung
    display_404Error(0);
}

if ($catid == -1) {
    $catid = $CONFIG['STARTKATEGORIE'];
}

// An diese Stelle den Cache einbauen
if ($CONFIG['CACHE'] == 1 && $speciallink != 1) {
    $cache_file = "";
    if ($sid > 0) {
        $cache_file = $CONFIG['CACHEDIR'].$sid.".cache";
        $cache_time = $CONFIG['CACHETIME_CAM'] * 60;
        // myecho($cache_file);
    } else {
        $cache_file = $CONFIG['CACHEDIR'].sprintf("%03d_%03d", $catid, $page).".cache";
        // myecho($cache_file);
        $cache_time = $CONFIG['CACHETIME_CAT'] * 60;
        // echo_debugtext($cache_time, '#FFF');
    }
    // Existiert die Datei und ist sie nicht zu alt?
    if (file_exists($cache_file) && (time() - filemtime($cache_file) < $cache_time)) {
        // echo_debugtext('from cache', '#FFF');
        if (filesize($cache_file) > 10) {
            if (!headers_sent()) {
                header("HTTP/1.0 200 OK");
                header("Content-Type: text/html; charset=utf-8");
            }
            readfile($cache_file);
            $lasttime = microtime_float();
            $timediff = $lasttime - $time["start"];
            savelog("Cache - Gesamtzeit: ".$timediff."");
            savelog("Cache - Speicher:   ".@memory_get_usage()." Bytes");
            die();
        } else {
            deletedir($CONFIG['CACHEDIR']);
        }
    } else if (file_exists($cache_file)) {
        // echo_debugtext('cachefile must be deleted', '#FFF');
        // Wenn hier, dann ist die Datei wohl zu alt, loesche sie.
        @unlink($cache_file);
    }
}

$own_cams = null;
$own_cams_inc_file = $docroot.'owncams.inc.php';
if (file_exists($own_cams_inc_file)) {
    include_once ($own_cams_inc_file);
}

$camall = get_kategorie_array(0);
// myecho($camall);
if ($catid != 0) {
    // myecho($catid);die();
    $cam = get_kategorie_array($catid);
} else {
    $cam = $camall;
}

if (isset($camall["BESCHREIBUNG"])) {
    $camall['LONGDESCRIPTION'] = $camall["BESCHREIBUNG"];
} else {
    $camall['LONGDESCRIPTION'] = '';
}
if (isset($cam["BESCHREIBUNG"])) {
    $cam['LONGDESCRIPTION'] = $cam["BESCHREIBUNG"];
} else {
    $cam['LONGDESCRIPTION'] = '';
}

$url_path = '/';
if (! empty($CONFIG['PATH'])) {
    $url_path = $CONFIG['PATH'];
}

if (substr($url_path, strlen($url_path) - 1) != '/') {
    $url_path .= '/';
}

if (isset($camall['ID'])) {
    if (count($camall['ID']) < 1) {
        $url = "//{$_SERVER['HTTP_HOST']}{$url_path}fetch.php?call=".time();
        echo('<html><body onload="window.location.href=\''.$url.'\'">Weiter</body></html>');
        //echo $bild;
        //echo $systemtext['no_data'];
        die();
    }
} elseif (!isset($camall['ID'])) {
    // myecho($camall);
    // myecho('NIX mit camall');die();
    // die Daten aktualisieren
    
    // alte temp Dateien loeschen
    $temp_directory = $docroot.$CONFIG['TEMPDIR'];
    if (!is_dir($temp_directory)) {
        if ($CONFIG['LOG'] == 1) {
            savelog($temp_directory.' ist nicht mehr vorhanden');
        }
        echo('TEMPDIR ist nicht mehr vorhanden');
        die();
    } else if ($dh = @opendir($temp_directory)) {
        while (($file = readdir($dh)) !== false) {
            if ($file != "." && $file != ".." && is_file($temp_directory.$file)) {
                $temp_file = $temp_directory.$file;
                if (strpos($temp_file, 'xml') !== false) {
                    if (!@unlink($temp_file)) {
                        if ($CONFIG['LOG'] == 1) {
                            savelog($temp_file.' konnte nicht geloescht werden');
                        }
                    }
                }
            }
        }
        closedir($dh);
        $url = "//{$_SERVER['HTTP_HOST']}{$url_path}fetch.php?call=".time();
        echo('<html><body onload="window.location.href=\''.$url.'\'">Weiter</body></html>');
        die();
    }
    
}

// Hier die Zufaelligen Cams einbauen:
$zufall = array();
$maximal = min(count($camall["ID"]), 25);
for ($n = 0; $n < $maximal; $n++) {
    // Nimm einen per Zufall
    $zufallszahl = mt_rand(0, count($camall["ID"]) - 1);
    if (in_array($zufallszahl, $zufall)) {
        $n--;
    } else {
        $zufall[$n] = $zufallszahl;
        // myecho($zufall[$n]);
        if (isset($camall['NAME'][$zufall[$n]])) {
            $cam_targeturl64 = createCamTargetUrl64($camall['ID'][$zufall[$n]]);
            $camall["camlogin"][$zufall[$n]] = (($CONFIG['PATH'] == "/") ? "" : $CONFIG['PATH'])."/remoteregister.php?id=".$CONFIG["WMID"]."&amp;targeturl=".$cam_targeturl64."&amp;camid=".$camall['ID'][$zufall[$n]]."&amp;name=".urlencode($camall['NAME'][$zufall[$n]]);
        } else {
            $camall["camlogin"][$zufall[$n]] = (($CONFIG['PATH'] == "/") ? "" : $CONFIG['PATH'])."/remoteregister.php?id=".$CONFIG["WMID"]."&amp;targeturl=".$targeturl64;
        }
        if ($CONFIG["LIVECAMLAYOUT"] != "") {
            $camall["camlogin"][$zufall[$n]] .= "&amp;l=".$CONFIG["LIVECAMLAYOUT"];
        }
        if (isset($CONFIG['HEADER']) && $CONFIG['HEADER'] == 'off') {
			$camall["camlogin"][$zufall[$n]] .= "&amp;h=" . $CONFIG['HEADER'];
		}
		if (isset($CONFIG['LANGUAGE']) && $CONFIG['LANGUAGE'] != 'de') {
			$camall["camlogin"][$zufall[$n]] .= "&amp;language=" . $CONFIG['LANGUAGE'];
		}
        if (isset($camall['NAME'][$zufall[$n]])) {
            while ($camall['NAME'][$zufall[$n]] == "") {
                //$zufallszahl = mt_rand(0, count($camall["ID"]));
                //$zufall[$n] = $zufallszahl;
                if (isset($camall['NAME'][$zufall[$n]])) {
                    $cam_targeturl64 = createCamTargetUrl64($camall['ID'][$zufall[$n]]);
                    $camall["camlogin"][$zufall[$n]] = (($CONFIG['PATH'] == "/") ? "" : $CONFIG['PATH'])."/remoteregister.php?id=".$CONFIG["WMID"]."&amp;targeturl=".$cam_targeturl64."&amp;camid=".$camall['ID'][$zufall[$n]]."&amp;name=".urlencode($camall['NAME'][$zufall[$n]]);
                    
                } else {
                    $camall["camlogin"][$zufall[$n]] = (($CONFIG['PATH'] == "/") ? "" : $CONFIG['PATH'])."/remoteregister.php?id=".$CONFIG["WMID"]."&amp;targeturl=".$targeturl64;
                    
                }
                if ($CONFIG["LIVECAMLAYOUT"] != "") {
                    $camall["camlogin"][$zufall[$n]] .= "&amp;l=".$CONFIG["LIVECAMLAYOUT"];
                }
				if (isset($CONFIG['HEADER']) && $CONFIG['HEADER'] == 'off') {
					$camall["camlogin"][$zufall[$n]] .= "&amp;h=" . $CONFIG['HEADER'];
				}
				if (isset($CONFIG['LANGUAGE']) && $CONFIG['LANGUAGE'] != 'de') {
					$camall["camlogin"][$zufall[$n]] .= "&amp;language=" . $CONFIG['LANGUAGE'];
				}
            }
        }
        // myecho($camall['ID'][$zufall[$n]]);
        if (isset($camall['ID'][$zufall[$n]])) {
            $wert = get_cam_info($camall['ID'][$zufall[$n]], false);
            // myecho('wert:');
            // myecho($wert);
            if (isset($wert['ONLINE']) && ($wert['ONLINE'] == 1 || $wert['ONLINE'] == 'true')) {
                $camall['ONLINE'][$zufall[$n]] = true;
            } else {
                $camall['ONLINE'][$zufall[$n]] = false;
            }
            if (isset($wert['PREVIEW'])) {
                // myecho($wert['PREVIEW']);
                $camall['PREVIEWURL'][$zufall[$n]] = $wert['PREVIEW'][0];
                // $camall['DESCRIPTION'][$zufall[$n]] = $wert['SHORTDESCRIPTION'];
                $camall['LASTMODIFIED'][$zufall[$n]] = $wert['LASTMODIFIED'];
                $description = $wert['BESCHREIBUNG'];
                $camall['LONGDESCRIPTION'][$zufall[$n]] = $description;
                $send_sound = 'true';
                if (!isset($wert['SENDSOUND']) || $wert['SENDSOUND'] != 1) {
                    $send_sound = false;
                }
                $camall['SENDSOUND'][$zufall[$n]] = $send_sound;
                $recieve_video = 'true';
                if ($wert['CAM2CAM'] != 1) {
                    $recieve_video = 'false';
                }
                ;
                $show_details = "https://mm.7-7-7-partner.com/showdetail.php?show={$wert['CAMID']}&size=l&lang=de";
                $sedcard_url = "https://www.777livecams.com/?show={$wert['CAMID']}";
                $camall['RECEIVEVIDEO'][$zufall[$n]] = $recieve_video;
                $camall['SHOWDETAILS'][$zufall[$n]] = $show_details;
                $camall['SETCARDURL'][$zufall[$n]] = $sedcard_url;
                $x = $zufall[$n];
                $link_datas = set_cam_link($camall, $x);
                $camall['CAMLINK'][$zufall[$n]] = $link_datas['link'];
                $camall['CAMLINKALT'][$zufall[$n]] = $camall['NAME'][$zufall[$n]]." - ".$camall['DESCRIPTION'][$zufall[$n]]." - ".$link_datas['keyword1'].",".$link_datas['keyword2'].",".$link_datas['keyword3'];
            } else {
                // myecho($wert);die();
            }
        }
    }
}
// myecho($camall);die();
$CAT_COUNT = get_cat_count();

// Brauche die Anzahl aller Cams aller Kategorien
$CAT_COUNT["alle"] = $CAT_COUNT[0];

$catname = $kategorie[$catid]["bezeichnung"];
$catcount = 0;
if (isset($cam['ID'])) {
    $catcount = count($cam["ID"]);
}

// die layout.inc.php einbinden

$layout_path = $docroot.'layouts/'.$CONFIG['LAYOUT'].'/';
if (!is_dir($layout_path)) {
    $message = 'layouts/'.$CONFIG['LAYOUT'].'/ wurde nicht gefunden<br/>bitte &uuml;berpr&uuml;fen Sie das Layoutverzeichnis';
    display_install_inc($message);
}
$layout_config_inc_file_1 = $layout_path.'config.inc.php';
$layout_config_inc_file_2 = $layout_path.'layout.config.inc.php';

if (file_exists($layout_config_inc_file_1)) {
    include_once ($layout_config_inc_file_1);
}
if (file_exists($layout_config_inc_file_2)) {
    include_once ($layout_config_inc_file_2);
}
// Wieviele Seiten?
$proseite = $CONFIG['ROWS'] * $CONFIG['COLS'];
// myecho($proseite);
$anzahlseiten = 1;
if (intval($catcount / $proseite) > 0) {
    $anzahlseiten = intval(ceil($catcount / $proseite));
}
// myecho('Seiten: '.intval($catcount/$proseite));
// myecho($catcount);
// myecho($anzahlseiten);

$rest = $catcount % $proseite;
if ($rest > 0) {
    $rest = $proseite - $rest;
}

// myecho($rest);
global $CONFIG;
if (!key_exists('SHOW_OFFLINE_CAMS', $CONFIG)) {
    $show_offline_cams = array();
    $show_offline_cams['SHOW_OFFLINE_CAMS'] = 1;
    $CONFIG = array_merge($CONFIG, $show_offline_cams);
}
if (!key_exists('OFFLINE', $CONFIG)) {
    $show_offline_cams = array();
    $show_offline_cams['OFFLINE'] = 'ON';
    $CONFIG = array_merge($CONFIG, $show_offline_cams);
}
if (isset($show_offline_cams)) {
    unset($show_offline_cams);
}

// Wenn die Seite >= 0 ist, $CONFIG["OFFLINE"] = on steht, dann fuelle die restlichen mit den offline-Cams auf.
if ((isset($CONFIG['OFFLINE']) && $CONFIG['OFFLINE'] != 'ON')) {
    $CONFIG['SHOW_OFFLINE_CAMS'] = 0;
}
if ($CONFIG['SHOW_OFFLINE_CAMS'] == 1 && ($rest > 0 || ($rest == 0 && $anzahlseiten == 1))) {
    $cat_count_online = 0;
    if (isset($cam["ID"])) {
        $cat_count_online = count($cam["ID"]);
    }
    $cat_count_offline = 0;
    $offlineliste = get_liste($catid);
    // myecho($offlineliste);
    if (count($offlineliste) > 0) {
        $i = 0;
        // myecho($cam);
        foreach ($offlineliste as $key=>$value) {
            // Pruefe, ob diese ID schon in $cam vorhanden ist
            if ($catcount == 0 || (isset($cam['ID']) && !in_array($offlineliste[$key]["CAMID"], $cam['ID']))) {
                if (isset($cam['ID'])) {
                    $catcount = count($cam['ID']);
                } else {
                    $catcount = 0;
                }
				if(isset($CONFIG['ONLYFAVOURITES']) && $CONFIG['ONLYFAVOURITES'] == 1){
					if (!empty($CONFIG['FAVORITEN'])) {
						if (strpos($CONFIG['FAVORITEN'], ',') !== false) {
							$favourite_camids = preg_split('#,#', $CONFIG['FAVORITEN']);
						} else {
							$favourite_camids = array($CONFIG['FAVORITEN']);
						}
						
						$offline_camid = $key;
						if(in_array($offline_camid, $favourite_camids)){
							$x = $catcount;
			                $cam['ID'][$x] = $offline_camid;
			                $cam['NAME'][$x] = $offlineliste[$key]["name"];
			                $cam['DESCRIPTION'][$x] = $offlineliste[$key]["desc"];
			                $cam['PREVIEWURL'][$x] = $offlineliste[$key]["preview"];
			                $cam['ONLINE'][$x] = false;
							$i++;
						}
					}
				}else{
					$x = $catcount;
	                $cam['ID'][$x] = $offlineliste[$key]["CAMID"];
	                $cam['NAME'][$x] = $offlineliste[$key]["name"];
	                $cam['DESCRIPTION'][$x] = $offlineliste[$key]["desc"];
	                $cam['PREVIEWURL'][$x] = $offlineliste[$key]["preview"];
	                $cam['ONLINE'][$x] = false;
					$i++;
				}
                if ($i == $rest) {
                    break;
                }
            }
        }
        $cat_count_offline = count($offlineliste);
    }
    $cat_count_all_cams = $cat_count_offline + $cat_count_online; // beinhaltet alle Cams
}
// myecho($cam);
$camneu = array();
$neueliste = get_neuliste();
// myecho($neueliste);die();
if (count($neueliste) > 0) {
    foreach ($neueliste as $value) {
        if (isset($value['CAMID']) && isset($value['PREVIEW'])) {
            if (isset($camneu['ID'])) {
                $x = count($camneu['ID']);
            } else {
                $x = 0;
            }
            $camneu['ID'][$x] = $value['CAMID'];
            $camneu['NAME'][$x] = $value['NAME'];
            $camneu['DESCRIPTION'][$x] = $value['SHORTDESCRIPTION'];
            $camneu["PREVIEWURL"][$x] = $value['PREVIEW'][0];
            $camneu['LONGDESCRIPTION'][$x] = $value['BESCHREIBUNG'];
            if (isset($value['ONLINE']) && ($value['ONLINE'] == 'true' || $value['ONLINE'] == 1)) {
                $camneu['ONLINE'][$x] = true;
            } else if (isset($value['ONLINE']) && ($value['ONLINE'] == 'false' || $value['ONLINE'] == 0)) {
                $camneu['ONLINE'][$x] = false;
            } else {
                $camneu['ONLINE'][$x] = false;
            }
            if ($CONFIG['SAVEIMAGES'] == 1) {
                $pic_cam_name = create_cam_name_for_link($camneu['NAME'][$x]);
                $bild = setbildlink(image_id($camneu["PREVIEWURL"][$x]), $pic_cam_name, strtolower(replace_ltext($camneu['DESCRIPTION'][$x])));
                $camneu['PREVIEWURL'][$x] = $CONFIG['PATH']."/".$bild;
            }
            if (isset($camneu['NAME'][$x])) {
                $cam_targeturl64 = createCamTargetUrl64($camneu['ID'][$x]);
                $camneu["CAMLOGIN"][$x] = (($CONFIG['PATH'] == "/") ? "" : $CONFIG['PATH'])."/remoteregister.php?id=".$CONFIG["WMID"]."&amp;targeturl=".$cam_targeturl64."&amp;camid=".$camneu['ID'][$x]."&amp;name=".urlencode($camneu['NAME'][$x]);
            } else {
                $camneu["CAMLOGIN"][$x] = (($CONFIG['PATH'] == "/") ? "" : $CONFIG['PATH'])."/remoteregister.php?id=".$CONFIG["WMID"]."&amp;targeturl=".$targeturl64;
            }
            if ($CONFIG["LIVECAMLAYOUT"] != "") {
                $camneu["CAMLOGIN"][$x] .= "&amp;l=".$CONFIG["LIVECAMLAYOUT"];
            }
			if (isset($CONFIG['HEADER']) && $CONFIG['HEADER'] == 'off') {
                $camneu["CAMLOGIN"][$x] .= "&amp;h=".$CONFIG['HEADER'];
            }
			if (isset($CONFIG['LANGUAGE']) && $CONFIG['LANGUAGE'] != 'de') {
				$camneu["CAMLOGIN"][$x] .= "&amp;language=" . $CONFIG['LANGUAGE'];
			}
            $link_datas = set_cam_link($camneu, $x);
            $camneu['CAMLINK'][$x] = $link_datas['link'];
            $camneu['CAMLINKALT'][$x] = $camneu['NAME'][$x]." - ".$camneu['DESCRIPTION'][$x]." - ".$link_datas['keyword1'].",".$link_datas['keyword1'].",".$link_datas['keyword1'];
        }
    }
}

if (count($camneu) - 1 >= $CONFIG["TOPSENDER_ANZAHL"]) {
    $help_ids = $camneu['ID'];
} else {
    //$help_ids = $cam['ID'];
}
$camtopsender = array();
$min = 0;
$bestgirl = array();
$bestgirl['ID'] = 0;
$bestgirl['GESCHLECHT'] = "maennlich";
$bestgirl['ALTER'] = 99;

if ($topsender == 1) {
    $topsender_ids = getTopsenderIds();
    // myecho($topsender_ids);
    $min = min($CONFIG["TOPSENDER_ANZAHL"], count($topsender_ids));
    unset($help_ids);
    for ($n = 0; $n < $min; $n++) {
        $topsender_id = $topsender_ids[$n];
        $temp_xmlfile = $CONFIG['TEMPDIR'].$topsender_id.".xml";
        if (!file_exists($temp_xmlfile) || time() - filemtime($temp_xmlfile) > 89400) {
            // Datei von mm.777-partners.net holen
            $remotefile = 'https://mm.7-7-7-partner.com/showdetail.php?show='.$topsender_id.'&lang='.$CONFIG['LANGUAGE'].'&size=l';
            $content = get_content($remotefile);
            $fp = fopen($temp_xmlfile, 'w');
            fwrite($fp, $content);
            fclose($fp);
        }
        $cam_info = get_cam_info($topsender_id);
        if (isset($cam_info['CAMID'])) {
            $nummer = count($camtopsender);
            $camtopsender[$nummer] = $cam_info;
            $camtopsender[$nummer]["ID"] = $camtopsender[$nummer]["CAMID"];
            $camtopsender[$nummer]["DESCRIPTION"] = $camtopsender[$nummer]["BESCHREIBUNG"];
            $camtopsender[$nummer]["PREVIEW"][0] = str_replace($mm_search, $mm, $camtopsender[$nummer]["PREVIEW"][0]);
            if ($CONFIG['SAVEIMAGES'] == 1) {
                $pic_cam_name = create_cam_name_for_link($camtopsender[$nummer]['NAME']);
                $pic_shortdescription = create_cam_name_for_link($camtopsender[$nummer]['BESCHREIBUNG']);
                $bilddatei = setbildlink(image_id($camtopsender[$nummer]["PREVIEW"][0]), $pic_cam_name, $pic_shortdescription);
                // myecho($bilddatei);
                $camtopsender[$nummer]['PREVIEWURL'] = $CONFIG['PATH']."/".$bilddatei;
            }
            $cam_targeturl64 = createCamTargetUrl64($camtopsender[$n]['ID']);
            $camtopsender[$nummer]["CAMLOGIN"] = (($CONFIG['PATH'] == "/") ? "" : $CONFIG['PATH'])."/remoteregister.php?id=".$CONFIG["WMID"]."&amp;targeturl=".$cam_targeturl64."&amp;camid=".$camtopsender[$n]['ID']."&amp;name=".urlencode($camtopsender[$n]['NAME']);
            if ($CONFIG["LIVECAMLAYOUT"] != "") {
                $camtopsender[$nummer]["CAMLOGIN"] .= "&amp;l=".$CONFIG["LIVECAMLAYOUT"];
            }
			if (isset($CONFIG['HEADER']) && $CONFIG['HEADER'] == 'off') {
                $camtopsender[$nummer]["CAMLOGIN"] .= "&amp;h=".$CONFIG["HEADER"];
            }
			if (isset($CONFIG['LANGUAGE']) && $CONFIG['LANGUAGE'] != 'de') {
				$camtopsender[$nummer]["CAMLOGIN"] .= "&amp;language=" . $CONFIG['LANGUAGE'];
			}
            $camtopsender[$nummer]["DESC"] = '';
            if (isset($camtopsender[$nummer]["DESCRIPTION"])) {
                $camtopsender[$nummer]["DESC"] = $camtopsender[$nummer]["DESCRIPTION"];
            }
            $helplink = $CONFIG['PATH']."/".implode("/", $CAMLINKZ);
            $camtopsender[$nummer]['CAMLINK'] = $helplink;
            $keyword1 = keyword1($camtopsender[$nummer]['ID']);
            $keyword2 = keyword2($camtopsender[$nummer]['ID']);
            $keyword3 = keyword3($camtopsender[$nummer]['ID']);
            $sk = senderkey($camtopsender[$nummer]['ID']);
            $camtopsender[$nummer]['CAMLINK'] = str_replace("{kategorie}", $kategorie[$CONFIG['STARTKATEGORIE']]["linkname"], $camtopsender[$nummer]['CAMLINK']);
            $camtopsender[$nummer]['CAMLINK'] = str_replace("{id}", $camtopsender[$nummer]["ID"], $camtopsender[$nummer]['CAMLINK']);
            $camtopsender[$nummer]['CAMLINK'] = str_replace("{keyword1}", $keyword1, $camtopsender[$nummer]['CAMLINK']);
            $camtopsender[$nummer]['CAMLINK'] = str_replace("{keyword2}", $keyword2, $camtopsender[$nummer]['CAMLINK']);
            $camtopsender[$nummer]['CAMLINK'] = str_replace("{keyword3}", $keyword3, $camtopsender[$nummer]['CAMLINK']);
            $camtopsender[$nummer]['CAMLINK'] = str_replace("{senderkey}", $sk, $camtopsender[$nummer]['CAMLINK']);
            if (strpos($camtopsender[$nummer]['CAMLINK'], '.php/') !== false) {
                $camtopsender[$nummer]['CAMLINK'] = substr($camtopsender[$nummer]['CAMLINK'], 0, strripos($camtopsender[$nummer]['CAMLINK'], '.php') + 4);
            }
            if (isset($camtopsender[$nummer]["DESCRIPTION"])) {
                //$camtopsender[$nummer]['CAMLINK'] = str_replace("{description}", $pic_description, $camtopsender[$nummer]['CAMLINK']);
                $camtopsender_link_description = substr($camtopsender[$nummer]['DESCRIPTION'], 0, 60);
                $camtopsender_link_description = create_cam_name_for_link($camtopsender_link_description);
            } else {
                $camtopsender_link_description = '';
            }
            $camtopsender[$nummer]['CAMLINK'] = str_replace("{desc}", $camtopsender_link_description, $camtopsender[$nummer]['CAMLINK']);
            $cam_link_name = create_cam_name_for_link($camtopsender[$nummer]['NAME']);
            $camtopsender[$nummer]['CAMLINK'] = str_replace("{name}", $cam_link_name, $camtopsender[$nummer]['CAMLINK']);
            if (isset($camtopsender[$nummer]["DESCRIPTION"])) {
                $camtopsender[$nummer]['CAMLINKALT'] = $camtopsender[$nummer]['NAME']." - ".$camtopsender[$nummer]['DESCRIPTION']." - ".$keyword1.",".$keyword2.",".$keyword3;
            } else {
                $camtopsender[$nummer]['CAMLINKALT'] = $camtopsender[$nummer]['NAME']." - ".$keyword1.",".$keyword2.",".$keyword3;
            }
            if (in_array($camtopsender[$nummer]['ID'], $cam['ID'])) {
                $camtopsender[$nummer]['ONLINE'] = 1;
            }
        } else {
            $min--;
        }
    }
    for ($n = 0; $n < $min; $n++) {
        if ($camtopsender[$n]["GESCHLECHT"] == "weiblich" && $camtopsender[$n]["ALTER"] <= $bestgirl['ALTER'] && $camtopsender[$n]["ALTER"] > 17) {
            $bestgirl['ID'] = $n;
            $bestgirl['GESCHLECHT'] = "weiblich";
            $bestgirl['ALTER'] = $camtopsender[$n]["ALTER"];
        }
    }
}

if (isset($cam["ID"])) {
    for ($n = 0; $n < count($cam["ID"]); $n++) {
        $link_datas = set_cam_link($cam, $n);
        $cam['CAMLINK'][$n] = $link_datas['link'];
        $cam['CAMLINKALT'][$n] = $cam['NAME'][$n]." - ".$cam['DESCRIPTION'][$n]." - ".$link_datas['keyword1'].",".$link_datas['keyword1'].",".$link_datas['keyword1'];
        $cam_targeturl64 = createCamTargetUrl64($cam['ID'][$n]);
        $cam["CAMLOGIN"][$n] = (($CONFIG['PATH'] == "/") ? "" : $CONFIG['PATH'])."/remoteregister.php?id=".$CONFIG["WMID"]."&amp;targeturl=".$cam_targeturl64."&amp;camid=".$cam['ID'][$n]."&amp;name=".urlencode($cam['NAME'][$n]);
        if ($CONFIG["LIVECAMLAYOUT"] != "") {
            $cam["CAMLOGIN"][$n] .= "&amp;l=".$CONFIG["LIVECAMLAYOUT"];
        }
		if (isset($CONFIG['HEADER']) && $CONFIG["HEADER"] == 'off') {
            $cam["CAMLOGIN"][$n] .= "&amp;h=".$CONFIG['HEADER'];
        }
		if (isset($CONFIG['LANGUAGE']) && $CONFIG['LANGUAGE'] != 'de') {
			$cam["CAMLOGIN"][$n] .= "&amp;language=" . $CONFIG['LANGUAGE'];
		}
    }
} else {
    // myecho('$cam[\'\ID\'] ist nicht gesetzt');
}
// myecho('test: '.$catid);
$anzahlseiten = min($anzahlseiten, $CONFIG['MAXSEITEN']);
// myecho($anzahlseiten);
$helplink = $CONFIG['PATH']."/".implode("/", $CATLINKZ);
for ($n = 1; $n <= $anzahlseiten; $n++) {
	// myecho('test: '.$catid);
    $CATLINKCOUNT[$n] = $helplink;
    $keyword1 = keyword1($n);
    $keyword2 = keyword2($n);
    $keyword3 = keyword3($n);
    $sk = senderkey($n);
    $CATLINKCOUNT[$n] = str_replace("{kategorie}", replace_ltext($kategorie[$catid]["linkname"]), $CATLINKCOUNT[$n]);
    $CATLINKCOUNT[$n] = str_replace("{titel}", urlencode(replace_ltext($kategorie[$catid]["titel"])), $CATLINKCOUNT[$n]);
    $CATLINKCOUNT[$n] = str_replace("{seite}", $n, $CATLINKCOUNT[$n]);
    $CATLINKCOUNT[$n] = str_replace("{keyword1}", $keyword1, $CATLINKCOUNT[$n]);
    $CATLINKCOUNT[$n] = str_replace("{keyword2}", $keyword2, $CATLINKCOUNT[$n]);
    $CATLINKCOUNT[$n] = str_replace("{keyword3}", $keyword3, $CATLINKCOUNT[$n]);
    $CATLINKCOUNT[$n] = str_replace("{senderkey}", $sk, $CATLINKCOUNT[$n]);
}

// Fuer jede Kategorie wird ein Link benoetigt:
$CATLINK = array();
$helplink = $CONFIG['PATH']."/".implode("/", $CATLINKZ);
for ($n = 0; $n < count($kategorie); $n++) {
    if (!isset($kategorie[$n]['bezeichnung']) || $kategorie[$n]['bezeichnung'] == "") {
        continue;
    }
    $keyword1 = keyword1($n);
    $keyword2 = keyword2($n);
    $keyword3 = keyword3($n);
    $sk = senderkey($n);
    $CATLINK[$n] = $helplink;
    $CATLINK[$n] = str_replace("{kategorie}", urlencode($kategorie[$n]["linkname"]), $CATLINK[$n]);
    $CATLINK[$n] = str_replace("{titel}", urlencode(replace_ltext($kategorie[$n]["titel"])), $CATLINK[$n]);
    $CATLINK[$n] = str_replace("{seite}", "1", $CATLINK[$n]);
    $CATLINK[$n] = str_replace("{keyword1}", $keyword1, $CATLINK[$n]);
    $CATLINK[$n] = str_replace("{keyword2}", $keyword2, $CATLINK[$n]);
    $CATLINK[$n] = str_replace("{keyword3}", $keyword3, $CATLINK[$n]);
    $CATLINK[$n] = str_replace("{senderkey}", $sk, $CATLINK[$n]);
    // echolink($CATLINK[$n]);
}


// es wurde eine camid ermittelt
if (isset($sid) && strlen(trim($sid)) > 0 && $sid > - 1) {
    // myecho($sid);
    $sender = get_cam_info($sid, 1);
    // die();
    $display_404Error = false;
    // nachsehen ob die Cam ueberhaupt noch angezeigt werden darf
    $cam_s_file = $CONFIG['TEMPDIR']."cam.s";
    if (file_exists($cam_s_file)) {
        $cams_s = unserialize(implode("", file($cam_s_file)));
        // myecho($cams_s);
        // ist die Cam ueberhaupt im System
        if (!isset($cams_s[$sid])) {
            $display_404Error = true;
        }
    } else {
        $display_404Error = true;
    }
    
    // vielleicht steht die Cam in der "liste-".$catid.".s"
    $category_s_file = $CONFIG['TEMPDIR']."liste-".$catid.".s";
    if ($display_404Error && file_exists($category_s_file)) {
        $category_s = unserialize(implode("", file($category_s_file)));
        // myecho($category_s);
        // ist die Cam ueberhaupt im System
        if (in_array($sid, $category_s)) {
            // myecho('gefunden');
            $display_404Error = false;
        }
    }
    // wenn der Sender online ist
    // darf auf jeden Fall die Show angezeigt angezeigt werden
    if ($display_404Error && is_array($sender) && key_exists('ONLINE', $sender)) {
        if ($sender['ONLINE'] == 1) {
            $display_404Error = false;
        }
    }
    // nachsehen ob der Camname in der searchbyshownames.txt steht
    if ($display_404Error) {
        $search_file_name = 'searchbyshownames.txt';
        $search_directory = $CONFIG['SEARCHDIR'];
        $search_file = $search_directory.$search_file_name;
        if (is_file($search_file)) {
            $lines = file($search_file);
            // myecho($lines);
            foreach ($lines as $line) {
                $line = str_replace("\n", '', $line);
                if (strpos($line, '=') !== false) {
                    $data = preg_split("#=#", $line);
                    if (trim($data[1]) == $sid) {
                        $display_404Error = false;
                        break;
                    }
                }
            }
        }
    }
    if (!$display_404Error && count($sender) > 0 && isset($sender['RESULT'])) {
        $display_404Error = true;
    }
    if (!$display_404Error && count($sender) > 0 && (isset($sender['DISPLAY']) && $sender['DISPLAY'] == 0)) {
        //$display_404Error = true;
    }
    if (!$display_404Error && count($sender) > 0 && (isset($sender['DISABLED']) && $sender['DISABLED'] == 1)) {
        $display_404Error = true;
    }
	if ($display_404Error) {
        $xml_file = $CONFIG['TEMPDIR'].$sid.'.xml';
        // Bilder und XML-datei vom Sender loeschen
        if (is_file($xml_file)) {
            $array = xml2array($xml_file);
            if (isset($array['PREVIEW'])) {
                foreach ($array['PREVIEW'] as $preview) {
                    $image_id = image_id($preview);
                    $image_file_name = $image_id.'.jpg';
                    $image_directory = $CONFIG['IMAGEDIR'];
                    $image_file = $image_directory.$image_file_name;
                    if (is_file($image_file)) {
                        unlink($image_file);
                    }
                }
            }
			
            unlink($xml_file);
            unset($array);
        }
		// in die inactivecams.xml eintragen
		addInactiveCam($sid);
		display_404Error($sid);    
    }
} else {
    unset($sid);
}

// myecho($sender);
if (!isset($sid) && (isset($_GET['sid']) && $_GET['sid'] == 1)) {
    if (count($cam["ID"]) > 0) {
        $sid = $cam['ID'][rand(0, count($cam['ID']) - 1)];
        $sender = get_cam_info($sid);
    }
    if ($sender['CAMID'] < 1) {
        $sid = $camall['ID'][rand(0, count($camall['ID']) - 1)];
        $sender = get_cam_info($sid);
    }
}
// Setze die Metadaten
$meta["title"] = $METACAT['TITLE'];
$meta["description"] = $METACAT['DESCRIPTION'];
$meta["keywords"] = $METACAT["KEYWORDS"];

if (isset($sid)) {
    $meta["title"] = $METACAM['TITLE'];
    $meta["description"] = $METACAM['DESCRIPTION'];
    $meta["keywords"] = $METACAM["KEYWORDS"];
    
    // Benoetige noch die Bilder
    $sender["IMAGE"][0] = str_replace("size=l", "size=m", $sender["PREVIEW"][0]);
    $sender["IMAGE"][1] = str_replace("size=l", "size=m", $sender["PREVIEW"][1]);
    $sender["IMAGE"][2] = str_replace("size=l", "size=m", $sender["PREVIEW"][2]);
}

// Ersetze die Variablen in den Meta-Tags:
$senderkeys = array('NAME', 'GESCHLECHT', 'STERNZEICHEN', 'ALTER', 'SEXPREF', 'KOERBCHENGROESSE', 'INTIMRASUR', 'BESCHREIBUNG', 'HOBBIES', 'GROESSE', 'FIGUR', 'HAARFARBE', 'HAARLAENGE', 'HAUTFARBE', 'AUGEN', 'SPRACHEN', 'CHARAKTER', 'EROINTRESSEN');
$msearch = array("{CATNAME}", "{CAT_TITLE}", "{CAT_DESCRIPTION}", "{CAT_KEYWORDS}");
$mreplace = array($catname, $kategorie[$catid]["titel"], $kategorie[$catid]["beschreibung"], $kategorie[$catid]["keywords"]);
foreach ($senderkeys as $senderkey) {
    if (isset($sender[$senderkey])) {
        $msearch[] = '{'.$senderkey.'}';
        $mreplace[] = $sender[$senderkey];
    } else {
        $msearch[] = '{'.$senderkey.'}';
        $mreplace[] = '';
    }
}

$meta["title"] = str_replace($msearch, $mreplace, $meta["title"]);
$meta["description"] = str_replace($msearch, $mreplace, $meta["description"]);
$meta["keywords"] = str_replace($msearch, $mreplace, $meta["keywords"]);

$msearch = array("\n", "\r", "\t", "\"");
$mreplace = array(" ", "", " ", "\\\"");

$meta["title"] = str_replace($msearch, $mreplace, $meta["title"]);
$meta["description"] = str_replace($msearch, $mreplace, $meta["description"]);
$meta["keywords"] = str_replace($msearch, $mreplace, $meta["keywords"]);

if (count($url_teile) > 0) {
    for ($n = 0; $n < 4; $n++) {
        if (isset($url_teile[$n])) {
            $meta["title"] = str_replace("{link".$n."}", $url_teile[$n], $meta["title"]);
            $meta["description"] = str_replace("{link".$n."}", $url_teile[$n], $meta["description"]);
            $meta["keywords"] = str_replace("{link".$n."}", $url_teile[$n], $meta["keywords"]);
        }
    }
}

// Die Seitennavigation betreffend:
$count = 0;
if ($page < 1) {
    $page = 1;
}
if ($page > $anzahlseiten) {
    $page = $anzahlseiten;
}
$page = intval($page);
$count = ($page - 1) * $proseite;
$NEXTPAGE = $BEFOREPAGE = 0;
if ($page < $anzahlseiten) {
    $NEXTPAGE = $page + 1;
}
if ($page > 1) {
    $BEFOREPAGE = $page - 1;
}

// Metatitle um die Seite erweitern damit nicht immer der gleiche Title bei Seiten von Kategorien erscheint
if ($page > 0 && ($page != 1 && $page != $anzahlseiten)) {
    if (!isset($text['page'])) {
        $text['page'] = 'Seite';
    }
    $meta["title"] = $meta["title"].' '.$text['page'].' '.$page;
}

// Array link mit den verschiedenen Links (anmeldung, register, voicecall)
$link = create_link($sender, $targeturl, $targeturl64);

if (!isset($impressum)) {
    $impressum = null;
}
if (!isset($tagcloud)) {
    $tagcloud = null;
}
if (!isset($suche)) {
    $suche = null;
}
if ($speciallink > 0) {
    $$specialname = 1;
}

@ include_once ("individuell.inc.php");
@ include_once ($_SERVER["DOCUMENT_ROOT"].$CONFIG['LAYOUTPATH']."/individuell.inc.php");
@ include_once ($_SERVER["DOCUMENT_ROOT"].$CONFIG['LAYOUTPATH']."/layout.individuell.inc.php");
// in der layout.individuell.inc.php wird die Suche ausgefuehrt, wenn diese fertig koennen die METATAGS zur Suche geschrieben werden
if ($speciallink > 0) {
    if (isset($special_link[$specialname]['TITLE']) && $special_link[$specialname]['TITLE'] != "") {
        $meta['title'] = $special_link[$specialname]['TITLE'];
        if (! empty($suchbegriff)) {
            $meta['title'] .= ' | '.$suchbegriff;
        }
    }
    if (isset($special_link[$specialname]['DESCRIPTION']) && $special_link[$specialname]['DESCRIPTION'] != "") {
        $meta['description'] = $special_link[$specialname]['DESCRIPTION'];
    }
    if (isset($special_link[$specialname]['KEYWORDS']) && $special_link[$specialname]['KEYWORDS'] != "") {
        $meta['keywords'] = $special_link[$specialname]['KEYWORDS'];
        if (! empty($suchbegriff)) {
            $meta['keywords'] .= ', '.$suchbegriff;
        }
    }
}
test_images();

// START EINBINDUNG NEUE FUNKTIONEN
// speziell fuer das layout 777livecams_w3c kann aber auch fuer andere Layouts genutzt werden
// dann muessen aber entsprechende Aenderungen vom Webmaster in der main.php vorgenommen werden
//
// die neuen Variables lauten: $category_text und $metatext
//
// 2015-03-05
$category_text = $metatext = '';

if (isset($sid)) {
	$mydatas = null;
	if(isset($CONFIG['LOAD_MY_SEDCARD_DATAS']) && $CONFIG['LOAD_MY_SEDCARD_DATAS'] == 1){
		$mydatas = loadMySedcardDatas($sid);
		if (!is_null($mydatas)) {
			$sender['SHORTDESCRIPTION'] = (string)$mydatas -> shortdescription;
			$sender['BESCHREIBUNG'] = (string)$mydatas -> description;
			$meta['description'] = (string)$mydatas -> meta_description;
			$meta['keywords'] = (string)$mydatas -> meta_keywords;
			$meta['title'] = (string)$mydatas -> meta_title;
		} else {
			$sender['SHORTDESCRIPTION'] = '';
		}	
	}
	// wenn ein anderer spezieller Text zu einer Show gewuenscht ist
	if (isset($CONFIG['SEDCARD_TEXT']) && $CONFIG['SEDCARD_TEXT'] == 1) {
		if($CONFIG['CAMIDS_FOR_SEDCARD_TEXT'][0] == 'all' || in_array($sid, $CONFIG['CAMIDS_FOR_SEDCARD_TEXT'], true)){
			$sender['BESCHREIBUNG'] = getSedcardText($sid, $text_file_subdirectory = 'sedcard/', $plain = true);
			// myecho($sender['BESCHREIBUNG']);
		}	
	}
} else {
	// camid bzw. sid ist nicht gesetzt Metadata fuer Kategorie 
	// mit eigenen Texten setzen, welche von den definierten $kategorie
	// abweichen koennen
	if (!isset($catid)) {
		$catid = $CONFIG['STARTKATEGORIE'];
	}
	// alle metadaten in einem string wobei die metadata immer gleich sind
	if(isset($CONFIG['CATEGORY_META_AS_STRING']) && $CONFIG['CATEGORY_META_AS_STRING'] > 0){
		// $CONFIG['CATEGORY_META_AS_STRING'] == 1 dann wird ein String ausgegeben
		// ansonsten wird das Array $meta nur angepasst
		$metatext = getMetaAsText($catid, $CONFIG['CATEGORY_META_AS_STRING']);
	}else{
		$meta['page_text'] = $meta['description'];
	}

	if(isset($CONFIG['LOAD_MY_CATEGORY_METAS']) && $CONFIG['LOAD_MY_CATEGORY_METAS'] == 1){
		// metadata wie gehabt in einem Array, fuer jede Seite der Kategorie anders
		$metas = loadMyCategoryMetas($catid, $page);	
		if (isset($metas -> page_text)) {
			$meta['page_text'] = (string)$metas -> page_text;
			$meta['description'] = (string)$metas -> meta_description;
			$meta['title'] = (string)$metas -> meta_title;
			$meta['keywords'] = (string)$metas -> meta_keywords;
			// myecho($meta);
		}	
	}
	
	// wenn ein eigener zufaelliger Kategorietext - page_text - gewuenscht ist
	if (isset($CONFIG['OWN_TEXT_FOR_CATEGORIES']) && $CONFIG['OWN_TEXT_FOR_CATEGORIES'] == 1) {
		if($CONFIG['IDS_FOR_CATEGORIES_WITH_OWN_TEXT'][0] == 'all' || in_array($catid, $CONFIG['IDS_FOR_CATEGORIES_WITH_OWN_TEXT'], true)){
			$meta['page_text'] = getCategoryText($catid);
			// myecho($meta['page_text']);
		}
	} 
}
// ENDE EINBINDUNG NEUE FUNKTIONEN 			2015-03-05

// START AUSGABE zusammen setzen

ob_start();
include_once ($_SERVER["DOCUMENT_ROOT"].$CONFIG['LANGUAGEPATH']);
include_once ($_SERVER["DOCUMENT_ROOT"].$CONFIG['LAYOUTPATH']."/main.php");
$sb = ob_get_contents();
ob_end_clean();
$sticky_link = "";
if ($CONFIG['STICKYSCRIPT'] == 1) {
    $sticky_link = $sticky['script'];
    $sb = str_replace("</body>", $sticky_link."\n</body>", $sb);
}

// spinner einbinden
$spin_inc_file = 'spin_special.inc.php';
if (is_file($spin_inc_file)) {
    include_once ($spin_inc_file);
}

// mobileoverlay
if(isset($CONFIG['MOBILEOVERLAY']) && $CONFIG['MOBILEOVERLAY'] == 1){
	$mobileoverlay_params  = 'lid=98';
	$mobileoverlay_params .= '&amp;stid=mobileoverlay';
	$mobileoverlay_params .= '&amp;l='. $CONFIG['MOBILEOVERLAY_LAYOUT'];
	$mobileoverlay_params .= '&amp;avs='.$CONFIG['MOBILEOVERLAY_AVS_JETZTLIVE'];
	$mobileoverlay_params .= '&amp;id='.$CONFIG['WMID'];
	$mobileoverlay_params .= '&amp;productid='.$CONFIG['MOBILEOVERLAY_PRODUCTID'];
	if($CONFIG['MOBILEOVERLAY_PRODUCTLOGO'] == 0){
		$mobileoverlay_params .= '&amp;h=off';
	}
	$mobilepverlay_product = 'jetztlive.com';
	if($CONFIG['MOBILEOVERLAY_PRODUCTID'] == 6){
		$mobileoverlay_params .= '&amp;bg='.$CONFIG['BACKGROUND_RUF777'];
		$mobileoverlay_params .= '&amp;p='.$CONFIG['PROFILE_RUF777'];
		$mobilepverlay_product = 'ruf777.com';
	}
	$mobileoverlay_script = "
	<!-- start overlaymobile {$mobilepverlay_product} -->
	<script type=\"text/javascript\" src=\"https://mm.777partner.com/?{$mobileoverlay_params}\"> </script>
	<!-- end overlaymobile {$mobilepverlay_product} -->
	";
	$sb = str_replace("</body>", $mobileoverlay_script."\n</body>", $sb);
}

// Im Cache darf das Bild zum Anstossen des Holmechanismuses nicht sein.
$fetch = false;
$bild = $div_fetch_status = '';
$div_style = ' style="min-height:20px;height:auto;padding:5px;background-color:#000;color:#FFF;font-size:12px;font-family:verdana, arial;text-align:left;width:400px;margin:0 auto;"';
$label_style = ' style="float:left;width:200px;text-align:left;margin:0 5px 0 0;"';
$div_fetch_status_style = 'style="z-index:9;position:absolute;left:10px;top:250px;border:1px solid pink;min-height:48px;height:auto;width:410px;text-align:left;"';    

if ($CONFIG['CRONJOB'] == 0) {    
    // die fetch.php nicht immer bei jedem Aufruf geladen wird, setze ich hier eine time_diff
    $time_diff = 1200;
    // datei mit dem Zeitstempel des letzten Update mit der fetch.php
    $last_update_time = 0;
    $timestamp_fetch_file_name = 'timestamp_fetch.txt';
    $directory = $CONFIG['TEMPDIR'];
    $timestamp_fetch_file = $directory.$timestamp_fetch_file_name;
    if (file_exists($timestamp_fetch_file) && filesize($timestamp_fetch_file) > 0) {
        $fp = fopen($timestamp_fetch_file, 'r');
        $last_update_time = trim(str_replace("\n", "", fread($fp, filesize($timestamp_fetch_file))));
        fclose($fp);
    }
    if (!is_numeric($last_update_time)) {
        $last_update_time = 0;
    }
    
    if (isset($CONFIG['DEVELOPMENT']) && $CONFIG['DEVELOPMENT']) {
        $div_fetch_status .= '<div ' . $div_fetch_status_style . '>';
        $div_fetch_status .= '<div '.$div_style.'><label '.$label_style.'>last update at:</label>'.date('Y-m-d G:i:s', $last_update_time).'</div>';
        $next_update_time = time() - $last_update_time;
        if ($next_update_time > $time_diff) {
            $next_update_time = 0;
        } else if ($next_update_time < $time_diff) {
            $next_update_time = $time_diff - $next_update_time;
        }
        $div_fetch_status .= '<div '.$div_style.'><label '.$label_style.'>next update expected:</label>'.date('Y-m-d G:i:s', (time() + $next_update_time)).'</div>';
    }
    if (time() - $last_update_time > $time_diff) {
        // fetch nach der Ausgabe des HTML ausfuehren
        $fetch = true;
        $fetch_file = $CONFIG['PATH'].'/fetch.php?call='.time();
        if (isset($CONFIG['DEVELOPMENT']) && $CONFIG['DEVELOPMENT']) {
            $div_fetch_status .= '<div '.$div_style.'><label '.$label_style.'>File</label>'.$fetch_file.'</div>';
        }
        $bild = '<img src="'.$fetch_file.'" style="width:1px;height:1px;border:0;" alt="" />';
    }
    if (isset($CONFIG['DEVELOPMENT']) && $CONFIG['DEVELOPMENT']) {
        $div_fetch_status .= '</div>';
    }
} else {
    if (isset($CONFIG['DEVELOPMENT']) && $CONFIG['DEVELOPMENT']) {
        $time_diff = 1200;
        // datei mit dem Zeitstempel des letzten Update mit der fetch.php
        $last_update_time = 0;
        $timestamp_fetch_file_name = 'timestamp_fetch.txt';
        $directory = $CONFIG['TEMPDIR'];
        $timestamp_fetch_file = $directory.$timestamp_fetch_file_name;
        if (file_exists($timestamp_fetch_file) && filesize($timestamp_fetch_file) > 0) {
            $fp = fopen($timestamp_fetch_file, 'r');
            $last_update_time = trim(str_replace("\n", "", fread($fp, filesize($timestamp_fetch_file))));
            fclose($fp);
        }
        if (!is_numeric($last_update_time)) {
            $last_update_time = 0;
        }
        $div_fetch_status .= '<div '.$div_fetch_status_style.'>';
        $div_fetch_status .= '<div '.$div_style.'><label '.$label_style.'>last update at:</label>'.date('Y-m-d G:i:s', $last_update_time).'</div>';
        $next_update_time = time() - $last_update_time;
        if ($next_update_time > $time_diff) {
            $next_update_time = 0;
        } else if ($next_update_time < $time_diff) {
            $next_update_time = $time_diff - $next_update_time;
        }
        $div_fetch_status .= '<div '.$div_style.'><label '.$label_style.'>cronjob expected at:</label>'.date('Y-m-d G:i:s', (time() + $next_update_time)).'</div>';
        $div_fetch_status .= '</div>';
    }
}


// Baue das Anmeldefensterscript ein und ersetze im Body-Teil das openchat durch anmeldefenster:
// Suche <body
$bodystrpos = stripos($sb, "<body");
if ($bodystrpos === false) {
    $bodystrpos = 0;
}
if(isset($CONFIG['development']) && $CONFIG['development']){
	$local_mm_server = 'mm.777partner.'.utilities::getActualTLD();
}else{
	$local_mm_server = $CONFIG['MM_SERVER'];
}


// statusbar einbinden
if((isset($_SESSION['DEVELOPMENT']) && $_SESSION['DEVELOPMENT']) || (isset($CONFIG['STATUSBAR']) && $CONFIG['STATUSBAR'] == 1)){
	if(isset($_SESSION['DEVELOPMENT']) && $_SESSION['DEVELOPMENT']){
		$CONFIG['development'] = $_SESSION['DEVELOPMENT'];
	}
	if(isset($CONFIG['STATUSBAR_SCRIPT'])){
		$previewscript = 'https://'.$local_mm_server.'/?'.$CONFIG['STATUSBAR_SCRIPT'];
		$statusbar = '<script src="'.$previewscript.'" type="text/javascript"> </script></body>';
		$sb = str_replace('</body>', $statusbar, $sb);
	}	
}else{
	$CONFIG['development'] = false;	
}

$sb = str_replace("</body>", $bild."\n</body>", $sb);
$sb = str_replace("</body>", '<div class="copy" style="text-align:center">&copy; '.date("Y", time()).' by 777Live / <a href="https://www.777partner.com/?id='.$CONFIG['WMID'].'" target="_blank" class="copy">$$ '.$systemtext['earn_money'].' $$</a>'.$impressum_link.'</div>'."\n<!-- V ".$CONFIG['VERSION']." -->\n</body>", $sb);
if (isset($CONFIG['LOG_TEXT'])) {
    $sb = str_replace("</body>", $CONFIG['LOG_TEXT'].'</body>', $sb);
	unset($CONFIG['LOG_TEXT']);
}
$sb = str_replace("</body>", $div_development.$div_fetch_status.'</body>', $sb);

if (strlen($CONFIG['TEXTE']) > 0) {
    $dateien = lese_textdateien();
    // Gehe alle Dateien durch und ersetze die Wildcards:
    $faktor = $system['faktor'];
    if (count($dateien) > 0) {
        for ($n = 0; $n < count($dateien); $n++) {
            $textsuche = "{".$dateien[$n]."}";
            $directory = $CONFIG['TXTDIR'];
            $text_file_name = $dateien[$n].".txt";
            $text_file = $directory.$text_file_name;
            if (!file_exists($text_file)) {
                $directory = $CONFIG['TXTDIR2'];
            }
            $text_file = $directory.$text_file_name;
            if (is_file($text_file)) {
                $content = trim(file_get_contents($text_file));
                if (!utilities::isUTF8($content)) {
                    // myecho ('TEXT ist nicht UTF8');
                    // HTML_ENTITIES entfernen
                    $content = entities_decode($content);
                    $content = html_entity_decode($content);
                    // Text in UTF-8 encode
                    $content = utilities::__utf8_encode($content);
                    // Datei neu schreiben
                    if (!@file_put_contents($text_file, $content)) {
                        // die Datei konnte nicht geschrieben werden
                        support_mail($directory);
                    }
                }
                $inhalt = file($text_file);
                if ($CONFIG['ZUFALLVERSION'] == 0) {
                    if (count($inhalt) > 0) {
                        if (!isset($sid) || $sid < 1) {
                            $wert = ($catid + 1) * ($page + 1);
                        } else {
                            $wert = $sid * ($catid + 1) * ($page + 1);
                        }
                        $zeile = abs(($faktor * $wert) % (count($inhalt)));
                        $textersatz = trim($inhalt[$zeile]);
                    }
                } elseif ($CONFIG['ZUFALLVERSION'] == 1) {
                    if (count($inhalt) > 0) {
                        $wert = 0;
                        for ($nn = 0; $nn < strlen($_SERVER["REQUEST_URI"]); $nn++) {
                            $wert += ord(substr($_SERVER["REQUEST_URI"], $nn, 1));
                        }
                        $wert += $faktor;
                        $zeile = $wert % (count($inhalt));
                        $textersatz = trim($inhalt[$zeile]);
                    }
                } else {
                    $textersatz = "";
                }
                if (strlen($textersatz) > 0) {
                    $textersatz = entities_decode($textersatz);
                    //$textersatz = html_entity_decode($textersatz);
                }
                $sb = str_replace($textsuche, str_ireplace('&', '&amp;', $textersatz), $sb);
            }
        }
    }
}

if (isset($CONFIG['LONG_TEXTS']) && $CONFIG['LONG_TEXTS'] == 1) {
    $dateien = lese_textdateien();
    if (count($dateien) > 0) {
        for ($n = 0; $n < count($dateien); $n++) {
            $search = "{".$dateien[$n].".txt}";
            $file_name = $dateien[$n].'.txt';
            $text_file = $CONFIG['TXTDIR'].$file_name;
            // myecho($text_file);
            if (file_exists($text_file)) {
                $content = file_get_contents($text_file);
                if (!utilities::isUTF8($content)) {
                    // myecho ('TEXT ist nicht UTF8');
                    // HTML_ENTITIES entfernen
                    $content = entities_decode($content);
                    $content = html_entity_decode($content);
                    // Text in UTF-8 encode
                    $content = utilities::__utf8_encode($content);
                    // Datei neu schreiben
                    if (!@file_put_contents($text_file, $content)) {
                        // die Datei konnte nicht geschrieben werden
                        support_mail($directory);
                    }
                } else {
                    $content = entities_decode($content);
                    $content = html_entity_decode($content);
                }
                $sb = str_replace($search, $content, $sb);
            }
        }
    }
}


// hier ganz unscheinbar die Ausgabe der Seite
// habs gefunden :-)
if (!headers_sent()) {
    header("Content-Type: text/html; charset=utf-8");
    header("HTTP/1.0 200 OK");
}
$sb = str_replace($mm_search, $mm, $sb);
$sb = encoding::fixUTF8($sb);
$time['vorecho'] = microtime_float();
echo $sb;
@flush();
@ob_flush();
$time['nachecho'] = microtime_float();


// Nach der Ausgabe werden noch ein paar zeitintensive Arbeiten erledigt
$shuffle_cams = false;
if (!$fetch) {
    // die Cams in der aktuellen werden neu sortiert, wenn erforderlich
    if (isset($catid) && is_numeric($catid) && $catid > - 1) {
        $xml_file = $CONFIG['TEMPDIR']."kategorie-".$catid.".xml";
        if (is_file($xml_file) && time() - filemtime($xml_file) > ($CONFIG['MINUTESLIVINGCAT'] * 60)) {
            if (!shuffle_cams_by_category_id($catid)) {
                echo('Die Neuanordnung der Cams hat nicht geklappt: shuffle_cams_by_category_id()');
            }
            $shuffle_cams = true;
        }
    }
	// myecho('kein fetch');
}

if (!$shuffle_cams) {
    // myecho('kein shuffle');
}
if ($CONFIG['CRONJOB'] == 0) {
    // myecho('kein cronjob');
}else {
	// myecho('cronjob ist eingerichtet');
}
if (!$fetch && !$shuffle_cams && $CONFIG['CRONJOB'] == 0) {
    $make_searchfile = true;
    if (is_dir($CONFIG['SEARCHDIR'])) {
        $file = 'make_searchfile.tool.php';
        if (is_file($file)) {
            $display_status = false;
            include_once ($file);
        } else {
            $make_searchfile = false;
        }
    } else {
        $make_searchfile = false;
    }
    if (!$make_searchfile) {
       // myecho($file.' wurde nicht ausgefuehrt');
    }
}
// Wenn Cache, dann hier abspeichern.
if ($CONFIG['CACHE'] == 1 && $speciallink != 1) {
    $fp = fopen($cache_file, "w");
    fputs($fp, $sb);
    fclose($fp);
    @chmod($cache_file, 0666);
    // myecho($cache_file);
}

if ($CONFIG['SITEMAP'] == true || $CONFIG['SITEMAP'] == 1) {
    filelist($sb);
}

$lasttime = microtime_float();
$timediff = $lasttime - $time["start"];
$memory_usage = utilities::convert_memory_usage();
savelog("NoCache - Gesamtzeit: ".$timediff." Sekunden");
savelog("NoCache - Speicher:   ".$memory_usage);

if (isset($CONFIG['LOG_TEXT'])) {
    echo($CONFIG['LOG_TEXT']);
}
exit();
?>
