<?php
include_once('basics.inc.php');
?>
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
        <style type="text/css" media="screen">
	        /*<![CDATA[*/
			@import url('https://fonts.googleapis.com/css?family=Amaranth:700');
	        @import url('<?php echo("{$popupdir}styles.css.php?imagepath={$imagepath}"); ?>');	        
	        /* ]]> */
	    </style>
	    <!--[if IE]>
	        <style type="text/css" media="screen">
	        .errortxt {
	        filter:alpha(opacity=80); /* IE */
	        }
	        </style>
	    <![endif]-->
        <script type="text/javascript">
            /*<![CDATA[*/                        
            function validate(){				
				var valid = true;
				var objInputUN = document.getElementById('un');
				var objInputPW = document.getElementById('pw');
				var objErrorbox = document.getElementById('errorbox-login');
				var objP = document.createElement('p');
				objP.className = 'errortxt';
				objP.setAttribute('class', 'errortxt');
				
				var directory = '<?php echo $imagepath_for_javascript?>';
				var bg_img_error = directory + 'input_error.jpg';	
				
                if (objInputUN.value.length == 0) {
                    objP.innerHTML = '<?php echo $text['remotelogin']['error_benutzername']?>';
					objInputUN.style.background = "url(" + bg_img_error +")";              
                    objInputUN.focus();
                    valid = false;
                }
                if (valid && objInputPW.value.length == 0) {
                    objP.innerHTML = '<?php echo $text['remotelogin']['error_email']?>';
                    objInputPW.style.background = "url(" + bg_img_error +")";
                    objInputPW.focus();
                    valid = false;
                }
				if(valid){
					document.formlogin.submit();
					var userAgent = navigator.userAgent;					
					if(strripos(userAgent, 'chrome', true)){
						setTimeout("window.close()", 1000);
					} else {
						window.close();
					}
				}else{
					objErrorbox.innerHTML = '';
					objErrorbox.appendChild(objP);
					return valid;
				}
            }
			// Finds position of last occurrence of a string within another string 
    		function strripos(haystack, needle, offset){
		        var i = -1;
		        haystack = (haystack + '').toLowerCase();
		        needle = (needle + '').toLowerCase();
		        if (offset) {
		            i = (haystack + '').slice(offset).lastIndexOf(needle);
		            // strrpos' offset indicates starting point of range till end,
		            // while lastIndexOf's optional 2nd argument indicates ending point of range from the beginning
		            if (i !== -1) {
		                i += offset;
		            }
		        }
		        else {
		            i = (haystack + '').lastIndexOf(needle);
		        }
		        return i >= 0 ? i : false;
		    }
			// versucht bei Enter im Textfeld das Formular ab zu schicken
			function doSubmit(e){
				var objForm = document.forms.formlogin;
				if(e.keyCode == 13){
					 validate();
				}
			}   
			/* ]]> */
        </script>
		<title>Login</title>
    </head>
    <body>
        <?php
        if ((! isset ($errorcode) || $errorcode > 0))
        {
        ?>
        <form action="https://member.777livecams.com/<?php echo($form['remotelogin_querystring']); ?>" method="post" target="_blank" name="formlogin" id="formlogin" accept-charset="UTF-8">
            <input type="hidden" name="targeturl" value="<?php echo $form['targeturl']?>" />			
			<input type="hidden" name="origin" value="<?php echo $form['origin']?>" />
			<input type="hidden" name="culture" value="<?php echo $form['language']?>" />
			<input type="hidden" name="ref" value="<?php echo $form['ref']?>" />
			<?php
				if(!is_null($CONFIG['CAMID'])){
					echo('<input type="hidden" name="camid" value="'.$CONFIG['CAMID'].'" />');
					echo('<input type="hidden" name="name" value="'. $form['name'] .'" />');
				}
				if(!is_null($CONFIG['SC_ID'])){
					echo('<input type="hidden" name="sc_id" value="'.$CONFIG['SC_ID'].'" />');
				}
				if (!is_null($CONFIG['HEADER'])) {
					echo('<input type="hidden" name="header" value="'.$CONFIG['HEADER'].'" />');
				}
			?>
            <div id="wrapper-login">
                <h1>
                    <?php echo  $text['remotelogin']['head'] ?>
                </h1>
                <h2>
                    <?php echo  $text['remotelogin']['head2'] ?>
                </h2>
                <div id="memberlogin-box">
                    <div class="div_headline">
                        <?php echo  $text['remotelogin']['owndata'] ?>
                    </div>
                    <p>
                        <label for="un">
                            <?php echo  $text['remotelogin']['username'].':' ?>
                        </label>
                        <input name="un" id="un" type="text" value="" size="20" maxlength="50" onkeydown="doSubmit(event);"/>
                    </p>
                    <p>
                        <label for="pw">
                            <?php echo  $text['remotelogin']['password'].':' ?>
                        </label>
                        <input name="pw" type="password" id="pw" value="" size="20" maxlength="50" onkeydown="doSubmit(event);"/>
                    </p>
                    <br clear="all" />
					<div class="div_button" style="height:40px;">
					    <a href="javascript:void(0);" onclick="validate()">
	                         <?php echo  $text['remotelogin']['nowlogin'] ?>
	                    </a>
					</div>
                </div>
                <div id="password-box" >
                    <a href="remotepassword.php<?php echo $form['remotepassword_querystring'] ?>" class="password-button">
                        <?php echo  $text['remotelogin']['passwordforgot'] ?>
                    </a>
                    <div id="errorbox-login">                    	
                    	<?php
                        if ( isset ($errorcode))
                        {
                        	echo('<p class="errortxt">'.$errormsg[$errorcode].'</p>');
						}
                        ?>
                    </div>					
                </div>
				<div class="nodata-button">
					<div>
						<a href="remoteregister.php<?php echo($form['remoteregister_querystring']); ?>" target="_self">
	                        <?php echo  $text['remotelogin']['nologinyet'] ?>
	                    </a>
					</div>
                </div>
            </div>
            <?php
            }
            ?>
        </form>
        <?php
        if ( isset ($counterpixel))
        {
            echo ($counterpixel);
        }
        ?>
    </body>
</html>