<?php
include_once('basics.inc.php');
?>
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
        <style type="text/css" media="screen">
            /*<![CDATA[*/
			@import url('https://fonts.googleapis.com/css?family=Amaranth:700');
            @import url('<?php echo("{$popupdir}styles.css.php?imagepath={$imagepath}"); ?>');
            /* ]]> */
        </style>
        <!--[if IE]>
            <style type="text/css" media="screen">
            .errortxt {
            filter:alpha(opacity=80); /* IE */
            }
            </style>
        <![endif]-->
        <script type="text/javascript">
	        /*<![CDATA[*/
	        function validate(){
	            var valid = true;
				var objInputEmail = document.getElementById('email');
				var objInputCaptcha = document.getElementById('captcha');
				var objInputUser = document.getElementById('user');
				var objErrorbox = document.getElementById('meldung');
				var objP = document.createElement('p');
				objP.className = 'errortxt';
				objP.setAttribute('class', 'errortxt');
				var directory = '<?php echo $imagepath_for_javascript?>';
				var bg_img_input_error = directory + 'input_error.jpg';
	        	var bg_img_captcha = directory + 'capturein_error.jpg';
				
				if (objInputUser.value.length == 0) {
	                objP.innerHTML = '<?php echo $text['remoteregister']['error_user']?>';
					objInputUser.style.background = "url(" + bg_img_input_error + ")";
	                objInputUser.focus();
	                valid = false;
	            }
	            if (valid && objInputEmail.value.length == 0) {
	                objP.innerHTML = '<?php echo $text['remoteregister']['error_email']?>';
					objInputEmail.style.background = "url(" + bg_img_input_error + ")";
	                objInputEmail.focus();
	                valid = false;
	            }
	            if (valid && (objInputCaptcha.value.length < 3 || isNaN(objInputCaptcha.value))) {
	                objP.innerHTML = '<?php echo $text['remoteregister']['error_captchatext']?>';
					objInputCaptcha.style.background = "url(" + bg_img_captcha + ")";
	                objInputCaptcha.focus();
	                valid = false;
	            }
				if(valid){
					document.formregister.submit();
				}else{
					objErrorbox.innerHTML = '';
					objErrorbox.appendChild(objP);
					return valid;
				}	            
	        }
			// versucht bei Enter im Textfeld das Formular ab zu schicken
			function doSubmit(e){
				var objForm = document.forms.formlogin;
				if(e.keyCode == 13){
					 validate();
				}
			}   	        
	        /* ]]> */            	    
        </script>
        <title>Register</title>
    </head>
    <body>
        <?php
        if ((! isset ($errorcode) || $errorcode > 0))
        {
        ?>
        <form action="<?php echo $action['remoteregister']?>" method="post" name="formregister" id="formregister" accept-charset="UTF-8">
            <input type="hidden" name="bid" value="<?php echo $form['bid']?>" />					
			<input type="hidden" name="targeturl" value="<?php echo $form['targeturl']?>" />
			<input type="hidden" name="language" value="<?php echo $form['language']?>" />
			<input type="hidden" name="origin" value="<?php echo $form['origin']?>" />
			<input type="hidden" name="capid" value="<?php echo $form['capid']?>" />
			<input type="hidden" name="layout" value="<?php echo $form['layout']?>" />
			<input type="hidden" name="ref" value="<?php echo $form['ref']?>" />
			<?php
				if(!is_null($CONFIG['CAMID'])){
					echo('<input type="hidden" name="camid" value="'.$CONFIG['CAMID'].'" />');
					echo('<input type="hidden" name="name" value="'. $form['name'] .'" />');
				}
				if(!is_null($CONFIG['SC_ID'])){
					echo('<input type="hidden" name="sc_id" value="'.$CONFIG['SC_ID'].'" />');
				}
				if (!is_null($CONFIG['HEADER'])) {
					echo('<input type="hidden" name="header" value="'.$CONFIG['HEADER'].'" />');
				}
			?>
            <div id="wrapper">
                <h1>
                    <?php echo  $text['remoteregister']['headhead'] ?>
                </h1>
                <h2>
                    <?php echo  $text['remoteregister']['head'] ?>
                </h2>
                <div id="regist-box">
                    <div class="div_headline">
                        <?php echo  $text['remoteregister']['head2'] ?>
                    </div>
                    <p>
                        <label for="user">
                            <?php echo  $text['remoteregister']['username'].':' ?>
                        </label>
                        <input id="user" type="text" name="user" value="" size="20" maxlength="50" onkeydown="doSubmit(event);"/>
                    </p>
                    <p>
                        <label for="email">
                            <?php echo  $text['remoteregister']['email'].':' ?>
                        </label>
                        <input id="email" type="text" name="email" value="" size="20" maxlength="50" onkeydown="doSubmit(event);"/>
                    </p>
                    <label for="captcha">
                        <?php echo  $text['remoteregister']['captchacode'].':' ?>
                    </label>
                    <div id="capture-box">
                        <div class="capture">
                            <img src="<?php echo $action['remotecaptcha']."?id=".$captcha['uniquekey']?>" alt="captcha" />
                        </div><input class="capture-in" id="captcha" type="text" name="captchatext" value="" size="8" maxlength="50" onkeydown="doSubmit(event);"/>
                    </div>
                    <br clear="all" />
					<div class="div_button" style="height:40px;">
					    <a href="javascript:void(0);" onclick="validate()">
	                         <?php echo  $text['remoteregister']['nowregister'] ?>
	                    </a>
					</div>
                    <div id="meldung">
                        <?php
                        if (! isset ($errorcode))
                        {
                        	echo('<p class="registertxt">'.$text['remoteregister']['fastsend'].'</p>');
                        }else{
                        	echo('<p class="errortxt">'.$errormsg[$errorcode].'</p>');
                        }
                        ?>
                    </div>
                </div>
                <div id="login-box">
                    <a href="remotelogin.php<?php echo $form['remoteregister_querystring'] ?>" class="login-button">
                        <?php echo  $text['remoteregister']['havingdata'] ?>
                    </a>
                    <p>
                        <?php echo  $text['remoteregister']['withdatalogin'] ?>
                    </p>
                </div>
                <div id="hinweis">
                    <?php echo  $text['remoteregister']['firsttime'] ?>
                </div>
            </div>
            <?php
            }
            elseif ( isset ($errorcode) && $errorcode == 0)
            {
            ?>
            <div id="wrapper-getpassword">
                <h1>
                    <?php echo  $text['remoteregister']['registersuccess'] ?>
                </h1>
                <h2>&nbsp; </h2>
                <div id="getpassword-box">
                	<div class="div_fieldset" style="margin-top:90px;">
                		<fieldset>
		                    <legend>
		                        <?php echo  $text['remoteregister']['yourregister'] ?>:
		                    </legend>
		                    <p>
	                            <?php echo  $text['remoteregister']['yourregisterlong'] ?>
	                        </p>
		                </fieldset>
		            </div>
                    <div id="getpassword-notiz-box">
                        <p>
                            &nbsp;
                        </p>
						<div class="div_button" style="height:40px;">
						    <a href="javascript:void(0);" onclick="self.close();" target="_self">
		                         <?php echo  $text['remoteregister']['windowclose'] ?>
		                    </a>
						</div>
                    </div>
                </div>
            </div>
            <?php
            }
            elseif ( isset ($errorcode) && $errorcode < 0)
            {
            ?>
            <div id="wrapper-getpassword">
                <h1>
                    <?php echo  $text['remoteregister']['registerproblem'] ?>
                </h1>
                <h2>&nbsp; </h2>
                <div id="getpassword-box" style="margin-top:0;">
                	<div class="div_fieldset">
                		<fieldset>
	                		<legend>
		                        <?php echo $text['remoteregister']['yourregister'] ?>:
		                    </legend>
		                    <p>
	                            <?php echo  $text['remoteregister']['registerproblemlong'] ?>
	                        </p>
	                	</fieldset>      
                	</div>       
                    <div id="getpassword-notiz-box">
						<a href="mailto:support@777live.com?subject=registration%20failed" target="_blank">
                        	<img src="<?php echo urldecode($imagepath) ?>mailetter.gif" alt="Eigenes Passwort anfordern" width="181" height="145" />
                        </a>
                    </div>
                </div>
            </div>
            <?php
            }
            ?>
        </form>
        <?php
        if ( isset ($counterpixel))
        {
            echo ($counterpixel);
        }
        ?>
    </body>
</html>