<?php
include_once('basics.inc.php');
?>
 <!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
        <title><?php echo($text['remotelogin']['nowlogin']); ?></title>
        <style type="text/css" media="all">        
            /*<![CDATA[*/
			@import url('<?php echo($popupdir . 'styles.' . $CONFIG['LANGUAGE']. '.css'); ?>');
			/* ]]> */
        </style>
        <!--[if IE]>
            <style type="text/css" media="screen">
            .errortxt {
            filter:alpha(opacity=80); /* IE */
            }
            </style>
        <![endif]-->
        <script type="text/javascript">
            /*<![CDATA[*/                        
            function validate(){				
				var valid = true;
				var objInputUN = document.getElementById('un');
				var objInputPW = document.getElementById('pw');
				var objErrorbox = document.getElementById('div_error');
				var objP = document.createElement('p');
				objP.className = 'errortxt';
				objP.setAttribute('class', 'errortxt');				
				var directory = '<?php echo($imagepath_for_javascript); ?>';
				var bg_image = 'formbox.png';
				var bg_img_input_error = 'url(' + directory + bg_image + ') 0 -94px';
            	var bg_img_captcha_error = 'url(' + directory + bg_image + ')  -90px -141px';
				var bg_img_input = 'url(' + directory + bg_image + ') 0 0';
            	var bg_img_captcha = 'url(' + directory + bg_image + ') -90px -47px';
				// alert(bg_img_captcha);
                if (objInputUN.value.length == 0) {
                    objP.innerHTML = '<?php echo $text['remotelogin']['error_benutzername']?>';
					objInputUN.style.background = bg_img_input_error;         
                    objInputUN.focus();
                    valid = false;
                }else{
					objInputUN.style.background = bg_img_input;  
				}
				
                if (valid && objInputPW.value.length == 0) {
                    objP.innerHTML = '<?php echo $text['remotelogin']['error_password']?>';
                    objInputPW.style.background = bg_img_input_error;     
                    objInputPW.focus();
                    valid = false;
                }else {
					objInputPW.style.background = bg_img_input; 
				}
				if(valid){
					document.formlogin.submit();
					var userAgent = navigator.userAgent;					
					if(strripos(userAgent, 'chrome', true)){
						setTimeout("window.close()", 1000);
					} else {
						window.close();
					}
				}else{
					//objErrorbox.innerHTML = '';
					document.getElementById('div_errorbox_text').innerHTML = '';
					document.getElementById('div_errorbox_text').appendChild(objP);
					objErrorbox.style.display = 'block';
					return valid;
				}
            }
			// Finds position of last occurrence of a string within another string 
    		function strripos(haystack, needle, offset){
		        var i = -1;
		        haystack = (haystack + '').toLowerCase();
		        needle = (needle + '').toLowerCase();
		        if (offset) {
		            i = (haystack + '').slice(offset).lastIndexOf(needle);
		            // strrpos' offset indicates starting point of range till end,
		            // while lastIndexOf's optional 2nd argument indicates ending point of range from the beginning
		            if (i !== -1) {
		                i += offset;
		            }
		        }
		        else {
		            i = (haystack + '').lastIndexOf(needle);
		        }
		        return i >= 0 ? i : false;
		    }
			// versucht bei Enter im Textfeld das Formular ab zu schicken
			function doSubmit(e){
				var objForm = document.forms.formlogin;
				if(e.keyCode == 13){
					 validate();
				}
			}   
			/* ]]> */
        </script>
    </head>
    <body>
        <!-- Start Wrapper -->
        <div class="div_wrapper">
            <div class="div_errorbox" id="div_error" <?php echo($style_div_errorbox); ?> >
                <div id="div_errorbox_text">
                    <p>
                        <?php echo($error); ?>
                    </p>
                </div>
                <div>
                    <input type="button" onclick="document.getElementById('div_error').style.display = 'none';" value="<?php echo($text['remoteregister']['close']); ?>" />
                </div>
            </div>
            <div class="headline-login">
                <span><?php echo($text['remotelogin']['member_login']); ?></span>
            </div>
            <div class="subheadline-login">
                <span><?php echo($text['remoteregister']['login_with_own_data']); ?></span>
            </div>
            <!-- <a href="close window" class="close"><span><?php echo($text['remotepassword']['windowclose'] ); ?></span></a> --><!-- Start formbox -->
            <form action="https://member.777livecams.com/<?php echo($form['remotelogin_querystring'] ); ?>" method="post" target="_blank" name="formlogin" id="formlogin" accept-charset="UTF-8">
                <input type="hidden" name="targeturl" value="<?php echo $form['targeturl']?>" />			
				<input type="hidden" name="origin" value="<?php echo $form['origin']?>" />
				<input type="hidden" name="culture" value="<?php echo $form['language']?>" />
				<input type="hidden" name="ref" value="<?php echo $form['ref']?>" />
				<?php
					if(!is_null($CONFIG['CAMID'])){
						echo('<input type="hidden" name="camid" value="'.$CONFIG['CAMID'].'" />');
						echo('<input type="hidden" name="name" value="'. $form['name'] .'" />');
					}
					if(!is_null($CONFIG['SC_ID'])){
						echo('<input type="hidden" name="sc_id" value="'.$CONFIG['SC_ID'].'" />');
					}
					if (!is_null($CONFIG['HEADER'])) {
						echo('<input type="hidden" name="header" value="'.$CONFIG['HEADER'].'" />');
					}
				?>
				<div class="div_formbox">
                    <div>
                        <label for="un">
                            <?php echo($text['remoteregister']['username'].':'); ?>
                        </label>
                        <input name="un" type="text" id="un" value="" size="20" maxlength="50" onkeydown="doSubmit(event);"/>
                    </div>
                    <div>
                        <label for="pw">
                            <?php echo($text['remotelogin']['password'].':'); ?>
                        </label>
                        <input name="pw" type="password" id="pw" value="" size="20" maxlength="50" onkeydown="doSubmit(event);"/>
                    </div>
                    <br class="br_clear"/>
                    <div class="div_login_submit">
                        <input type="button" onclick="validate();" onmouseover="this.style.background='url(<?php echo($popupdir); ?>images/<?php echo($CONFIG['LANGUAGE']); ?>/buttons.png) -199px -49px';" onmouseout="this.style.background='url(<?php echo($popupdir); ?>images/<?php echo($CONFIG['LANGUAGE']); ?>/buttons.png) -199px -0px'" value="&nbsp;" />
                    </div><a href="remotepassword.php<?php echo($form['remotepassword_querystring']); ?>" target="_self" class="a_password">
                        <?php echo($text['remotelogin']['lost_password']); ?>
                    </a>
                </div>
            </form>
            <!-- Ende formbox --><!-- Start Footer -->
            <div class="div_footer">
                <div style="height:30px">
                    <a href="remoteregister.php<?php echo($form['remoteregister_querystring']); ?>"  target="_self" title="<?php echo($text['remotepassword']['newregister']); ?>" class="a_register"><span><?php echo($text['remotepassword']['newregister']); ?></span></a>
                </div>
                <div>
                    <a href="remoteregister.php<?php echo($form['remoteregister_querystring']); ?>"  target="_self"  title="<?php echo($text['remotepassword']['newregister']); ?>" class="a_50coins"><span><?php echo($text['remotepassword']['newregister']); ?></span></a>
                </div>
                <div class="div_textbox_2">
                    <h1><?php echo($text['remotelogin']['you_havent_no_entrance_data']); ?> </h1>
                </div>
                <!-- Ende Footer -->
            </div>
            <!-- Ende Wrapper -->
			<?php
	        if ( isset ($counterpixel))
	        {
	            $_SESSION['cid_refresh'] = time();
				echo ($counterpixel);
	        }
	        ?>
        </div>
		
    </body>
</html>
