<?php
include_once('basics.inc.php');
?>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
        <title><?php echo($text['remotelogin']['nowlogin']); ?></title>
        <style type="text/css" media="all">        
            /*<![CDATA[*/
			@import url('<?php echo($popupdir); ?>styles.css');
			@import url('<?php echo($popupdir); ?>bgimages.<?php echo($CONFIG['LANGUAGE']); ?>.css');
            /* ]]> */
        </style>
        <!--[if IE]>
            <style type="text/css" media="screen">
            .errortxt {
            filter:alpha(opacity=80); /* IE */
            }
            </style>
        <![endif]-->
        <script type="text/javascript">
	        /*<![CDATA[*/
	        function validate(){
	            var valid = true;
				var objInputUN = document.getElementById('un');
				var objInputPW = document.getElementById('pw');
				var objErrorbox = document.getElementById('div_error');
				var objP = document.createElement('p');
				objP.className = 'errortxt';
				objP.setAttribute('class', 'errortxt');
				var directory = '<?php echo($imagepath_for_javascript); ?>';
				var bg_image = 'input.png';
				var bg_img_input_error = 'url(' + directory + bg_image + ') 0 -174px';
            	var bg_img_captcha_error = 'url(' + directory + bg_image + ') -100px -271px';
				var bg_img_input = 'url(' + directory + bg_image + ') 0 0';
            	var bg_img_captcha = 'url(' + directory + bg_image + ') -100px -99px';
				
				// alert(bg_img_captcha);
                if (objInputUN.value.length == 0) {
                    objP.innerHTML = '<?php echo $text['remotelogin']['error_benutzername']?>';
					objInputUN.style.background = bg_img_input_error;         
                    objInputUN.focus();
                    valid = false;
                }else{
					objInputUN.style.background = bg_img_input;  
				}
				
                if (valid && objInputPW.value.length == 0) {
                    objP.innerHTML = '<?php echo $text['remotelogin']['error_password']?>';
                    objInputPW.style.background = bg_img_input_error;     
                    objInputPW.focus();
                    valid = false;
                }else {
					objInputPW.style.background = bg_img_input; 
				}
				if(valid){
					document.formlogin.submit();
					var userAgent = navigator.userAgent;					
					if(strripos(userAgent, 'chrome', true)){
						setTimeout("window.close()", 1000);
					} else {
						window.close();
					}
				}else{
					//objErrorbox.innerHTML = '';
					document.getElementById('div_errorbox_text').innerHTML = '';
					document.getElementById('div_errorbox_text').appendChild(objP);
					objErrorbox.style.display = 'block';
					return valid;
				}
            }
			// Finds position of last occurrence of a string within another string 
    		function strripos(haystack, needle, offset){
		        var i = -1;
		        haystack = (haystack + '').toLowerCase();
		        needle = (needle + '').toLowerCase();
		        if (offset) {
		            i = (haystack + '').slice(offset).lastIndexOf(needle);
		            // strrpos' offset indicates starting point of range till end,
		            // while lastIndexOf's optional 2nd argument indicates ending point of range from the beginning
		            if (i !== -1) {
		                i += offset;
		            }
		        }
		        else {
		            i = (haystack + '').lastIndexOf(needle);
		        }
		        return i >= 0 ? i : false;
		    }
			// versucht bei Enter im Textfeld das Formular ab zu schicken
			function doSubmit(e){
				var objForm = document.forms.formlogin;
				if(e.keyCode == 13){
					 validate();
				}
			}  	        
	        /* ]]> */                    
        </script>
    </head>
    <body>
        <!-- Start Wrapper -->
        <div class="div_wrapper_dark">
        	 <div class="div_errorbox" id="div_error" <?php echo($style_div_errorbox); ?> >
                <div id="div_errorbox_text">
                    <p>
                        <?php echo($error); ?>
                    </p>
                </div>
                <div>
                    <input type="button" onclick="document.getElementById('div_error').style.display = 'none';" value="<?php echo($text['remoteregister']['close']); ?>" />
                </div>
            </div>
            <div class="div_headline02">
                <span><?php echo($text['remotelogin']['member_login_1']); ?></span>
            </div>
            <div class="div_subheadline">
                <?php echo($text['remotelogin']['yout_login_data']); ?>
            </div>
            <div class="div_siegel">
                <span><?php echo($text['remoteregister']['Trustet LiveSex - GUARANTEE']); ?></span>
            </div>
			<!-- Start formbox -->
            <form action="https://member.777livecams.com/<?php echo($form['remotelogin_querystring'] ); ?>" method="post" target="_blank" name="formlogin" id="formlogin" accept-charset="UTF-8">
                <input type="hidden" name="targeturl" value="<?php echo $form['targeturl']?>" />
				<input type="hidden" name="origin" value="<?php echo $form['origin']?>" />
				<input type="hidden" name="culture" value="<?php echo $form['language']?>" />
				<input type="hidden" name="ref" value="<?php echo $form['ref']?>" />
				<?php
					if(!is_null($CONFIG['CAMID'])){
						echo('<input type="hidden" name="camid" value="'.$CONFIG['CAMID'].'" />');
						echo('<input type="hidden" name="name" value="'. $form['name'] .'" />');
					}
					if(!is_null($CONFIG['SC_ID'])){
						echo('<input type="hidden" name="sc_id" value="'.$CONFIG['SC_ID'].'" />');
					}
					if (!is_null($CONFIG['HEADER'])) {
						echo('<input type="hidden" name="header" value="'.$CONFIG['HEADER'].'" />');
					}
				?>
                <div class="div_formbox">
                    <p>
                        <label for="un">
                            <?php echo($text['remoteregister']['username'].':'); ?>
                        </label>
                        <input name="un" type="text" id="un" value="" size="20" maxlength="50" onkeydown="doSubmit(event);"/>
                    </p>
                    <p>
                        <label for="pw">
                            <?php echo($text['remotelogin']['password'].':'); ?>
                        </label>
                        <input name="pw" type="password" id="pw" value="" size="20" maxlength="50" onkeydown="doSubmit(event);"/>
                    </p>
                    <br class="br_clear"/>
                    <div class="div_login_submit">
                        <input type="button" onclick="validate();" onmouseover="this.style.background='url(<?php echo($popupdir); ?>images/<?php echo($CONFIG['LANGUAGE']); ?>/button.png) 0 -186px';" onmouseout="this.style.background='url(<?php echo($popupdir); ?>images/<?php echo($CONFIG['LANGUAGE']); ?>/button.png) 0 -129px'" value="&nbsp;" />
                    </div><a href="remotepassword.php<?php echo($form['remotepassword_querystring']); ?>" target="_self" title="<?php echo($text['remotelogin']['lost_password']); ?>" class="a_password"><span><?php echo($text['remotelogin']['lost_password']); ?></span></a>
                </div>
            </form>
			<!-- end formbox -->
            <div class="div_rightbg_light">
                <div class="div_righthl">
                   <?php echo($text['remotelogin']['no_entrance_data']); ?>
                </div>
                <a href="remoteregister.php<?php echo($form['remoteregister_querystring']); ?>" target="_self" title="<?php echo($text['remotelogin']['free_register']); ?>" class="a_right_regist_button"><span><?php echo($text['remotelogin']['register_now']); ?></span></a>
                <div class="div_rightsubhl">
                    <?php echo($text['remotelogin']['free_register']); ?>
                    <br/>
                    <?php echo($text['remotelogin']['50_coins_gift']); ?>
                </div>
            </div>
            <!-- Ende Wrapper -->
        </div>
    </body>
</html>
